/**
 * Scripts
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
;(function( $ ) {
	
	"use strict";

$(document).ready(function(){

	/* Rw Sidebar
	------------------------------------------------*/
	$('.rw-sidebar').rw_Sidebar();
	
	/* Main menus
	------------------------------------------------*/
	$('#the-main-menu').smk_Menu({
		breakpoint:  960
	});
	$('#the-user-menu').smk_Menu({
		// responsive: false,
		subMenuMarkText: false,
		breakpoint:  480
	});

	/* Smk Accordion Init
	------------------------------------------------*/
	$(".jquery_accordion").smk_Accordion();

	/* Smk Visual Select Init
	------------------------------------------------*/
	$('.visual-select').smk_VisualSelect();

	/* Carousel
	------------------------------------------------*/
	$(".carousel-posts").owlCarousel({
		items: 3,
		paginationSpeed: 300,
		rewindSpeed: 400
	});
	$('.carousel-posts-nav-prev').on('click', function(){
		$(this).parents('.grid-container').find('.carousel-posts').trigger('owl.prev');
	});
	$('.carousel-posts-nav-next').on('click', function(){
		$(this).parents('.grid-container').find('.carousel-posts').trigger('owl.next');;
	});

	/* Home Carousel
	------------------------------------------------*/
	$(".home-carousel-posts.show-3-items").owlCarousel({
		items: 3,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-4-items").owlCarousel({
		items: 4,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-5-items").owlCarousel({
		items: 5,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-6-items").owlCarousel({
		items: 6,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-7-items").owlCarousel({
		items: 7,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-8-items").owlCarousel({
		items: 8,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-9-items").owlCarousel({
		items: 9,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$(".home-carousel-posts.show-10-items").owlCarousel({
		items: 10,
		paginationSpeed: 300,
		rewindSpeed: 400
	});

	$('.carousel-posts-nav-prev').on('click', function(){
		$(this).parents('.grid-container').find('.home-carousel-posts').trigger('owl.prev');
	});
	$('.carousel-posts-nav-next').on('click', function(){
		$(this).parents('.grid-container').find('.home-carousel-posts').trigger('owl.next');;
	});

	$('.big-featured-recipes-slider').each( function(index, elem) {
		var $carousel = $(elem);

		$carousel.owlCarousel({
			singleItem: true,
			paginationSpeed: 500,
			rewindSpeed: 500,
			navigation: true,
			autoPlay : $carousel.data("autoplay"),
			navigationText : [ '<span class="fa fa-chevron-left"><span>', '<span class="fa fa-chevron-right"></span>' ],
		});
	});

	/* Generate random string
	------------------------------------------------*/
	var smk_theme_generate_string = function(_nr, _underscore){
		
		var possible_letters = "abcdefghijklmnopqrstuvwxyz",
			possible_nr = "0123456789",
			possible_all = "abcdefghijklmnopqrstuvwxyz0123456789",
			_new_nr, text="", text1="", text2="", text3="";

		if( _nr < 4 ) _nr = 4;

		if( _underscore ){
			_new_nr = parseInt(_nr, 10) - 2;
			for( var i=0; i < 2; i++ ){
				text1 += possible_letters.charAt(Math.floor(Math.random() * possible_letters.length));
			}
			if( _new_nr > 3 ){
				_new_nr = _new_nr - 3;
				for( var i=0; i < _new_nr; i++ ){
					text2 += possible_all.charAt(Math.floor(Math.random() * possible_all.length));
				}
				for( var i=0; i < 3; i++ ){
					text3 += possible_nr.charAt(Math.floor(Math.random() * possible_nr.length));
				}
			}
			else{
				for( var i=0; i < _new_nr; i++ ){
					text2 += possible_all.charAt(Math.floor(Math.random() * possible_all.length));
				}
			}
			
			text = text1 +'_'+ text2 + text3;
		}
		else{
			for( var i=0; i < _nr; i++ ){
				text += possible_all.charAt(Math.floor(Math.random() * possible_all.length));
			}
		}
		

		return text;
	}
	
	/* qTip Init
	------------------------------------------------*/
	function smk_theme_tooltip(){
		$('.rw-layout a[title], .smk_theme_tooltip').qtip({
			position: {
				my: 'bottom center',
				at: 'top center',
			},
			style: {
				classes: 'qtip-tipsy qtip-shadow',
			},
			hide: {
				event: 'click mouseleave'
			}
		});
	}
	smk_theme_tooltip();

	/* qTip Init for comment form allowed tags
	------------------------------------------------*/
	$('.post-author-tooltip').each(function() {
		$(this).qtip({
			content: {
				text: $('.post-author-tooltip-block')
			},
			position: {
				my: 'left center',
				at: 'right center',
			},
			style: {
				classes: 'qtip-tipsy qtip-rounded',
			},
			hide: {
				event: 'click mouseleave'
			}
		});
	});

	/* qTip Init for comment form allowed tags
	------------------------------------------------*/
	$('.comment-form-question').each(function() {
		$(this).qtip({
			content: {
				title: $('.form-allowed-tags .ftg-title'),
				text: $('.form-allowed-tags')
			},
			position: {
				my: 'bottom center',
				at: 'top center',
			},
			style: {
				classes: 'qtip-tipsy qtip-rounded',
			},
			hide: {
				event: 'click mouseleave'
			}
		});
	});

	/* Main menu sticky
	------------------------------------------------*/
	$(window).scroll(function () {
		if ($(this).scrollTop() > 200) {
			$('.rw-header.mod-fixed-header').addClass("header-fixed");
		} else {
			$('.rw-header.mod-fixed-header').removeClass("header-fixed");
		}
		if ($(this).scrollTop() > 300) {
			$('.rw-header.mod-fixed-header').addClass("header-fixed-show");
		} else {
			$('.rw-header.mod-fixed-header').removeClass("header-fixed-show");
		}
	});

	/* Tag index filter
	------------------------------------------------*/
	function smk_theme_keyword_index_filter(elem) {
		var value    = $(elem).val().toLowerCase(),
		    headings = $('.keywords-index-list h4');

		// Hide or show headings
		value.length > 0 ? headings.hide() : headings.show();

		// Hide or show keywords
		$(".keywords-index-list li").each(function() {
			$(this).text().toLowerCase().search(value) > -1 ? $(this).removeClass('hide-keyword') : $(this).addClass('hide-keyword');
		});
	}
	$('.keywords-filter-block .filter-keywords').on( 'keyup', function(){
		smk_theme_keyword_index_filter(this);
	});

	$('.keywords-filter-block .filter-controls').on( 'click', '.control', function(){
		$(this).parent().children('.control').removeClass('active');
		$(this).addClass('active');
		if( $(this).hasClass('block') ){
			$('.keywords-index-list').addClass('display-block');
		}
		else{
			$('.keywords-index-list').removeClass('display-block');
		}
	});

	/* Mark recipe ingredient on single recipe page
	------------------------------------------------*/
	$('.single-recipe-ingredients li').on( 'click', function(){
		$(this).toggleClass('active');
	});

	/* Submission ingredients manage
	------------------------------------------------*/
	$('.submission-form-repeatable').smk_Accordion({
		showIcon: false,
		closeAble: true
	});

	// Live update title and label on typing 
	function smk_theme_submission_form_livetext( field, section ){
		$( '.submission-form-repeatable' ).on( 'keyup change', field, function(){
			var thisval = $(this).val();
			$(this).parents('.accordion_in').find( section ).text( thisval );
		});
	}
	smk_theme_submission_form_livetext('.this-section-title-field', '.section-title');
	smk_theme_submission_form_livetext('.this-section-label-field', '.section-label');
	smk_theme_submission_form_livetext('.this-section-measure-field', '.section-measure');

	// Delete section
	$('.submission-form-repeatable').on( 'click', '.delete-section', function( event ){
		event.preventDefault();
		var lists = $(this).parents('.submission-form-repeatable').children(); 
		if( lists.length > 2 ){
			$(this).parents('.accordion_in').slideUp(150, false, function(){
				$(this).remove();
			});
		}
	});

	// Add new section
	$('.submission-form-repeatable-add-new').on( 'click', function(){
		var array_key = smk_theme_generate_string( 5, false),
		    the_ul    = $(this).prev('.submission-form-repeatable'),
		    cloned    = $(the_ul).find('.sfa-noindex').clone();
		
		$( the_ul ).children().removeClass('acc_active');
		$( the_ul ).find('.acc_content').slideUp(150);
		$( the_ul ).append( cloned.hide().addClass('acc_active') );
		cloned.children('.acc_content').show();
		cloned.slideDown(150);
		cloned.removeClass('sfa-noindex');
		cloned.find('input, select').each(function(){
			// Update the 'rules[0]' part of the name attribute to contain the latest count 
			$(this).attr( 'name', $(this).attr( 'name' ).replace( '__noindex__', array_key ) );
		});
	});

	/* Profile user tabs
	------------------------------------------------*/
	function smk_theme_profile_user_tabs(){
		$('.profile-mini-menu li:not(.link) a').on('click', function(event){
			event.preventDefault();
			var theid = $(this).attr('href');

			// The menu
			$('.profile-mini-menu li:not(.link)').removeClass('active');
			$(this).parent().addClass('active');

			//The tabs
			$('.profile-user-tab').removeClass('active');
			$(theid).addClass('active');
		});
	}
	smk_theme_profile_user_tabs();

	/* Recipes info
	------------------------------------------------*/
	$('.recipe .recipe-info-pointer').on({
		'mouseenter': function(){
			$(this).next().addClass('active');
			$(this).prev().addClass('inactive');
		},
		'mouseleave': function(){
			$(this).prev().removeClass('inactive');
			$(this).next().removeClass('active');
		}
	});

	/* Jump to the top
	------------------------------------------------*/
	function smk_theme_jump_to_it( _selector, _speed ){
		
		_speed = parseInt(_speed, 10) === _speed ? _speed : 300;

		$( _selector ).on('click', function(event){
			event.preventDefault();
			var url = $(this).attr('href'); //cache the url.

			// Animate the jump
			$("html, body").animate({ 
				scrollTop: parseInt( $(url).offset().top ) - 50
			}, _speed);

		});
	}
	smk_theme_jump_to_it( '.footer-to-top', 500);

	/* Add CSS class to comment form button
	------------------------------------------------*/
	$('.comment-respond input[type=submit]').addClass('button primary');


	/* AJAX
	------------------------------------------------*/
	
	function smk_theme_follow_user(){
		$('.follow-user').on( 'click', function(event){
			event.preventDefault();
			var btn = $(this),
			    user_id = btn.data('id');

			if( btn.hasClass('not-allowed') ) return true; // If this does not require ajax, because user can't follow

			btn.addClass('loading');	
			$.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				data: {
					"action": "follow_user",
					"usertofollow": user_id,
				},

				success: function(response){
					console.log(response);
					btn.removeClass('loading');
					if( response == 'followed' ){
						btn.removeClass('blue').addClass('active current green');
						btn.find('.text').text('Following');
						btn.find('.fa').removeClass('fa-plus').addClass('fa-check');
					}
					else if( response == 'unfollowed' ){
						btn.removeClass('green active current').addClass('blue');
						btn.find('.text').text('Follow');
						btn.find('.fa').removeClass('fa-check').addClass('fa-plus');
					}
				},
				complete: function( jqXHR, textStatus ){
					// console.log(jqXHR);
					// console.log(textStatus);
				}
			});

		});
	}
	smk_theme_follow_user();

	function smk_theme_send_private_message_delete(){
		$( ".private-messages-single" ).on( "click", '.msg-delete', function( event ) {
			// event.preventDefault();
			var _message_id = $(this).data('id'),
			    _post_id = $(this).data('post'),
			    _msg = $(this).parents('.single-message');
			console.log(this);
			console.log(_message_id);
			console.log(_post_id);
			console.log(_msg);
			if( _message_id && _post_id ){
				_msg.css('opacity', 0.5);
				jQuery.ajax({
					type: "POST",
					url: themeAjax.ajax_url,
					data: {
						'action': 'smk_private_messages_delete_msg_ajax_handler',
						'message_id': _message_id,
						'post_id': _post_id
					},
					success: function(response){
						if( response == -1 || response == 0 ) {// If ajax error
							_msg.css('opacity', '');
							return;
						}
						$('.private-messages-single').html( response );
						smk_theme_tooltip();
					},
					// complete: function(){}
				});//ajax
			}
		});
	}
	smk_theme_send_private_message_delete();

	function smk_theme_send_private_message(){
		$('.private-messaging-form .response-message').on('click', function(){
			$(this).slideUp(150);
		});

		$(document).on("keydown", ".private-messaging-form textarea", function(e){
			if ((e.keyCode == 10 || e.keyCode == 13) && e.ctrlKey){
				$( ".private-messaging-form" ).submit();
			}
		});

		$( ".private-messaging-form" ).on( "submit", function( event ) {
			event.preventDefault();
			var _form = $( this ),
			    _response_msg = _form.find('.response-message'),
			    _form_data = _form.serialize(),
			    _btn = _form.find('.private-messaging-button');

			// console.log( _form );
			_response_msg.slideUp(150);
			_btn.addClass('loading');

			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				data: {
					'action': 'smk_private_messages_form_ajax_handler',
					'data':   { form_data: _form_data }
				},
				success: function(response){
					if( response == -1 || response == 0 ) {
						return;// If ajax error
					}
					else if( parseInt( response ) == response ){
						if( 100 == response ){
							_response_msg.html('<div class="notification red">' + themeAjax.msg100 + '</div>').slideDown(150);
						}
						else if(  101 == response ){
							_response_msg.html('<div class="notification red">' + themeAjax.msg101 + '</div>').slideDown(150);
						}
						else if(  102 == response ){
							_response_msg.html('<div class="notification green">' + themeAjax.msg102 + '</div>').slideDown(150);
							_form.find('textarea').val('');// Reset textarea
						}
						else if(  103 == response ){
							_response_msg.html('<div class="notification red">' + themeAjax.msg103 + '</div>').slideDown(150);
						}
					}
					else{
						$('.private-messages-single').html( response );
						smk_theme_tooltip();
						_form.find('textarea').val('');// Reset textarea
						smk_theme_send_private_message_delete();
					}
				},
				complete: function(){
					_btn.removeClass('loading');
				}
			});//ajax
		});
	}
	smk_theme_send_private_message();

	function smk_theme_message_mark_as_important(){
		$( ".pm-mark-as-important" ).on( "click", function( event ) {
			event.preventDefault();
			var _this = $(this),
			    _td_row = _this.parents('.td-row'),
			    _post_id = $(this).data('post');

			if( _post_id ){
				$(_td_row).css('opacity', 0.5);
				jQuery.ajax({
					type: "POST",
					url: themeAjax.ajax_url,
					data: {
						'action': 'smk_private_messages_mark_as_important_ajax_handler',
						'post_id': _post_id
					},
					success: function(response){
						$(_td_row).css('opacity', '');
						if( response == -1 || response == 0 ) {// If ajax error
							return;
						}
						else if( response == 'marked' ){
							_this.addClass('active').html('<i class="fa fa-check-circle"></i>');
						}
						else if( response == 'unmarked' ){
							_this.removeClass('active').html('<i class="fa fa-circle-o"></i>');
						}
					},
					// complete: function(){}
				});//ajax
			}
		});
	}
	smk_theme_message_mark_as_important();

	function smk_theme_login_form(){

		// Prepare form on page ready
		$( ".smk-theme-login-block .fr-log-y" ).show();
		$( ".smk-theme-login-block .fr-reg-y:not(.fr-log-y), .smk-theme-login-block .fr-rec-y" ).hide();

		var _form_type = $('.smk-theme-login-block .smk-login-form-type');

		// Show form type
		$( ".smk-theme-login-block-type" ).on( "click", 'span', function( event ) {
			event.preventDefault();
			
			if( ! $(this).hasClass('active') ){
				$( ".smk-theme-login-block-type span" ).removeClass('active');
				$(this).addClass('active');
				$('.form-message-response').slideUp(150);

				if( $(this).hasClass('type-login') ){
					$( ".smk-theme-login-block .fr-reg-y:not(.fr-log-y), .smk-theme-login-block .fr-rec-y" ).slideUp(150);
					$( ".smk-theme-login-block .fr-log-y" ).slideDown(150);
					_form_type.val('log');
				}
				else if( $(this).hasClass('type-register') ){
					$( ".smk-theme-login-block .fr-log-y:not(.fr-reg-y), .smk-theme-login-block .fr-rec-y" ).slideUp(150);
					$( ".smk-theme-login-block .fr-reg-y" ).slideDown(150);
					_form_type.val('reg');
				}
				else if( $(this).hasClass('type-recover') ){
					$( ".smk-theme-login-block .fr-reg-y, .smk-theme-login-block .fr-log-y" ).slideUp(150);
					$( ".smk-theme-login-block .fr-rec-y" ).slideDown(150);
					_form_type.val('rec');
				}
			}

		});

		// Open login form
		$( ".smk-theme-link-to-login" ).on( "click", function( event ) {
			event.preventDefault();
			$('.smk-theme-login-block-back-shadow, .smk-theme-login-block').addClass('active');
			$('.smk-theme-login-block input:eq(0)').focus(); // Focus first input on form open
			$( ".smk-theme-login-block .fr-reg-y:not(.fr-log-y), .smk-theme-login-block .fr-rec-y" ).slideUp(150);
			$( ".smk-theme-login-block .fr-log-y" ).slideDown(150);
			$(".smk-theme-login-block-type span").removeClass('active');
			$(".smk-theme-login-block-type span.type-login").addClass('active');
			_form_type.val('log');
		});

		// Open registration form
		$( ".smk-theme-link-to-register" ).on( "click", function( event ) {
			event.preventDefault();
			$('.smk-theme-login-block-back-shadow, .smk-theme-login-block').addClass('active');
			$('.smk-theme-login-block input:eq(0)').focus(); // Focus first input on form open
			$( ".smk-theme-login-block .fr-log-y:not(.fr-reg-y), .smk-theme-login-block .fr-rec-y" ).slideUp(150);
			$( ".smk-theme-login-block .fr-reg-y" ).slideDown(150);
			$(".smk-theme-login-block-type span").removeClass('active');
			$(".smk-theme-login-block-type span.type-register").addClass('active');
			_form_type.val('reg');
		});

		// Close form
		$( ".smk-theme-login-block-close, .smk-theme-login-block-back-shadow" ).on( "click", function( event ) {
			event.preventDefault();
			$('.smk-theme-login-block-back-shadow, .smk-theme-login-block').removeClass('active');
			$('.smk-theme-login-block .form-row input').val(''); // Clear inputs
			$('.form-message-response').html(''); // Clear messages
		});

		// Submit form
		$( ".smk-theme-login-form" ).on( "submit", function( event ) {
			event.preventDefault();
			var _form = $(this),
			    _msg = _form.find('.form-message-response'),
			    _form_data = _form.serialize(),
			    _button = $('.smk-theme-login-form-button');


			_msg.slideUp(150);
			_button.attr('disabled', true).addClass('loading');
			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				data: {
					'action': 'smk_login_form_ajax_handler',
					'data': _form_data
				},
				success: function(response){
					console.log(response);
					// _msg.html(response);
					if( response == -1 || response == 0 ) {
						_msg.html('<div class="notification red">' + themeAjax.login_msg105 + '</div>').slideDown(150);
						return;// If ajax error
					}
					else if( parseInt( response ) == response ){
						if(  101 == response ){
							_msg.html('<div class="notification red">' + themeAjax.login_msg101 + '</div>').slideDown(150);
						}
						else if(  102 == response ){
							_msg.html('<div class="notification red">' + themeAjax.login_msg102 + '</div>').slideDown(150);
						}
						else if(  104 == response ){
							_msg.html('<div class="notification green">' + themeAjax.login_msg104 + '</div>').slideDown(150);
							location.reload();
						}
						else if(  113 == response ){
							_msg.html('<div class="notification green">' + themeAjax.login_msg113 + '</div>').slideDown(150);
							location.reload();
						}
						else if(  116 == response ){
							_msg.html('<div class="notification green">' + themeAjax.login_msg116 + '</div>').slideDown(150);
							location.reload();
						}
						else{
							_msg.html('<div class="notification red">' + themeAjax['login_msg' + response] + '</div>').slideDown(150);
						}
					}

					_button.attr('disabled', false).removeClass('loading');

				},
				error: function(){
					_msg.html('<div class="notification red">' + themeAjax.login_msg105 + '</div>').slideDown(150);
					_button.attr('disabled', false).removeClass('loading');
				},
				// complete: function(){}
			});//ajax
		});
	}
	smk_theme_login_form();

	function smk_theme_user_settings_form(){
		$( "#smk-theme-user-settings-form" ).on( "submit", function( event ) {
			event.preventDefault();
			var _this = $(this),
			    _form_data = _this.serialize(),
			    _button = $('#smk-theme-user-settings-submit-button');
			$('.smk-field').removeClass('field-error')
			$('body').find('.smk-field-error').remove();
			_button.attr('disabled', true).addClass('loading');
			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				dataType: "json",
				data: {
					'action': 'smk_user_settings_form_ajax_handler',
					'data': _form_data
				},
				success: function(response){
					console.log( response );
					_button.attr('disabled', false).removeClass('loading');
					if( jQuery.type( response ) == 'object' ){
						if( response.msg_type == 'error' ){
							$.each(response, function( index, elem ) {
								if( elem != 'error' ){
									$('.smk-field-' + index).addClass('field-error').after('<div class="smk-field-error text-red">'+ elem +'</div>');
								}
							});
						}
						else if( response.msg_type == 'success' ){
							_this.after('<div class="smk-field-error text-green"><strong>'+ response.message +'</strong></div>');
							window.setTimeout(function(){
								$('body').find('.smk-field-error').slideUp(150);
							}, 3500);
						}
					}
				},
				// complete: function(){}
			});//ajax
		});
	}
	smk_theme_user_settings_form();

	/*
	-------------------------------------------------------------------------------
	Submit recipe
	-------------------------------------------------------------------------------
	*/

	function smk_submit_recipe(){
		$( "#smk-submit-recipe" ).on( "submit", function( event ) {
			event.preventDefault();
			
			if (typeof(tinymce) !== "undefined") {
				tinymce.triggerSave();
			}

			$(this).find('input, textarea, select').change();

			var _this = $(this),
			    _form_data = _this.serialize(),
			    _button = $('#smk-submit-recipe-button'),
			    ajaxMsg = themeAjax.submit_recipe;

			_button.attr('disabled', true).addClass('loading');
			_this.find('.smk-field-error').slideUp(150, false, function(){
				_this.find('[name]').css({ 'border-color': '' });
				$(this).remove();
			});
			_this.find('.submission_notice').fadeOut(100, false, function(){
				$(this).remove();
			});

			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				dataType: "json",
				data: {
					'action': 'smk_submit_recipe_ajax_handler',
					'data': _form_data
				},
				success: function(response){
					console.log( response );
					_button.attr('disabled', false).removeClass('loading');
					if( ! response.post_id ){
						$.each(response, function(key, value){
							$('[data-field="'+ key +'"]').append('<div class="smk-field-error text-red" style="display: none;">'+ value +'</div>');
							$('[name="'+ key +'"]').css({ 'border-color': '#EB5858' });
							_this.find('.smk-field-error').slideDown(150);
						});
						_button.after('<span class="submission_notice red" style="display: none;">' + ajaxMsg.recipe_errors + '</span>');
					}
					else{
						if( response.submit_type == 'new' ){
							_button.attr('disabled', true);

							if( response.post_status == 'pending' ){
								_button.after('<span class="submission_notice green" style="display: none;">' + ajaxMsg.recipe_pending + ' - <a href="'+ response.user_recipes_url +'">' + ajaxMsg.check_recipe_status + '</span>');
							}
							else{
								_button.after('<span class="submission_notice green" style="display: none;">' + ajaxMsg.recipe_approved + ' - <a href="'+ response.post_url +'">' + ajaxMsg.view_your_recipe + '</a></span>');
							}
						}
						else if( response.submit_type == 'updated' ){
							if( response.post_status == 'pending' ){
								_button.after('<span class="submission_notice green" style="display: none;">' + ajaxMsg.recipe_updated + ' - <a href="'+ response.user_recipes_url +'">' + ajaxMsg.check_recipe_status + '</span>');
							}
							else{
								_button.after('<span class="submission_notice green" style="display: none;">' + ajaxMsg.recipe_updated + ' - <a href="'+ response.post_url +'">' + ajaxMsg.view_your_recipe + '</a></span>');
							}
						}
					}
					_this.find('.submission_notice').fadeIn(100);
				},
				// complete: function(){}
			});//ajax
		});
	}
	smk_submit_recipe();

	/*
	-------------------------------------------------------------------------------
	Manage recipe
	-------------------------------------------------------------------------------
	*/
	function smk_manage_recipe(){
		var _manage = $( ".smk-manage-recipe" );

		_manage.on( 'click', '.manage-recipe-handler', function( event ) {
			event.preventDefault();
			var _this   = $(this),
			    _parent = _this.parents(".smk-manage-recipe");

			// First hide all opened
			$( ".smk-manage-recipe" ).not(_parent).removeClass('active');

			_parent.toggleClass('active');
		});

		//Hide/Show when we leave the area
		$(document).mouseup(function ( event ){
			if ( 
				!_manage.is(event.target)                  // if the target of the click isn't the container...
				&& _manage.has(event.target).length === 0  // ... nor a descendant of the container
			){
				_manage.removeClass('active');
			}
		});
	}
	smk_manage_recipe();

	function smk_manage_recipe_remove(){
		$('.smk-remove-recipe').on( 'click', function( event ){
			event.preventDefault();
			var _this = $(this),
			    _post_id = _this.data('id');

			var confirm_delete = confirm( themeAjax.confirm_recipe_delete );

			if( confirm_delete ){
				_this.addClass('loading-element');
				jQuery.ajax({
					type: "POST",
					url: themeAjax.ajax_url,
					dataType: "json",
					data: {
						'action': 'smk_remove_recipe_ajax_handler',
						'post_id': _post_id
					},
					success: function(response){
						_this.removeClass('loading-element');
						_this.parent().find('a').not('.smk-remove-recipe').slideUp( 100, false, function(){
							$(this).remove();
						});
						_this.text( response.message );
						setTimeout( function(){
							if( response.redirect ){
								window.location.assign( response.redirect );
							}
						}, 200);
					}
				});
			}
		});
	}
	smk_manage_recipe_remove();

	function smk_manage_recipe_approve_publish(){
		$('.smk-approve-unapprove-recipe').on( 'click', function( event ){
			event.preventDefault();
			var _this = $(this),
			    _post_id = _this.data('id');

			_this.addClass('loading-element');
			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				dataType: "json",
				data: {
					'action': 'smk_approve_publish_recipe_ajax_handler',
					'post_id': _post_id
				},
				success: function(response){
					_this.removeClass('loading-element');
					if( ! response.error_message ){
						if( response.status == 'approved' ){
							_this.removeClass( 'approve' ).addClass( 'unapprove' );
						}
						else if( response.status == 'unapproved' ){
							_this.addClass( 'approve' ).removeClass( 'unapprove' );
						}
					}
					_this.text( response.text );
				}
			});
		});
	}
	smk_manage_recipe_approve_publish();

	function smk_manage_recipe_make_featured(){
		$('.smk-make-recipe-featured').on( 'click', function( event ){
			event.preventDefault();
			var _this = $(this),
			    _post_id = _this.data('id');

			_this.addClass('loading-element');
			jQuery.ajax({
				type: "POST",
				url: themeAjax.ajax_url,
				dataType: "json",
				data: {
					'action': 'smk_make_recipe_featured_ajax_handler',
					'post_id': _post_id
				},
				success: function(response){
					_this.removeClass('loading-element');
					if( response.status ){
						if( response.status == 'featured' ){
							_this.removeClass( 'not_featured' ).addClass( 'featured' );
						}
						else if( response.status == 'not_featured' ){
							_this.addClass( 'not_featured' ).removeClass( 'featured' );
						}
						_this.text( response.featured );
					}
				}
			});
		});
	}
	smk_manage_recipe_make_featured();

	function smk_recipes_remove_reputation(){
		$('.smk-recipes-remove-reputation').on( 'click', function( event ){
			event.preventDefault();
			var _this = $(this);

			_this.parents('.reputation-event').css( 'opacity', 0.5 );
			jQuery.ajax({
				type: "GET",
				url: themeAjax.ajax_url,
				data: _this.attr('href').split('?')[1],
				success: function(response){
					// console.log(response);
					_this.parents('.reputation-event').slideUp( 'fast' );
				}
			});
		});
	}
	smk_recipes_remove_reputation();

	function smk_recipes_remove_activity(){
		$('.smk-recipes-remove-activity').on( 'click', function( event ){
			event.preventDefault();
			var _this = $(this);

			_this.parents('.single-notification').css( 'opacity', 0.5 );
			jQuery.ajax({
				type: "GET",
				url: themeAjax.ajax_url,
				data: _this.attr('href').split('?')[1],
				success: function(response){
					// console.log(response);
					_this.parents('.single-notification').slideUp( 'fast' );
				}
			});
		});
	}
	smk_recipes_remove_activity();

	/*
	-------------------------------------------------------------------------------
	Uploader
	-------------------------------------------------------------------------------
	*/
	function smk_image_uploader_upload_file(event, selector, _multiple_allowed) {
		event.preventDefault();
	
		var _elem = $(this),
		    frame;
			
		// If the media frame already exists, reopen it.
		if ( frame ) {
			frame.open();
			return;
		}

		// Create the media frame.
		frame = wp.media({
			multiple: _multiple_allowed,

			// Set the title of the modal.
			title: _elem.data('choose'),

			// Customize the submit button.
			button: {
				// Set the text of the button.
				text: _elem.data('update'),
				// Tell the button not to close the modal, since we're
				// going to refresh the page when the image is selected.
				close: false,
			},
			library: {
				type: 'image'
			},
		});

		// When an image is selected, run a callback.
		frame.on( 'select', function() {
			// Grab the selected attachment.
			var attachments    = frame.state().get('selection'),
			    attachment     = attachments.first(),
			    mime_type      = attachment.attributes.mime,
			    mime_type      = (mime_type) ? mime_type.toLowerCase() : '',
			    the_url        = attachment.attributes.url,
			    is_img = ( jQuery.inArray( mime_type, ['image/jpg', 'image/jpeg', 'image/png'] ) == -1 ) ? false : true;
			
			// console.log(attachments);
			console.log(attachment);

			if( is_img ){
				var the_thumb_url  = ( attachment.attributes.sizes.thumbnail ) ? attachment.attributes.sizes.thumbnail.url : the_url,
				    hidden_img     = selector.find('.smk-the-image-hidden').clone(),
				    img_block_list = selector.find('.smk-image-uploader-images-list'),
				    img_w          = ( attachment.attributes.width ) ? attachment.attributes.width : 0,
				    img_h          = ( attachment.attributes.height ) ? attachment.attributes.height : 0;

				if( selector.hasClass('size-medium') ){
					the_thumb_url  = ( attachment.attributes.sizes.medium ) ? attachment.attributes.sizes.medium.url : the_url;
				}
				else if( selector.hasClass('size-large') ){
					the_thumb_url  = ( attachment.attributes.sizes.large ) ? attachment.attributes.sizes.large.url : the_url;
				}

				// Remove previous uploaded image
				img_block_list.find(".static-upload").remove();

				// Show the imag and update data
				img_block_list.append( hidden_img );
				hidden_img.removeClass('smk-the-image-hidden').addClass('static-upload');
				
				var the_hidden_img_input = hidden_img.find('input');
				the_hidden_img_input.attr( 'name', the_hidden_img_input.attr( 'data-name' ) ).removeAttr('data-name');
				the_hidden_img_input.attr( 'value', the_url );

				hidden_img.find('img').attr('src', the_thumb_url);
				selector.find('.smk-image-uploader-button').hide(); // hide upload button
			}
			frame.close();

		});

		// Finally, open the modal.
		frame.open();
	}
    
	function smk_image_uploader(){
		
		$('body').on('click', '.smk-image-uploader-button', function( event ) {
			smk_image_uploader_upload_file(event, $(this).parents( '.smk-image-uploader' ), $(this).parents( '.smk-image-uploader' ).hasClass('mt'));
		});

		$('body').on('click', '.static-upload .the-image-div', function( event ) {
			smk_image_uploader_upload_file(event, $(this).parents( '.smk-image-uploader' ), $(this).parents( '.smk-image-uploader' ).hasClass('mt'));
		});

		$('body').on('click', '.smk-uploader-remove-image', function( event ) {
			var _this = $(this),
			    _uploader = _this.parents( '.smk-image-uploader' ),
			    _parent = _this.parents( '.the-image' );
			
			_parent.children('.the-image-div').fadeOut(150, false, function(){
				_parent.remove();
				_uploader.find('.smk-image-uploader-button').fadeIn(100); // show upload button
			});
		});

	}
	smk_image_uploader();


	$('#smk-user-settings-password').on('keyup', function(){
		var _field_val    = $(this).val(),
		    _meter_ind    = $('#smk-user-settings-password-meter .meter-ind'),
		    len_score     = 0,
		    nr_score      = 0,
		    alphaL_score  = 0,
		    alphaU_score  = 0,
		    special_score = 0,
		    percent       = 0;

			if( _field_val.length > 0 )  len_score = 0;
			if( _field_val.length > 3 )  len_score = 1;
			if( _field_val.length > 7 )  len_score = 2;
			if( _field_val.length > 9 )  len_score = 3;
			if( _field_val.length > 11 ) len_score = 4;

			alphaL_score   = _field_val.match(/[a-z]/) ? 1 : 0;
			alphaU_score   = _field_val.match(/[A-Z]/) ? 2 : 0;
			special_score  = _field_val.match(/.[!@#$%^&*?_~]/) ? 2 : 0;
			nr_score       = _field_val.match(/[0-9]/) ? 1 : 0;
			percent        = ( len_score + alphaL_score + alphaU_score + special_score + nr_score ) * 10;

			_meter_ind.stop().animate({ 'left': ( percent ) + '%' }, 500);
	});

	$('#smk-user-settings-password, #smk-user-settings-password-confirm').on('keyup', function(){
		var _pass1     = $('#smk-user-settings-password'),
		    _pass2     = $('#smk-user-settings-password-confirm'),
		    _pass1_val = $('#smk-user-settings-password').val(),
		    _pass2_val = $('#smk-user-settings-password-confirm').val();

			if( _pass2_val === _pass1_val ){
				_pass1.css({ 'border-color': '#89C245' });
				_pass2.css({ 'border-color': '#89C245' });
			}
			else{
				_pass1.css({ 'border-color': '' });
				_pass2.css({ 'border-color': '#EB5858' });
			}

			if( _pass2_val.length < 1 ){
				_pass1.css({ 'border-color': '' });
				_pass2.css({ 'border-color': '' });
			}
	});

	function smk_theme_print_button_animate(){
		$( ".recipe-tools" ).on( "click", '.tool.print', function() {
			var _this = $(this);
			_this.addClass('loading-element');
		});
	}
	smk_theme_print_button_animate();

	function smk_theme_add_to_favorites(){
		$( ".smk-mark-button" ).on( "click", function( event ) {
			event.preventDefault();
			var _this = $(this),
			    _post_id = _this.data('post'),
			    settings = _this.data('settings') ? _this.data('settings') : false,
			    logged = _this.data('l') ? _this.data('l') : false,
			    act = _this.data('act') ? _this.data('act') : false;

			if( parseInt(_post_id) > 0 && settings && logged ){
				_this.addClass('loading-element');
				jQuery.ajax({
					type: "POST",
					dataType: "json",
					url: themeAjax.ajax_url,
					data: {
						'action': 'smk_mark_post_' + act,
						'data': {
							'post': _post_id,
							'settings': settings
						}
					},
					success: function(obj){
						// console.log( obj );
						_this.removeClass('loading-element');
						var _activeClass = (obj.class_active) ? obj.class_active : false;


						// What is the status?
						if( _activeClass ){
							if( obj.js_status == 'added' ){
								_this.addClass( _activeClass );
								var _content_remove = obj.content_remove;
								_content_remove = _content_remove.replace(/\\\'/g, "'").replace(/\\\"/g, '"').replace(/\\\\/g, '\\');
								_this.html( _content_remove );
							}
							else if( obj.js_status == 'removed' ){
								_this.removeClass( _activeClass );
								var _content = obj.content;
								_content = _content.replace(/\\\'/g, "'").replace(/\\\"/g, '"').replace(/\\\\/g, '\\');
								_this.html( _content );
							}
						}

						// Update the counter text number that is before or after the button
						if( obj.modify_content == 'next' ){
							_this.next().text( obj.js_total_number_of_fav );
						}
						if( obj.modify_content == 'prev' ){
							_this.prev().text( obj.js_total_number_of_fav );
						}

						// Change the title
						_this.attr( 'title', obj.attributes.title );
					},
					// complete: function(){}
				});//ajax
			}
		});
	}
	smk_theme_add_to_favorites();

	function smk_theme_comment_rating_stars(){
		$('.comment-form-rating-field i').on('mouseover', function(){
			var _t = $(this);
			var rating = parseInt( _t.data('order'), 10);
			_t.parent().find('i').removeClass('fa-star').addClass('fa-star-o');
			_t.parent().find('i:lt('+ rating +')').removeClass('fa-star-o').addClass('fa-star');
		});

		$('.comment-form-rating-field i').on('mouseout', function(){
			var _t = $(this);
			var rating = parseInt( _t.parent().find('input').val(), 10);
			_t.parent().find('i').removeClass('fa-star').addClass('fa-star-o');
			_t.parent().find('i:lt('+ rating +')').removeClass('fa-star-o').addClass('fa-star');
		});

		$('.comment-form-rating-field input').on('change', function(){
			var _t = $(this);
			var rating = parseInt( _t.val(), 10);
			_t.parent().find('i').removeClass('fa-star').addClass('fa-star-o');
			_t.parent().find('i:lt('+ rating +')').removeClass('fa-star-o').addClass('fa-star');
			
			var cr = _t.parent().find('.clear-rating');
			if( rating > 0 ){
				cr.fadeIn(150);
			}
			else{
				cr.fadeOut(150);
			}
		});

		$('.comment-form-rating-field i').on('click', function(){
			var rating = parseInt( $(this).data('order'), 10);
			$(this).parent().find('input').val(rating).change();
		});

		$('.comment-form-rating-field .clear-rating').on('click', function(){
			$(this).parent().find('input').val(0).change();
		});
		
		$('.comment-reply-link').on('click', function(){
			$('.comment-respond .comment-form-rating-field input').val(0).change();
		});
	}
	smk_theme_comment_rating_stars();



	// function smk_recipes_filter_select_make_active(){
	// 	$( ".recipes-filter select" ).each( function( index, elem ) {
	// 		if( $(elem).val() ){
	// 			$(elem).addClass('active');
	// 		}
	// 	});
	// }
	// smk_recipes_filter_select_make_active();

	// function smk_recipes_filter_select(){
	// 	$( ".recipes-filter" ).on( "change", 'select', function( event ) {
	// 		var _t    = $(this),
	// 		    _name = _t.attr('name'),
	// 		    _val  = _t.val(),
	// 		    _url  = window.location,
	// 		    uri   = new Uri( _url );

	// 		$( ".recipes-filter select" ).attr('disabled', true);
	// 		_t.addClass('loading-element');
			
	// 		// Delete paged arg
	// 		uri.deleteQueryParam('pag');
			
	// 		var _new = uri.replaceQueryParam(_name, _val);
	// 		window.location.assign( _new );
	// 	});
	// }
	// smk_recipes_filter_select();

	// function smk_recipes_filter_view(){
	// 	$( ".recipes-filter" ).on( "click", '.option', function( event ) {
	// 		var _t    = $(this),
	// 		    _name = _t.data('name'),
	// 		    _val  = _t.data('val'),
	// 		    _url  = window.location,
	// 		    uri   = new Uri( _url );

	// 		if( ! _t.hasClass('active') ){
	// 			$( ".recipes-filter select" ).attr('disabled', true);
	// 			$( ".recipes-filter .option" ).not(this).removeClass('active').addClass('inactive');
	// 			_t.addClass('active');
	// 			var _new = uri.replaceQueryParam(_name, _val);
	// 			window.location.assign( _new );
	// 		}
	// 	});
	// }
	// smk_recipes_filter_view();


	// function smk_comments_ajax_submit(){
	// 	$( "#commentform" ).on( "submit", function( event ) {
	// 		event.preventDefault();
	// 		var _this = $(this),
	// 		    _form_data = _this.serialize(),
	// 		    _button = $(this).find('.form-submit .button');

	// 		_button.attr('disabled', true).addClass('loading');
	// 		console.log(_form_data);
	// 		jQuery.ajax({
	// 			type: "POST",
	// 			url: themeAjax.ajax_url,
	// 			// dataType: "json",
	// 			data: {
	// 				'action': 'smk_comments_ajax_submit',
	// 				'data': _form_data
	// 			},
	// 			success: function(response){
	// 				console.log( response );
	// 				_button.attr('disabled', false).removeClass('loading');
	// 				$( '#all-post-comments' ).html( response );
	// 			},
	// 			// complete: function(){}
	// 		});//ajax
	// 	});
	// }
	// smk_comments_ajax_submit();






	/* Do not jump on top when the link contain only the hash(#) sign
	------------------------------------------------*/
	// $('a[href="#"]').on('click', function(event){
	// 	event.preventDefault();
	// 	return false;
	// });

	/* If the menu has empty links make them less relevant to the user
	------------------------------------------------*/
	// $('.menu ul a[href="#"]').css({
	// 	// 'text-decoration': 'line-through',
	// 	'font-style': 'italic',
	// 	'opacity': '0.8'
	// });

	/* Grid demo
	------------------------------------------------*/
	// function smk_theme_grid_demo(){
	// 	$('.demo-grid-col').each( function(index, elem){
	// 		if( $(this).parent().hasClass('grid') ){
	// 			var tc = $(elem).parent('.grid').attr('class').replace('grid', '');
	// 			$(elem).append(tc);
	// 		}
	// 	} );

	// }
	// smk_theme_grid_demo();

	/* Fake bahavoir
	------------------------------------------------*/
	// function smk_theme_like_favorite(){
	// 	$('.entry-controls .entry-to-favorites, .entry-controls .entry-like').on('click', function(event){
	// 		event.preventDefault();
	// 		var btn = $(this),
	// 			counter = btn.next('.control-tip'),
	// 			count = parseInt( counter.text(), 10 );
	// 		if( btn.hasClass('active') ){
	// 			btn.removeClass('active');
	// 			counter.text( count - 1 );
	// 		}
	// 		else{
	// 			btn.addClass('active');
	// 			counter.text( count + 1 );
	// 		}
	// 		return false;
	// 	});
	// }
	// smk_theme_like_favorite();

	// function smk_theme_recipe_tools(){
	// 	$('.recipe-tools .tool:not(.share):not(.print)').on('click', function(event){
	// 		event.preventDefault();
			
	// 		var btn = $(this);
	// 		btn.hasClass('active') ? btn.removeClass('active') : btn.addClass('active');

	// 		return false;
	// 	});
	// }
	// smk_theme_recipe_tools();

	function smk_theme_comment_vote(){
		$('.comment-vote .control').on( 'click', function(){
			var btn = $(this),
			    container = btn.parent(),
			    counter = container.find('.counter'),
			    total = parseInt( counter.text(), 10);

			if( btn.hasClass('active') ){
				btn.hasClass('upvote') ? counter.text( total - 1 ) : counter.text( total + 1 );
				btn.removeClass('active');
			}
			else{
				if( container.find('.control').hasClass('active') ){
					btn.hasClass('upvote') ? counter.text( total + 2 ) : counter.text( total - 2 );
				}
				else{
					btn.hasClass('upvote') ? counter.text( total + 1 ) : counter.text( total - 1 );
				}
				container.find('.control').removeClass('active');
				btn.addClass('active');
			}
		});
	}
	smk_theme_comment_vote();

});

})(jQuery);