<?php

/**
 * Forums Loop - Single Forum
 *
 * @package bbPress
 * @subpackage Theme
 */

$forum_id = bbp_get_forum_id();
?>

<div id="bbp-forum-<?php bbp_forum_id(); ?>" <?php bbp_forum_class(); ?>>

	<div class="bbp-forum-info-header clearfix">
		
		<div class="forum-header-left">
			<a class="bbp-forum-title" href="<?php bbp_forum_permalink(); ?>">
				<?php bbp_forum_title(); ?>
			</a>
			<span class="bbp-forum-content"><?php bbp_forum_content(); ?></span>
		</div>

		<div class="forum-header-right">
			<div class="forum-topic-count">
				<span class="mark green" title="<?php printf( __('%d topics', 'smk_theme'), bbp_get_forum_topic_count() ); ?>">
					<?php printf( __('%d topics', 'smk_theme'), bbp_get_forum_topic_count() ); ?>
				</span>
			</div>
		</div>

		<?php bbp_forum_row_actions(); ?>

	</div>

	<div class="bbp-forum-info-body-forums-list">
		<?php 
			bbp_list_forums(array(
				'separator' => '',
			)); 
		?>
	</div>
	<div class="bbp-forum-info-body">
		<?php 
			$query_topics = array( 
				'author'         => 0, 
				'show_stickies'  => false, 
				'order'          => 'DESC', 
				'posts_per_page' => 5,
				'meta_key'       => '_bbp_last_active_time',
				'orderby'        => 'meta_value',
			);

			$sub = bbp_forum_get_subforums();
			if( !empty($sub) ){
				$query_topics['post_parent__in'] = array( $forum_id );
				foreach ($sub as $key => $value) {
					$query_topics['post_parent__in'][] = $value->ID;
				}
			}
			else{
				$query_topics['post_parent'] =  $forum_id;
			}


			if ( bbp_has_topics( $query_topics ) ){
				while ( bbp_topics() ) : bbp_the_topic();
					bbp_get_template_part( 'loop', 'single-topic-home' );
				endwhile;
			}
			else{
				echo '<div class="notification blue super-light">'. __('This forum has not any active topics.', 'smk_theme') .'</div>';
			}
		?>
	</div>

</div><!-- #bbp-forum-<?php bbp_forum_id(); ?> -->
