<?php

/**
 * Replies Loop - Single Reply
 *
 * @package bbPress
 * @subpackage Theme
 */
$reply_author_id = bbp_get_reply_author_id();
$reputation = new Smk_Theme_User_Reputation($reply_author_id);
?>

<div id="post-<?php bbp_reply_id(); ?>" class="topic clearfix">
	<div class="topic-left">
		<a href="<?php echo get_author_posts_url( bbp_get_reply_author_id() ); ?>"><?php echo bbp_get_reply_author_avatar( false, 80 ); ?></a>
		<div class="username"><?php echo bbp_get_reply_author_display_name(); ?></div>
		<div class="rank"><span><?php echo bbp_get_reply_author_role(); ?></span></div>
		<div class="user-info-total"><?php printf( __('%d replies', 'smk_theme') , bbp_get_user_reply_count_raw($reply_author_id) ); ?></div>
		<div class="user-info-total"><?php printf( __('%d topics', 'smk_theme') , bbp_get_user_topic_count_raw($reply_author_id) ); ?></div>
	</div>
	<div class="topic-right">
		<div class="topic-header">
			<div class="topic-time"><?php printf( __('Posted on %1$s', 'smk_theme'), bbp_get_reply_post_date() ); ?></div>
			<div class="topic-moderate">
				<?php do_action( 'bbp_theme_before_reply_admin_links' ); ?>
				<?php bbp_reply_admin_links(array('sep'    => '')); ?>
				<?php do_action( 'bbp_theme_after_reply_admin_links' ); ?>
			</div>
		</div>
		<div class="topic-content">
			<?php do_action( 'bbp_theme_before_reply_content' ); ?>
			<?php bbp_reply_content(); ?>
			<?php do_action( 'bbp_theme_after_reply_content' ); ?>
		</div>
	</div>
</div>