<?php

/**
 * Topics Loop - Single
 *
 * @package bbPress
 * @subpackage Theme
 */

?>


<div id="bbp-topic-<?php bbp_topic_id(); ?>" <?php bbp_topic_class( bbp_get_topic_id(), array( 'topic', 'clearfix' ) ); ?>>
	<div class="details">
		<div class="submeta">
			<div class="title">
				<a class="bbp-topic-permalink" href="<?php bbp_topic_permalink(); ?>"><?php 
				
					if( bbp_is_topic_closed() ){
						echo '<span class="topic-status closed">'. __('Closed', 'smk_theme') .'</span>';
					}
					bbp_topic_title(); 
				?></a>
			</div>
			<?php 
				$topic_author_id = get_the_author_meta( 'ID' );
				echo '<a href="'. bbp_get_topic_permalink() .'" class="author-avatar">';
					echo get_avatar( $topic_author_id, 80 );
				echo '</a>'; 
			?>
			<div class="topic-author">
				<?php 
					printf(
						__('Started by: %s in: %s', 'smk_theme'),
						' <a href="'. get_author_posts_url( $topic_author_id ) .'">' . get_user_option( 'display_name', $topic_author_id ) .'</a>',
						' <a href="'. bbp_get_forum_permalink( bbp_get_topic_forum_id() ) .'">' . bbp_get_forum_title( bbp_get_topic_forum_id() ) .'</a>'
					);
				?>
				
			</div>
			<div class="topic-author">
				<?php 
					$topic_last_author_id = get_post_field( 'post_author', bbp_get_topic_last_active_id() );
					printf( 
						__('Last reply by: %s', 'smk_theme'),
						' <a href="'. get_author_posts_url( $topic_last_author_id ) .'">' . get_user_option( 'display_name', $topic_last_author_id ) .'</a>'
					);
				?>
			</div>
			<div class="topic-time"><?php bbp_topic_freshness_link(); ?></div>
		</div>
	</div>
	<div class="meta">
		<div class="topic-meta">
			<span class="label">
				<?php bbp_show_lead_topic() ? bbp_topic_reply_count() : bbp_topic_post_count(); ?>
				<?php echo ' '. _x('replies', 'Refers to the number of replies. Ex: 29 replies', 'smk_theme')  ?>
			</span>
		</div>
		<div class="users clearfix">
			
			<?php 
				bbp_get_template_part( 'topic', 'participants' );
			?>

		</div>
	</div>
</div> <!-- .topic -->