<?php 
	$comments_closed_notice = '<div class="notification red super-light center">' . __( 'Comments are closed.', 'smk_theme' ) . '</div>';
	$comments_open          = comments_open();
	$comments_number        = absint(get_comments_number());

	// If this post requires a password and it is not entered by the user, stop
	if ( post_password_required() ){
		return;
	}

	// If comments are closed and there are 0 comments already posted, stop
	if( !$comments_open && $comments_number == 0  ){
		echo '<div class="rw-row clearfix">'. $comments_closed_notice .'</div>';
		return;
	}
	
?>

<div class="rw-row border-bottom clearfix">
	<?php 
		if( $comments_number > 0 ){
			echo '<h2>'. __('Comments:', 'smk_theme') .' - '. $comments_number .'</h2>';
		} 
	?>

	<div id="comments" class="comments-area">
		<?php 
			if ( have_comments() ) {

				//Comments list
				echo '<ul class="post-comments">';
					$args = smk_comments_args();
					wp_list_comments( $args );
				echo '</ul>';

				// Paginate comments
				if ( get_comment_pages_count() > 1 && get_option( 'page_comments' ) ){
					echo '<div class="comments-pagination">';
						paginate_comments_links();
					echo '</div>';
				}

			} // have_comments()
			elseif( $comments_open ){
				echo '<div class="notification blue super-light center">' . __( 'No comments. Be the first to comment on this.', 'smk_theme' ) . '</div>';
			}
		?>
	</div><!-- #comments -->
</div> <!-- .rw-row -->

<div class="rw-row clearfix">
	<?php 
		// If comments are closed
		if ( ! $comments_open ) {
			echo $comments_closed_notice;
		}
		
		$comments_args = smk_theme_comments_args();
		comment_form( $comments_args );
	?>
</div>