<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<?php wp_head(); ?>
</head>
<body <?php body_class(); ?>>
<?php 
	$layout_style = smk_theme_setting( 'layout_style', 'boxed' );
	$rw_layout_class = '';
	if( 'full' == $layout_style ){
		$rw_layout_class = ' full-width-layout';
	}
 ?>
<section id="rw-layout" class="rw-layout<?php echo $rw_layout_class; ?>">
<?php 

$current_user = Smk_Theme_User::currentUser();
$pm_list = new Smk_Private_Messages_List( $current_user );

?>

<!--
// ===================================^__^=================================== //
   Header
// ===================================^__^=================================== //
-->
<?php 
	$sticky_header = get_theme_mod( 'sticky_header' );
	$sticky_class = ( !empty( $sticky_header ) ) ? ' mod-fixed-header' : '';
?>
<div class="rw-section rw-header<?php echo $sticky_class; ?>">
	<div class="rw-inner clearfix">
		
		<div class="header-container clearfix">
			
			<div class="header-logo-holder <?php echo apply_filters('smk_logo_holder_class', ''); ?>">
				<?php echo apply_filters('smk_theme_logo', '<a href="'. site_url() .'">'. get_bloginfo('name') .'</a>'); ?>
			</div>
			
			<div class="header-menu">
				
				<?php 
					wp_nav_menu( array(
						'theme_location'  => 'the_main_menu',
						'container'       => 'nav',
						'container_id'    => 'the-main-menu',
						'container_class' => 'main-menu-nav menu-inline',
						'menu_class'      => 'menu horizontal',
						'menu_id'         => 'main_menu',
						'fallback_cb'     => false,
					) ); 
				?>
			</div>

			<div class="header-user-menu">
				<nav id="the-user-menu" class="main-menu-nav">
					<ul class="menu horizontal align-right">

						<?php 
							$show_search_icon = get_theme_mod( 'show_header_search_icon' );
							if( !empty( $show_search_icon ) ) :
						?>
						<!-- Search -->
						<li class="to-left-more">
							<a href="<?php echo smk_get_recipes_search_url(); ?>" class="menu-single-icon header-search-icon" title="<?php _e('Search recipes', 'smk_theme') ?>">
								<i class="fa fa-search"></i>
								<span class="menu-hidden-title"><?php _e('Search recipes', 'smk_theme') ?></span>
							</a>
						</li>
						<?php endif; ?>
						
						<?php 
						/*echo '<!-- Notifications -->
						<li class="to-left-more">
							<a href="#" class="menu-single-icon" title="<?php _e('Notifications', 'smk_theme') ?>">
								<i class="fa fa-bell"></i>
							</a>
							<ul class="sub-menu user-notes">
								<li>
									<div class="no-new-notifications clearfix"><?php _e('No new notifications.', 'smk_theme'); ?></div>
								</li>
								
								<li class="go-to-all"><a href="#"><?php _e('View all notifications', 'smk_theme') ?></a></li>
							</ul>
						</li>';*/
						?>
						
					<?php 
					if( is_user_logged_in() ) { 
					?>
						
						<?php 
							$show_pm_icon = get_theme_mod( 'show_header_pm_icon' );
							if( !empty( $show_pm_icon ) ) :
						?>
						<!-- Messages -->
						<li class="to-left-more">
							<a href="<?php echo smk_user_pm_url(); ?>" class="menu-single-icon" title="<?php _e('Private messages', 'smk_theme') ?>">
								<i class="fa fa-envelope"></i>
								<span class="menu-hidden-title"><?php _e('Private messages', 'smk_theme') ?></span>
								<?php 
									$total = $pm_list->getNewTotal();
									echo ($total > 0) ? '<span class="new-info">'. $total .'</span>' : '';
								?>
							</a>
							<ul class="sub-menu user-notes">
								<li>
									<?php $pm_list->getNew(); ?>
								</li>
								
								<li class="go-to-all"><a href="<?php echo smk_user_pm_url(); ?>"><?php _e('View all messages', 'smk_theme') ?></a></li>
							</ul>
						</li>
						<?php endif; ?>
						
						<?php 
							if( smk_recipe_submission_enabled() ) :
								$show_submission_icon = get_theme_mod( 'show_header_submission_icon' );
								if( !empty( $show_submission_icon ) ) :
						 ?>
						<!-- Submission -->
						<li class="to-left-more">
							<a href="<?php echo smk_recipe_submit_url(); ?>" class="menu-single-icon" title="<?php _e('Submit new recipe', 'smk_theme') ?>">
								<i class="fa fa-plus"></i>
								<span class="menu-hidden-title"><?php _e('Submit new recipe', 'smk_theme') ?></span>
							</a>
						</li>
						<?php 
								endif;
							endif;
						?>

						<?php 
							$show_header_user_menu = get_theme_mod( 'show_header_user_menu' );
							if( !empty( $show_header_user_menu ) ) :

								$user_menu_show_element = get_theme_mod( 'user_menu_show_element', 'avatar' );
								if( 'avatar' == $user_menu_show_element ){
									$usermenu_before = '<div class="user-details-in-menu">';
									$usermenu_after = '</div>';
									$usermenu_link_class = 'user-avatar';
									$usermenu_content = get_avatar( $current_user->ID, 24 );
								}
								elseif( 'username' == $user_menu_show_element ){
									$usermenu_before = '<div class="user-details-in-menu-username">';
									$usermenu_after = '</div>';
									$usermenu_link_class = '';
									$usermenu_content = $current_user->display_name;
								}
								elseif( 'icon' == $user_menu_show_element ){
									$usermenu_before = '';
									$usermenu_after = '';
									$usermenu_link_class = 'menu-single-icon';
									$usermenu_content = '<i class="fa fa-user"></i>';
								}
								
						?>
						<!-- User menu -->
						<li class="to-left-more">
							<?php echo $usermenu_before; ?>
								<a href="<?php echo smk_user_profile_url() ?>" class="<?php echo $usermenu_link_class; ?>" title="<?php _e('Public Profile', 'smk_theme') ?>">
								<?php echo $usermenu_content; ?>
								<span class="menu-hidden-title"><?php _e('Public Profile', 'smk_theme') ?></span>
								</a>
							<?php echo $usermenu_after; ?>
							<ul class="sub-menu">
								<?php 
									$links = array(
										array(
											'url'   => smk_user_profile_url(),
											'label' => __('Public Profile', 'smk_theme'),
											'class' => '',
											'show'  => true,
										),
										// array(
										// 	'url'   => '#',
										// 	'label' => __('Notifications', 'smk_theme'),
										// 	'class' => '',
										// 	'show'  => true,
										// ),
										array(
											'url'   => smk_user_pm_url(),
											'label' => __('Private Messages', 'smk_theme'),
											'class' => '',
											'show'  => true,
										),
										array(
											'url'   => smk_user_settings_url(),
											'label' => __('Settings', 'smk_theme'),
											'class' => 'separator',
											'show'  => true,
										),
										array(
											'url'   => smk_user_recipes_list(),
											'label' => __('My Recipes', 'smk_theme'),
											'class' => '',
											'show'  => true,
										),
										array(
											'url'   => smk_user_collections_url(),
											'label' => __('Collections', 'smk_theme'),
											'class' => '',
											'show'  => false,
										),
										array(
											'url'   => smk_user_favorites_url(),
											'label' => __('Favorites', 'smk_theme'),
											'class' => '',
											'show'  => smk_favorites_enabled(),
										),
										array(
											'url'   => smk_user_likes_url(),
											'label' => __('Likes', 'smk_theme'),
											'class' => '',
											'show'  => smk_likes_enabled(),
										),
										array(
											'url'   => smk_user_reputation_url(),
											'label' => __('Reputation', 'smk_theme'),
											'class' => '',
											'show'  => true,
										),
										array(
											'url'   => smk_user_followers_url(),
											'label' => __('Followers', 'smk_theme'),
											'class' => 'separator',
											'show'  => true,
										),
										array(
											'url'   => wp_logout_url($_SERVER['REQUEST_URI']),
											'label' => __('Sign Out', 'smk_theme'),
											'class' => '',
											'show'  => true,
										),
									);
									$output = '';
									foreach ($links as $link) {
										$class = !empty( $link['class'] ) ? ' class="'. $link['class'] .'"' : '';
										$output .= ( $link['show'] ) ? '<li'. $class .'><a href="'. $link['url'] .'">'. $link['label'] .'</a></li>' : '';
									}
									echo $output;
								?>
							</ul>
						</li><!-- www.scriptha.ir -->
					<?php endif; ?>

					<?php 
					}
					else{
						$auth_links = get_theme_mod('auth_links');
						$custom_login_link = get_theme_mod('custom_login_link');
						$custom_registration_link = get_theme_mod('custom_registration_link');
						$sign_in_link = ( empty($custom_login_link) ) ? '<a href="#" class="smk-theme-link-to-login">'. __('Sign in', 'smk_theme') .'</a>' : '<a href="'. $custom_login_link .'">'. __('Sign in', 'smk_theme') .'</a>';
						$register_link = ( empty($custom_registration_link) ) ? '<a href="#" class="smk-theme-link-to-register">'. __('Register', 'smk_theme') .'</a>' : '<a href="'. $custom_registration_link .'">'. __('Register', 'smk_theme') .'</a>';
					?>
						<li class="to-left-more">
							<?php echo $sign_in_link; ?>
						</li>
						<?php if( $auth_links == 'signin_n_reg' ) : ?>
						<li class="to-left-more">
							<?php echo $register_link; ?>
						</li>
						<?php endif; ?>
					<?php
					}
					?>

					</ul>
				</nav>
			</div>
			
			<!-- <div class="hidden-seach-row">
				<input type="text" name="search" placeholder="<?php _e('Enter the keyword here.', 'smk_theme'); ?>" />
			</div> -->


		</div> <!-- .grid-container -->
	</div> <!-- .rw-inner -->
</div> <!-- .rw-header -->

<!--
// ===================================^__^=================================== //
   Content
// ===================================^__^=================================== //
-->
