<?php
// These settings can be applied only by admins
$special_settings = new Smk_User_Form('special_settings', array(
	'title' => __('Special settings(applied only by admin)', 'smk_theme'),
	'capability' => 'edit_users',
));

$special_settings->addField('st_cooking_level', array(
	'title' => __('Cooking level', 'smk_theme'),
	'type' => 'select',
	'capability' => 'edit_users',
	'options' => array(
		'none' => __('None', 'smk_theme'),
		'beginner' => __('Beginner', 'smk_theme'),
		'intermediate' => __('Intermediate', 'smk_theme'),
		'expert' => __('Expert', 'smk_theme'),
		'professional' => __('Professional', 'smk_theme'),
	),
));

/* Awards
------------------------------------------------*/
function smk_get_user_possible_awards(){
	$awards = array();
	
	$awards['st_award_featured_user'] = array(
		'title' => __('Featured user', 'smk_theme'),
		'color' => 'green',
		'icon' => 'award-icon-businessman',
	);

	$awards['st_award_won_a_competition'] = array(
		'title' => __('Won a competition', 'smk_theme'),
		'color' => 'purple',
		'icon' => 'award-icon-award2',
	);

	$awards['st_award_community_superstar'] = array(
		'title' => __('Coummunity Superstar', 'smk_theme'),
		'color' => 'red',
		'icon' => 'award-icon-fivepointed2',
	);

	$awards['st_award_forum_superstar'] = array(
		'title' => __('Forum Superstar', 'smk_theme'),
		'color' => 'teal',
		'icon' => 'award-icon-fivepointed',
	);

	$awards['st_award_attended_a_meetup'] = array(
		'title' => __('Attended a meetup', 'smk_theme'),
		'color' => 'black',
		'icon' => 'award-icon-man',
	);

	$awards['st_award_beta_tester'] = array(
		'title' => __('Beta Tester', 'smk_theme'),
		'color' => 'blue',
		'icon' => 'award-icon-teacher',
	);

	$awards['st_award_copyright_sheriff'] = array(
		'title' => __('Copyright Sheriff', 'smk_theme'),
		'color' => 'green',
		'icon' => 'award-icon-shield',
	);

	return $awards;
}

$user_awards = new Smk_User_Form('user_awards', array(
	'title' => __('User Awards(applied only by admin)', 'smk_theme'),
	'capability' => 'edit_users',
));

foreach (smk_get_user_possible_awards() as $key => $value) {
	$user_awards->addField($key, array(
		'title' => $value['title'],
		'type' => 'select',
		'capability' => 'edit_users',
		'options' => array(
			'n' => __('No', 'smk_theme'),
			'y' => __('Yes', 'smk_theme'),
		),
	));
}


function smk_get_user_awards( $user_id ){
	$award_fields = smk_get_user_possible_awards();
	$awards = '';
	foreach ($award_fields as $key => $value) {
		$meta = get_user_meta($user_id, $key, true);
		if( !empty($meta) && $meta == 'y' ){
			$awards .= '<span title="'. $value['title'] .'" class="award-single '. $value['color'] .'"><i class="'. $value['icon'] .'"></i></span>';
		}
	}
	return $awards;
}