<?php
/* Favorites
------------------------------------------------*/
function smk_add_activity_added_favorite( $post_id ){
	smk_insert_activity( 'favorite', array(
		'mode'    => 'added',
		'post_id' =>  $post_id,
	));
}
add_action( 'smk_mark_post_favorite_added', 'smk_add_activity_added_favorite');

function smk_add_activity_removed_favorite( $post_id ){
	smk_insert_activity( 'favorite', array(
		'mode'    => 'removed',
		'post_id' =>  $post_id,
	));
}
add_action( 'smk_mark_post_favorite_removed', 'smk_add_activity_removed_favorite');

/* Likes
------------------------------------------------*/
function smk_add_activity_added_like( $post_id ){
	smk_insert_activity( 'like', array(
		'mode'    => 'added',
		'post_id' =>  $post_id,
	));
}
add_action( 'smk_mark_post_like_added', 'smk_add_activity_added_like');

function smk_add_activity_removed_like( $post_id ){
	smk_insert_activity( 'like', array(
		'mode'    => 'removed',
		'post_id' =>  $post_id,
	));
}
add_action( 'smk_mark_post_like_removed', 'smk_add_activity_removed_like');

/* Following
------------------------------------------------*/
function smk_add_activity_followed( $user_id ){
	smk_insert_activity( 'followed', array(
		'user_id' =>  $user_id,
	));
}
add_action( 'smk_followed_user', 'smk_add_activity_followed');

function smk_add_activity_unfollowed( $user_id ){
	smk_insert_activity( 'unfollowed', array(
		'user_id' =>  $user_id,
	));
}
add_action( 'smk_unfollowed_user', 'smk_add_activity_unfollowed');

/* Recipe published
------------------------------------------------*/
function smk_recipe_published_notification( $post_id, $post ) {
	$already_published = get_post_meta( $post_id, 'smk_recipe_already_published', true );
	if( empty($already_published) ){
		$author_id = get_post_field( 'post_author', $post_id );
		smk_insert_activity( 'recipe_published', array(
			'post_id' =>  $post_id,
		), $author_id);
	}
}
add_action( 'publish_smk_recipes', 'smk_recipe_published_notification', 20, 2 );