<?php
/* Favorites
------------------------------------------------*/
function smk_reputation_added_favorite( $post_id ){
	$user_id = get_post_field( 'post_author', $post_id );
	$current_user_id = Smk_Theme_User::currentUserId();
	if( $user_id == $current_user_id ) // do not allow to add self rep.
		return;

	$points = absint( smk_recipe_setting( 'add_to_fav_points', 10 ) );

	smk_insert_user_reputation( 
		$user_id, 
		$points,
		'favorited',
		array(
			'post_id' => $post_id
		)
	);
}
add_action( 'smk_mark_post_favorite_added', 'smk_reputation_added_favorite');

function smk_reputation_removed_favorite( $post_id ){
	$user_id = get_post_field( 'post_author', $post_id );
	$current_user_id = Smk_Theme_User::currentUserId();
	if( $user_id == $current_user_id ) // do not allow to add self rep.
		return;

	$points = absint( smk_recipe_setting( 'add_to_fav_points', 10 ) );

	smk_insert_user_reputation( 
		$user_id, 
		-($points),
		'unfavorited',
		array(
			'post_id' => $post_id
		)
	);

	$sanction_points = absint( smk_recipe_setting( 'sanction_points_for_remove_fav', -2 ) );

	smk_insert_user_reputation( 
		$current_user_id, 
		-($sanction_points), 
		'unfavorited_a_post'
	);
}
add_action( 'smk_mark_post_favorite_removed', 'smk_reputation_removed_favorite');

/* Likes
------------------------------------------------*/
function smk_reputation_like( $post_id ){
	$user_id = get_post_field( 'post_author', $post_id );
	$current_user_id = Smk_Theme_User::currentUserId();
	if( $user_id == $current_user_id ) // do not allow to add self rep.
		return;

	$points = absint( smk_recipe_setting( 'like_recipe_points', 10 ) );

	smk_insert_user_reputation( 
		$user_id, 
		$points, 
		'liked',
		array(
			'post_id' => $post_id
		)
	);
}
add_action( 'smk_mark_post_like_added', 'smk_reputation_like');

function smk_reputation_dislike( $post_id ){
	$user_id = get_post_field( 'post_author', $post_id );
	$current_user_id = Smk_Theme_User::currentUserId();
	if( $user_id == $current_user_id ) // do not allow to add self rep.
		return;

	$points = absint( smk_recipe_setting( 'like_recipe_points', 10 ) );

	smk_insert_user_reputation( 
		$user_id, 
		-($points), 
		'disliked',
		array(
			'post_id' => $post_id
		)
	);

	$sanction_points = absint( smk_recipe_setting( 'sanction_points_for_dislike', -2 ) );

	smk_insert_user_reputation( 
		$current_user_id, 
		-($sanction_points), 
		'disliked_a_post'
	);
}
add_action( 'smk_mark_post_like_removed', 'smk_reputation_dislike');

/* Recipe published
------------------------------------------------*/
function smk_reputation_recipe_published( $post_id, $post ) {
	$already_published = get_post_meta( $post_id, 'smk_recipe_already_published', true );
	if( empty($already_published) ){
		$user_id = get_post_field( 'post_author', $post_id );
		$points = absint( smk_recipe_setting( 'publish_recipe_points', 50 ) );
		smk_insert_user_reputation( 
			$user_id, 
			$points, 
			'recipe_published',
			array(
				'post_id' => $post_id
			)
		);
	}
}
add_action( 'publish_smk_recipes', 'smk_reputation_recipe_published', 20, 2 );

/* Recipe published update meta
------------------------------------------------*/
function smk_reputation_recipe_published_meta_already( $post_id, $post ) {
	$already_published = get_post_meta( $post_id, 'smk_recipe_already_published', true );
	if( empty($already_published) ){
		update_post_meta( $post_id, 'smk_recipe_already_published', 'yes' );
	}
}
add_action( 'publish_smk_recipes', 'smk_reputation_recipe_published_meta_already', 99, 2 );