<?php
function smk_comments_args( $args = array() ){
	$comments_args = array(
		'avatar_size' => 80,
		'style' => 'ul',
		'callback' => 'smk_theme_comment_template'
	);
	return wp_parse_args( $args, $comments_args );
}

function smk_theme_comment_template($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment;
	extract($args, EXTR_SKIP);

	$tag =  ( 'div' == $args['style'] ) ? 'div' : 'li';
	$add_below = 'comment-inner';
?>
	<<?php echo $tag ?> <?php comment_class( empty( $args['has_children'] ) ? '' : 'parent' ) ?> id="comment-<?php comment_ID() ?>">

	<div class="comment-avatar">
		<?php if ( $args['avatar_size'] != 0 ) echo get_avatar( $comment, $args['avatar_size'] ); ?>
	</div>
	
	<div class="content">
		<div id="comment-inner-<?php comment_ID() ?>">
			<div class="comment-header">

				<?php 
					if( $comment->user_id > 0 ){
						echo '<a href="'. get_author_posts_url( $comment->user_id ) .'">'. get_user_option( 'display_name', $comment->user_id ) .'</a>';
					}
					else{
						printf( __( '%s', 'smk_theme' ), get_comment_author_link() );
					}
				?>
				<?php  ?>
				<span class="comment-time"><?php printf( __('%1$s', 'smk_theme'), get_comment_date() ); ?></span>
				<?php 
					comment_reply_link( array_merge( $args, 
						array( 
							'add_below' => $add_below, 
							'depth' => $depth, 
							'max_depth' => $args['max_depth'] 
						) 
					) ); 
				?>

				<div class="comment-vote">
					<?php 
						$rating = new Smk_Recipes_Rating;
						echo $rating->getStars(); 
					?>
				</div>
			</div>
			<?php if ( $comment->comment_approved == '0' ) { ?>
				<em class="text-red"><?php _e( 'Your comment is awaiting moderation.', 'smk_theme' ); ?></em><br />
			<?php } ?>
			<?php comment_text(); ?>
		</div>
	</div>

<?php 
}

// function smk_comments_ajax_submit(){
// 	if( isset($_POST) && !empty($_POST) ){
	
// 		$form_data = !empty($_POST['data']) ? $_POST['data'] : false;
// 		if( empty( $form_data ) ) die( '100' );

// 		parse_str($form_data, $data); // Convert jQuery serialized data to a PHP array
// 		// print_r( $data );

// 		$comm_data = array();

// 		if( is_user_logged_in() ) {
// 			$user                              = Smk_Theme_User::currentUser();
// 			$comm_data['user_id']              = $user->ID;
// 			$comm_data['comment_author']       = $user->display_name;
// 			$comm_data['comment_author_email'] = $user->user_email;
// 			$comm_data['comment_author_url']   = $user->user_url;
// 		}
// 		else{
// 			$comm_data['comment_author']       = $data['author'];
// 			$comm_data['comment_author_email'] = $data['email'];
// 			$comm_data['comment_author_url']   = $data['url'];
// 		}

// 		$comm_data['comment_post_ID']  = ( absint( $data['comment_post_ID'] ) > 0 ) ? absint( $data['comment_post_ID'] ) : false;
// 		$comm_data['comment_content']  = $data['comment'];
// 		$comm_data['comment_type']     = '';
// 		$comm_data['comment_parent']   = absint( $data['comment_parent'] );
// 		$comm_data['comment_agent']    = $_SERVER['HTTP_USER_AGENT'];
// 		$comm_data['comment_date']     = current_time('mysql');
// 		$comm_data['comment_approved'] = 1;

// 		//User IP
// 		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
// 			$ip = $_SERVER['HTTP_CLIENT_IP'];
// 		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
// 			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
// 		} else {
// 			$ip = $_SERVER['REMOTE_ADDR'];
// 		}
// 		$comm_data['comment_author_IP'] = $ip;

// 		$new_comment = wp_new_comment($comm_data);

// 		comments_template();
					
// 	}
// 	die();
// }
// add_action('wp_ajax_smk_comments_ajax_submit', 'smk_comments_ajax_submit' );
// add_action('wp_ajax_nopriv_smk_comments_ajax_submit', 'smk_comments_ajax_submit' ); //Only for non-logged in users