<?php
function smk_get_activity( $users ){
	$query = array (
		'post_type'      => 'smk_activities',
		'posts_per_page' => 20,
		'paged'          => smk_theme_current_pag(),
		'author__in'     => (array) $users,
	);
	$activ_query = new WP_Query($query);
	echo '<div class="profile-notifications clearfix">';
	if ($activ_query->have_posts()) {
		while ($activ_query->have_posts()) : 
			$activ_query->the_post();
			$activity_type     = get_post_meta( get_the_ID(), 'smk_activity_type', true);
			$activity_settings = get_post_meta( get_the_ID(), 'smk_activity_settings', true);
			$act_author_link   = '<a href="'. get_author_posts_url( get_the_author_meta( 'ID' ) ) .'">'. get_the_author_meta( 'display_name' ) .'</a>';
			$act_author_avatar = '<a href="'. get_author_posts_url( get_the_author_meta( 'ID' ) ) .'" title="'. get_the_author_meta( 'display_name' ) .'">'. get_avatar( get_the_author_meta( 'ID' ), 80 ) .'</a>';
			$activity_title    = '';
			$class = '';
			$icon  = '';
			$action_title = '';
			$image_preview = '';

			switch ($activity_type) {
				case 'favorite':
					if( $activity_settings['mode'] == 'added' ){
						$activity_title = sprintf( __('%1$s added to favorites:', 'smk_theme'), $act_author_link);
						$class = 'to-favorites';
						$icon = 'fa-heart';
					}
					elseif( $activity_settings['mode'] == 'removed' ){
						$activity_title = sprintf( __('%1$s removed from favorites:', 'smk_theme'), $act_author_link);
						$class = 'favorites-removed';
						$icon = 'fa-heart-o';
					}
					$action_title = '<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'">'. get_the_title( $activity_settings['post_id'] ) .'</a>';
					$img_id = get_post_thumbnail_id( $activity_settings['post_id'] );
					if ( !empty($img_id) ) {
						$image_preview = '<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'"><img src="'. smk_theme_resize( wp_get_attachment_url( $img_id ), 460, 460, true) .'" alt="" /></a>';
					}
					break;
				
				case 'like':
					if( $activity_settings['mode'] == 'added' ){
						$activity_title = sprintf( __('%1$s liked:', 'smk_theme'), $act_author_link);
						$class = 'liked';
						$icon = 'fa-thumbs-up';
					}
					elseif( $activity_settings['mode'] == 'removed' ){
						$activity_title = sprintf( __('%1$s disliked:', 'smk_theme'), $act_author_link);
						$class = 'disliked';
						$icon = 'fa-thumbs-o-down';
					}
					$action_title = '<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'">'. get_the_title( $activity_settings['post_id'] ) .'</a>';
					$img_id = get_post_thumbnail_id( $activity_settings['post_id'] );
					if ( !empty($img_id) ) {
						$image_preview = '<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'"><img src="'. smk_theme_resize( wp_get_attachment_url( $img_id ), 460, 460, true) .'" alt="" /></a>';
					}
					break;
				
				case 'followed':
				case 'unfollowed':
					
					$user_un_or_followed = '<a href="'. get_author_posts_url( $activity_settings['user_id'] ) .'">'. get_the_author_meta( 'display_name', $activity_settings['user_id'] ) .'</a>';
					
					if($activity_type == 'followed'){
						$activity_title = sprintf( __('%1$s followed %2$s', 'smk_theme'), $act_author_link, $user_un_or_followed );
						$class = 'followed';
						$icon = 'fa-check';
					}
					else{
						$activity_title = sprintf( __('%1$s unfollowed %2$s', 'smk_theme'), $act_author_link, $user_un_or_followed );
						$class = 'unfollowed';
						$icon = 'fa-close';
					}

					$image_preview = '<a href="'. get_author_posts_url( $activity_settings['user_id'] ) .'">'. get_avatar( $activity_settings['user_id'], 80 ) .'</a>';
					break;

				case 'recipe_published':

					$activity_title = sprintf( __('%1$s submitted a new recipe:', 'smk_theme'), $act_author_link);
					$class = 'recipe-published';
					$icon = 'fa-plus';

					$action_title = '
						<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'">'. get_the_title( $activity_settings['post_id'] ) .'</a>
						<div class="the-excerpt">'. smk_theme_excerpt(35, '...', false, $activity_settings['post_id']) .'</div>
					';
					$img_id = get_post_thumbnail_id( $activity_settings['post_id'] );
					if ( !empty($img_id) ) {
						$image_preview = '<a href="'. get_the_permalink( $activity_settings['post_id'] ) .'"><img src="'. smk_theme_resize( wp_get_attachment_url( $img_id ), 460, 460, true) .'" alt="" /></a>';
					}
					break;
				
				
				default:
					# code...
					break;
			}

			$link = esc_url( add_query_arg( array( 
				'action'    => 'smk_recipes_remove_activity',
				'recipe-id' => get_the_ID(),
				'_nonce'    => wp_create_nonce('smk_recipes_remove_activity'), 
			) ) );

			$remove_activity = ( current_user_can('edit_users') ) ? '<a href="'. $link .'" class="smk-recipes-remove-activity">'. __('Remove', 'smk_theme') .'</a>' : '';
			echo '<div class="single-notification '. $class .' clearfix">
				<div class="user-photo">'. $act_author_avatar .'</div>
				<div class="the-sign">
					<i class="the-icon fa '. $icon .'"></i>
				</div>
				<div class="image-preview">'. $image_preview .'</div>
				<div class="type">'. $activity_title .'</div>
				<div class="title">'. $action_title .'</div>
				<div class="date">'. smk_post_date('j F Y, H:m', false) .'</div>
				<div class="clear"></div>
				'. $remove_activity .'
			</div>
			<div class="clear"></div>';


		endwhile; 
		smk_theme_pagination($activ_query);
	}
	else{
		echo '<div class="notification red super-light center">'. __('No recent activity.', 'smk_theme') .'</div>';
	}
	echo '</div>';

}