<?php
function smk_get_user_reputation_log( $user_id ){
	$args = array(
		'author' => $user_id, 
		'post_type' => 'smk_user_reputation',
		'orderby' => 'date',
		'order' => 'DESC',
		'posts_per_page' => -1,
	);
	$the_query = new WP_Query( $args );

	// The Loop
	if ( $the_query->have_posts() ) {
		echo'<div class="grid-container">';
			echo'<div class="profile-reputation">';
			while ( $the_query->have_posts() ) {
				$the_query->the_post();

				$post_id = get_the_ID();

				$total_per_today = get_post_meta( $post_id, 'smk_reputation_total', true );
				$post_msg        = get_post_meta( $post_id, 'smk_reputation_reasons', true );

				if( !empty($post_msg) ){
					$post_msg = array_reverse($post_msg, true);
					foreach ($post_msg as $key => $msg) {
						$color  = ( $msg['value'] > 0 ) ? ' green' : ' red';
						if( $msg['value'] > 100 ) {
							$color  = ' blue';
						}
						if( $msg['value'] > 500 ) {
							$color  = ' purple';
						}
						$prefix = ( $msg['value'] > 0 ) ? '+' : '';

						$the_post_id = 0;
						$other_settings = ( !empty( $msg['other_settings'] ) ) ? $msg['other_settings'] : false;
						if( $other_settings ){
							$the_post_id = ( !empty( $other_settings['post_id'] ) ) ? $other_settings['post_id'] : 0;
						}

						switch ( $msg['reason'] ) {
							case 'favorited':
							case 'favorite':
								$reason = sprintf( __('A user added "%s" to favorites.', 'smk_theme'), get_post_field( 'post_title', $the_post_id ));
								break;

							case 'unfavorited':
								$reason = sprintf( __('A user removed "%s" from favorites.', 'smk_theme'), get_post_field( 'post_title', $the_post_id ));
								break;
							
							case 'liked':
							case 'like':
								$reason = sprintf( __('A user liked: "%s".', 'smk_theme'), get_post_field( 'post_title', $the_post_id ));
								break;

							case 'disliked':
								$reason = sprintf( __('A user disliked: "%s".', 'smk_theme'), get_post_field( 'post_title', $the_post_id ));
								break;
							
							case 'recipe_published':
								$rp_title = get_post_field( 'post_title', $the_post_id );
								$rp_url = '<a href="'. get_permalink( $the_post_id ) .'">'. $rp_title .'</a>';
								$reason = sprintf( __('Submitted the recipe "%s"', 'smk_theme'), $rp_url);
								break;
							
							case 'unfavorited_a_post':
								$reason = __('Removed a recipe from favorites.', 'smk_theme');
								break;
							
							case 'disliked_a_post':
								$reason = __('Disliked a recipe.', 'smk_theme');
								break;
							
							default:
								$reason = $msg['reason'];
								break;
						}

						$link_remove = esc_url( add_query_arg( array( 
							'action' => 'smk_recipes_remove_reputation',
							'activity' => get_the_ID(),
							'key'      => $key,
							'_nonce'   => wp_create_nonce('smk_recipes_remove_reputation'), 
						) ) );

						$remove = ( current_user_can('edit_users') ) ? ' <a href="'. $link_remove .'" class="smk-recipes-remove-reputation">'. __('Remove', 'smk_theme') .'</a>' : '';

						echo '<div class="reputation-event clearfix">
							<div class="grid desk-1 points"><span class="mark'. $color .'">'. $prefix . $msg['value'] .'</span></div>
							<div class="grid desk-3 date"><span>'. date("d F Y, H:i:s", $msg['time']) .'</span></div>
							<div class="grid desk-8 text">'. $reason . $remove .'</div>
						</div>';
					}
				}

			}
			echo'</div>';
		echo'</div>';
	} else {
		echo '<div class="notification orange light">' . __('No active reputation records.', 'smk_theme') . '</div>';
	}
	/* Restore original Post Data */
	wp_reset_postdata();
}