<?php
function smk_get_members_list( $include = false, $type = false, $parent_user_id = false ){
	
	$follow = new Smk_Theme_User_Follow;

	$per_page     = 20;
	$current_page = smk_theme_current_pag();

	$args = array(
		'orderby' => 'ID',
		'order' => 'ASC',
		'number' => $per_page, // Users per page
		'offset' => $per_page *( $current_page - 1 ), 
	);
	if( is_array( $include ) ){
		$args['include'] = $include;
	}
	$all_users = new WP_User_Query( $args );

	// User Loop
	if ( ! empty( $all_users->results ) ) {
		echo '<div class="members-list grid-container">';
		$index = 1;
		foreach ( $all_users->results as $user ) {

			$followers = new Smk_Theme_User_Followers($user->ID);
			$reputation = new Smk_Theme_User_Reputation($user->ID);
			$last_visit = new Smk_Theme_User_LastVisit($user->ID);
			?>
			<div class="grid desk-6">
				<div class="member clearfix">
					<div class="user-avatar">
						<a href="<?php echo get_author_posts_url( $user->ID ); ?>"><?php echo get_avatar( $user->user_email, '80' ); ?></a>
					</div>
					<div class="user-details grid desk-7 mob-6 alpha clearfix">
						<div class="title clearfix">
							<a href="<?php echo get_author_posts_url( $user->ID ); ?>" class="name"><?php echo $user->display_name; ?></a>
							<?php if( in_array(smk_user_cooking_level($user->ID, 'level'), array('expert', 'professional' ) ) ){ ?>
							<span class="user-level mark <?php echo smk_user_cooking_level($user->ID, 'color'); ?>"><?php echo smk_user_cooking_level($user->ID); ?></span>
							<?php } ?>
						</div>
						<div class="info">
							<div class="info-item"><?php printf( __('%d recipes', 'smk_theme'), smk_get_total_user_recipes( $user->ID ) ); ?></div>
							<div class="info-item user-reputation">
								<span class="count"><?php echo $reputation->show(); ?></span>
								<span class="text"><?php echo _x('points', 'noun', 'smk_theme') ?></span>
							</div>
						</div><!-- www.scriptha.ir -->
					</div>
					<div class="user-follow grid desk-5 mob-6 omega clearfix">
						<?php echo $follow->button( $user->ID ); ?><br>
						<a href="#" class="followers-count"><?php echo $followers->totalFollowers() .' '. __('followers', 'smk_theme'); ?></a>
					</div>
				</div>
			</div>
			<?php
			if( $index == 2 ) echo '<div class="clear"></div>';
			$index++;
			$index = ( $index > 2 ) ? 1 : $index;
		}
		echo '</div> <!-- .members-list -->';

		$total_users = !empty($all_users->total_users) ? absint($all_users->total_users) : 0;
		$total_pages = ( $total_users > 0 ) ? ceil( $total_users / $per_page ) : 1;
		smk_theme_pagination( $total_pages, array( 'block_class' => 'members-pagination' ) );

	} else {
		echo 'No users found.';
	}
}
