<?php
if( class_exists('Smk_PageBuilder_Module') && !class_exists( 'Smk_Theme_PBM_Home_Forums_List' ) ) {
	class Smk_Theme_PBM_Home_Forums_List extends Smk_PageBuilder_Module {

		function settings(){
			return array(
				'title'    => __('Home forums list', 'smk_theme'),
				'desc'     =>  __('Show a list with the latest active topics from the forum.', 'smk_theme'),
				'category' => 'content theme_defined',
			);
		}

		function form(){
			return array(

				array(
					'id' 	=> 'title',
					'type' 	=> 'input',
					'label' => __('Title:', 'smk_theme'),
					'std' 	=> __('Forums activity', 'smk_theme'),
				),
				array(
					'id' 	=> 'per_page',
					'type' 	=> 'sliderui',
					'label' => __('Max number of topics to display:', 'smk_theme'),
					'min' 	=> '2',
					'max' 	=> '40',
					'std' 	=> '5',
				),

			);
		}
		
		function render($data){
			$title    = ( !empty($data['title']) ) ? esc_html($data['title']) : '';
			$per_page = ( !empty($data['per_page']) && absint($data['per_page']) > 2 ) ? absint($data['per_page']) : 5;

			?>
			<div class="grid-container clearfix">
				<div class="grid desk-12">
					<h4><?php echo esc_html($title); ?></h4>
				</div>
				<?php
				if( function_exists('bbpress') ){
					$query_topics = array( 
						'author'         => 0, 
						'show_stickies'  => false, 
						'order'          => 'DESC', 
						'posts_per_page' => $per_page,
						'meta_key'       => '_bbp_last_active_time',
						'orderby'        => 'meta_value',
						'post_parent'    => 'any',
					);

					if ( bbp_has_topics( $query_topics ) ){
						while ( bbp_topics() ) : bbp_the_topic();
						?>

							<div class="grid desk-12">
								<div class="pb-topic-on-home clearfix">

									<?php 
										$topic_author_id = get_the_author_meta( 'ID' );
										echo '<a href="'. bbp_get_topic_permalink() .'" class="author-avatar">';
											echo get_avatar( $topic_author_id, 80 );
										echo '</a>'; 
									?>

									<div class="entry-title">
										<a class="topic-title" href="<?php bbp_topic_permalink(); ?>"><?php 
											if( bbp_is_topic_closed() ){
												echo '<span class="topic-status closed">'. __('Closed', 'smk_theme') .'</span>';
											}
											bbp_topic_title();
										?></a>
									</div>

									<div class="enty-topic-info">
										<?php 
											$topic_last_author_id = get_post_field( 'post_author', bbp_get_topic_last_active_id() );
											$last_reply_id = bbp_get_topic_last_reply_id(); 
											$excerpt = smk_theme_excerpt(10, "...", false, $last_reply_id); 
											printf( 
												__('%s: %s', 'smk_theme'),
												' <a href="'. get_author_posts_url( $topic_last_author_id ) .'">' . get_user_option( 'display_name', $topic_last_author_id ) .'</a>',
												$excerpt
											);
										?>
									</div>
									<div class="topic-time"><?php echo bbp_get_topic_freshness_link(); ?></div>

								</div> <!-- .pb-topic-on-home -->
							</div>

						<?php
						endwhile;
					}
					else{
						echo '<div class="notification orange light">' . __('Sorry, no posts matched your criteria.', 'smk_theme') . '</div>';
					}
				}
				wp_reset_postdata();
				?>
			</div>
			<?php
		}

	}//class
}//check class_exists