<?php
if( class_exists('Smk_PageBuilder_Module') ){
	
	$files = array(
		'featured-recipe',
		'home-recipes-list',
		'home-blog-list',
		'home-forums-list',
		'top-authors',
		'rev-slider',
	);

	foreach ( $files as $value) {
		require SMK_THEME_INCLUDES . 'page-builder/' . $value .'.php';
	}

	//Register PBMs
	if( class_exists('Smk_PageBuilder_ModuleInit') ) {
		$reg_modules = new Smk_PageBuilder_ModuleInit();
		$reg_modules->register(
			array(
				'smk_theme_pbm_featured_recipe'   => 'Smk_Theme_PBM_Featured_Recipe',
				'smk_theme_pbm_home_recipes_list' => 'Smk_Theme_PBM_Home_Recipes_List',
				'smk_theme_pbm_home_blog_list'    => 'Smk_Theme_PBM_Home_Blog_List',
				'smk_theme_pbm_home_forums_list'  => 'Smk_Theme_PBM_Home_Forums_List',
				'smk_theme_pbm_home_top_authors'  => 'Smk_Theme_PBM_Home_Top_Authors',
				'smk_theme_pbm_rev_slider'        => 'Smk_Theme_PBM_RevSlider',
			)
		);
	}
	//Register a new PBM category
	if( class_exists('Smk_PageBuilder_ModuleCategory') ) {
		new Smk_PageBuilder_ModuleCategory(array(
			'theme_defined' => __('Theme Defined', 'smk_theme'),
		));
	}//check class_exists

	//Add page builder row style
	function smk_theme_page_builder_row_settings_styles($styles){
		$styles[] = array(
			'val'   => 'dark',
			'color' => '#383D46',
			'label' => __('Dark', 'smk_theme'),
		);
		return $styles;
	}
	add_filter('smk_page_builder_row_settings_style', 'smk_theme_page_builder_row_settings_styles');

}