<?php
/**
 * Revolution Slider
 *
 * This is a module designed for SMK Toolkit Page Builder. It is included in a theme
 * available for sale on themeforest.
 * If you own a separate license for SMK Toolkit and want to build custom modules for
 * a personal or commercial theme then you are free to use or modify the following code
 * as you want. Happy coding.
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( class_exists( 'Smk_PageBuilder_Module' ) && 
	class_exists( 'RevSlider' ) && 
  ! class_exists( 'Smk_Theme_PBM_RevSlider' ) 
) {
	class Smk_Theme_PBM_RevSlider extends Smk_PageBuilder_Module {

		function settings(){
			return array(
				'title' => __('Revolution Slider', 'smk_theme'),
				'icon'  => array(
					// 'class' => 'bars2',
					// 'color' => '#EE8248',
				),
				'desc' =>  __('Insert a revolution slider that you already created. This module is not recomented for small columns.', 'smk_theme'),
				'category' => 'media plugins theme_defined',
			);
		}

		function all_rev_sliders_in_array(){
			if (class_exists('RevSlider')) {
				$theslider 	= new RevSlider();
				$arrSliders = $theslider->getArrSliders();
				$arrA 	= array();
				$arrT 	= array();
				foreach($arrSliders as $slider){
					$arrA[] 	= $slider->getAlias();
					$arrT[] 	= $slider->getTitle();
				}
				if($arrA && $arrT){
					$result = array_combine($arrA, $arrT);
				}
				else
				{
					$result = array();
				}
				return $result;
			}
			else{
				return array();
			}
		}

		function form(){
			$form = array(

				array(
					'id' 	=> 'slider',
					'type' 	=> 'select',
					'label' => __('Select slider','smk_theme'),
					'std' 	=> '',
					'options' => $this->all_rev_sliders_in_array(),
					// 'set'   => array(
					// 	'grid' => 6,
					// 	'grid_pos' => 'first',
					// ),
				),
					

			);
			return $form;
		}

		function render($data){

			// Data
			$slider = SMK_Get::value($data, 'slider', '');
			if( !empty($slider) ){
				if( function_exists('putRevSlider') ){
					putRevSlider( $slider );
				}
			}

		}


	}//class
}//check class_exists
