<?php
if( class_exists('Smk_PageBuilder_Module') && !class_exists( 'Smk_Theme_PBM_Home_Top_Authors' ) ) {
	class Smk_Theme_PBM_Home_Top_Authors extends Smk_PageBuilder_Module {

		function settings(){
			return array(
				'title'    => __('Top authors', 'smk_theme'),
				'desc'     =>  __('Display the authors ordered by the reputation.', 'smk_theme'),
				'category' => 'content theme_defined',
			);
		}

		function form(){
			return array(

				array(
					'id' 	=> 'title',
					'type' 	=> 'input',
					'label' => __('Title:', 'smk_theme'),
					'std' 	=> __('Top authors', 'smk_theme'),
				),
				array(
					'id' 	=> 'per_page',
					'type' 	=> 'sliderui',
					'label' => __('Max number of authors to display:', 'smk_theme'),
					'min' 	=> '2',
					'max' 	=> '40',
					'std' 	=> '12',
				),

			);
		}
		
		function render($data){
			$title    = ( !empty($data['title']) ) ? esc_html($data['title']) : '';
			$per_page = ( !empty($data['per_page']) && absint($data['per_page']) > 2 ) ? absint($data['per_page']) : 8;
			
			global $wpdb;
			$query = "SELECT um1.user_id, um1.meta_value
				FROM $wpdb->usermeta um1
				WHERE um1.meta_key = 'st_reputation'
				ORDER BY CAST(um1.meta_value AS SIGNED) DESC
				LIMIT $per_page";
				
			$all_users = $wpdb->get_results($query);
			
			if ( ! empty( $all_users ) ) {
				?>
				<div class="grid-container">
					<div class="grid desk-12">
						<h4><?php echo $title ?></h4>
						<div class="home-authors clearfix">
							<?php
								foreach ($all_users as $user) {
									$user_id    = $user->user_id;
									$reputation = new Smk_Theme_User_Reputation($user_id);
									$user_url   = get_author_posts_url( $user_id );
								?>
									<a href="<?php echo $user_url; ?>" class="author" title="<?php echo get_user_option( 'display_name', $user_id ) .' - '. $reputation->show(); ?>">
										<?php echo get_avatar( $user_id, '80' ); ?>
									</a>
								<?php
								}
							?>
						</div>
					</div>
				</div>
				<div class="clear"></div>
				<?php
			}
			wp_reset_query();
		}

	}//class
}//check class_exists