<?php
function smk_theme_page_title( $custom_title = '' ) {

	$the_title = '';

	if( !empty( $custom_title ) ){
		$the_title = $custom_title;
	}
	elseif( function_exists('bbp_is_forum') && bbp_is_forum() ){
		$the_title = bbp_title('', '');
	}
	elseif( function_exists('woocommerce_page_title') && is_woocommerce() ){
		$the_title = woocommerce_page_title();
	}
	elseif( function_exists('is_smk_recipes') && is_smk_recipes() ){
		$the_title = smk_recipes_page_title();
	}
	elseif (is_archive()) {
		$term = get_term_by('slug', get_query_var('term'), get_query_var('taxonomy'));
		if ($term) {
			$the_title = $term->name;
		} 
		elseif (is_post_type_archive()) {
			$the_title = get_queried_object()->labels->name;
		} 
		elseif (is_day()) {
			$the_title = sprintf(__('Daily Archives: %s', 'smk_theme'), '<em>' . get_the_date() .'</em>');
		} 
		elseif (is_month()) {
			$the_title = sprintf(__('Monthly Archives: %s', 'smk_theme'), '<em>' . get_the_date('F Y') .'</em>');
		} 
		elseif (is_year()) {
			$the_title = sprintf(__('Yearly Archives: %s', 'smk_theme'), '<em>' . get_the_date('Y') .'</em>');
		} 
		elseif (is_author()) {
			$author = get_queried_object();
			$the_title = $author->display_name;
		} 
		else {
			$the_title = single_cat_title('', false);
		}
	} 
	elseif (is_search()) {
		$the_title = sprintf(__('Search Results for: %s', 'smk_theme'), '<em>' . get_search_query() .'</em>');
	} 
	elseif (is_404()) {
		$the_title = __('Not Found', 'smk_theme');
	} 
	elseif (is_home()) {
		$page_for_posts_id = get_option('page_for_posts');
		$the_title = get_the_title($page_for_posts_id);
	}
	else {
		$the_title = get_the_title();
	}

	return $the_title;
}
