<?php 
	$author = Smk_Theme_User::currentAuthor();
	$user   = Smk_Theme_User::currentUser();

	$reputation = new Smk_Theme_User_Reputation;
	$last_visit = new Smk_Theme_User_LastVisit;
	$profile_views = new Smk_Theme_User_ProfileViews;
	$following = new Smk_Theme_User_Following;
	$followers = new Smk_Theme_User_Followers;
	$registration_date = new Smk_Theme_User_RegistrationDate;

	$section = isset($_GET['profile-section']) ? sanitize_text_field( $_GET['profile-section'] ) : false;

	$profile_views->updateViews();
?>
			<div class="rw-row subtle">
				<div class="grid-container">

					<div class="grid desk-12">
						<ul class="profile-mini-menu">
							<?php
							if( $section && in_array($section, array('pm', 'settings', 'all-recipes')) ){
								echo '<li class="link"><a href="'. smk_user_profile_url( $author->ID ) .'"><i class="fa fa-arrow-left"></i> '. __('Summary', 'smk_theme') .'</a></li>';
							}
							else{
								echo '<li class="active"><a href="#user-summary">'. __('Summary', 'smk_theme') .'</a></li>';
								if( !empty($author->description) ) {
									echo '<li><a href="#user-about">'. __('About', 'smk_theme') .'</a></li>';
								}
								if( $user->ID !== $author->ID){
									echo '<li><a href="#user-send-pm">'. __('Send PM', 'smk_theme') .'</a></li>';
								}
							}


							if( $user->ID == $author->ID || current_user_can('create_users') ){
								$active = ( $section == 'settings' ) ? ' active' : '';
								echo '<li class="right link'. $active .'">
									<a href="'. smk_user_settings_url( $author->ID ) .'"><i class="fa fa-cog"></i> '. __('Settings', 'smk_theme') .'</a>
								</li>';

								$active = ( $section == 'pm' ) ? ' active' : '';
								echo '<li class="right link'. $active .'">
									<a href="'. smk_user_pm_url( $author->ID ) .'"><i class="fa fa-envelope"></i> '. __('PM', 'smk_theme') .'</a>
								</li>';


								if( $user->ID != $author->ID ){
									$rep_list = __('Recipes', 'smk_theme');
								}
								else{
									$rep_list = __('My recipes', 'smk_theme');
								}
								$active = ( $section == 'all-recipes' ) ? ' active' : '';
								echo '<li class="right link'. $active .'">
									<a href="'. smk_user_recipes_list( $author->ID ) .'"><i class="fa fa-book"></i> '. $rep_list .'</a>
								</li>';
							}
							?>
						</ul> <!-- .profile-mini-menu -->
					</div>
					<div class="clear"></div>

				<?php if( ! in_array( $section, array('pm', 'settings', 'all-recipes')) ) : ?>

					<div class="grid desk-3">
						<div class="profile-avatar">
							<a href="<?php echo get_author_posts_url( $author->ID ); ?>"><?php echo get_avatar( $author->ID, 256 ); ?></a>
							<div class="social-block">
								<div class="profiles clearfix">
									<?php 
										$networks = array(
											'st_social_facebook' => 'Facebook',
											'st_social_twitter' => 'Twitter',
											'st_social_google_plus' => 'Google+',
											'st_social_vimeo' => 'Vimeo',
											'st_social_youtube' => 'YouTube',
										);
										foreach ($networks as $key => $title) {
											$meta = get_user_meta($author->ID, $key, true);
											$class = str_replace('+', '-plus', strtolower($title));
											$addon = ( $title == 'Vimeo') ? '-square' : '';
											if( !empty($meta) ){
												echo '
												<a href="'. esc_url($meta) .'" title="'. $title .'" class="social-profile '. $class .'">
													<i class="fa fa-'. $class . $addon .'"></i>
												</a>
												';
											}
										}
									?>
								</div>
							</div> <!-- .social-block -->
						</div> <!-- .profile-avatar -->
					</div>

					<div class="grid desk-9">

						<div id="user-summary" class="profile-user-tab active">
							<div class="grid desk-6 alpha">
								<ul class="profile-rows">
									<?php 
										$cook_level = smk_user_cooking_level($author->ID, 'level');
										if( !empty($cook_level) && $cook_level !== 'none' ) :
									?>
										<li>
											<i class="the-icon fa fa-cutlery"></i>
											<span class="the-label"><?php _e('Cooking Level:', 'smk_theme'); ?> </span>
											<?php echo '<span class="the-value mark '. smk_user_cooking_level($author->ID, 'color') .'">'. smk_user_cooking_level($author->ID) .'</span>'; ?>
										</li>
									<?php
										endif;
									?>
									<li>
										<i class="the-icon fa fa-history"></i>
										<span class="the-label"><?php echo $last_visit->getTitle(); ?>: </span>
										<?php 
											$last_visit_color = $last_visit->color();
											$last_visit_color = ! empty( $last_visit_color ) ? $last_visit_color : 'light-gray';
										?>
										<span class="the-value mark <?php echo $last_visit_color; ?>" title="<?php echo $last_visit->dateAndTime(); ?>"><?php echo $last_visit->show(); ?></span>
									</li>
									<li>
										<i class="the-icon fa fa-child"></i>
										<span class="the-label"><?php echo $registration_date->getTitle(); ?>: </span>
										<span class="the-value mark light-gray"><?php echo $registration_date->show(); ?></span>
									</li>
									<li>
										<i class="the-icon fa fa-eye"></i>
										<span class="the-label"><?php echo $profile_views->getTitle(); ?>: </span>
										<span class="the-value mark light-gray"><?php echo $profile_views->show(); ?></span>
									</li>

									<?php 
									$location = get_user_meta($author->ID, 'st_location', true);
									if( !empty($location) ){
									?>
									<li>
										<i class="the-icon fa fa-home"></i>
										<span class="the-label"><?php _e('Living In:', 'smk_theme'); ?> </span>
										<span class="the-value"><?php echo $location; ?></span>
									</li>
									<?php } ?>
									<?php if( !empty($author->user_url) ){ ?>
									<li>
										<i class="the-icon fa fa-globe"></i>
										<span class="the-label"><?php _e('Website:', 'smk_theme'); ?> </span>
										<span class="the-value"><a href="<?php echo $author->user_url; ?>"><?php echo $author->user_url; ?></a></span>
									</li>
									<?php } ?>
								</ul>
							</div>
							<div class="grid desk-6 omega">
								<div class="following-block clearfix">
									<div class="follow-col reputation">
										<div class="follow-col-in">
											<a href="<?php echo smk_user_reputation_url( $author->ID ); ?>"><span class="count"><?php echo $reputation->show(); ?></span><span class="title"><?php echo $reputation->getTitle(); ?></span></a>
										</div>
									</div>
									<div class="follow-col followers">
										<div class="follow-col-in">
											<a href="<?php echo smk_user_followers_url( $author->ID ); ?>"><span class="count"><?php echo $followers->totalFollowers(); ?></span><span class="title"><?php echo $followers->getTitle(); ?></span></a>
										</div>
									</div>
									<div class="follow-col following">
										<div class="follow-col-in">
											<a href="<?php echo smk_user_following_url( $author->ID ); ?>"><span class="count"><?php echo $following->totalFollowing(); ?></span><span class="title"><?php echo $following->getTitle(); ?></span></a>
										</div>
									</div>
								</div>
								<div class="clear"></div>

								<?php 
									$user_awards = smk_get_user_awards( $author->ID );
									if( !empty($user_awards) ){
								?>
								<div class="awards-block">
									<div class="the-label"><?php _e('Awards', 'smk_theme'); ?></div>
									<div class="awards clearfix">
										<?php 
											echo $user_awards;
										?>
									</div>
								</div>
								<?php } ?>

							</div>
							<div class="clear"></div>
						</div> <!-- #user-summary -->

						<?php if( !empty($author->description) ) { ?>
						<div id="user-about" class="profile-user-tab">
							<div class="tab-inner">
								<div class="profile-user-bio">
									<h4 class="heading-title"><?php _e('About:', 'smk_theme') ?></h4>
									<?php echo wpautop( $author->description ); ?>
								</div>
							</div>
							<div class="clear"></div>
						</div> <!-- #user-about -->
						<?php } ?>

						<div id="user-send-pm" class="profile-user-tab">
							<div class="tab-inner">
								<?php 
									if( $user->ID !== $author->ID){
										$form = new Smk_Private_Messages_Form;
										$form->form( $author, 'create' ); 
									}
								?>
							</div>
							<div class="clear"></div>
						</div> <!-- #user-send-pm -->

					</div>
					<div class="clear"></div>

				<?php endif; ?>

				</div> <!-- .grid-container -->
			</div> <!-- .rw-row -->
