<?php
/* 
 * Register, enqueue scripts and styles
 *
 * Scripts and style used by this theme
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-04-09 18:06:37
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-05-26 20:37:02
 *
 */
function smk_theme_scripts_n_styles() {

	wp_register_style( 'theme-styles', SMK_THEME_ASSETS_URI .'css/styles.css');
	wp_register_style( 'font-awesome', SMK_THEME_ASSETS_URI .'css/font-awesome.min.css');
	wp_register_style( 'font-awards', SMK_THEME_ASSETS_URI .'fonts/awards/awards.css');
	
	$scripts = array(
		"smk-menu.js",
		"rw-sidebar.js",
		"jquery.qtip.js",
		"smk-accordion.js",
		"smk-visual-select.js",
		"owl.carousel.js",
		"Uri.js",
		"scripts.js",
	);

	foreach ($scripts as $key => $script) {
		wp_register_script( $script, SMK_THEME_ASSETS_URI .'js/' . $script, 'jquery', false, true);
	}

	// STYLES
	wp_enqueue_style('font-awesome');
	wp_enqueue_style('font-awards');
	wp_enqueue_style('theme-styles');

	// SCRIPTS
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'comment-reply' );

	if( is_user_logged_in() ){
		wp_enqueue_media();
	}

	// reChaptcha
	$registration_captcha_enable = smk_recipe_setting( 'registration_captcha_enable' );
	$registration_captcha_site_key = smk_recipe_setting( 'registration_captcha_site_key' );
	$registration_captcha_secret_key = smk_recipe_setting( 'registration_captcha_secret_key' );
	$registration_captcha_donot_load_script = smk_recipe_setting( 'registration_captcha_donot_load_script' );
	if( $registration_captcha_donot_load_script !== 'on' ){
		if( !empty($registration_captcha_site_key) && !empty($registration_captcha_secret_key) && !empty($registration_captcha_enable) && $registration_captcha_enable == 'on' ){
			wp_register_script( 'recaptcha', 'https://www.google.com/recaptcha/api.js', false, false, false);
			wp_enqueue_script( 'recaptcha' );
		}
	}


	foreach ($scripts as $key => $script) {
		wp_enqueue_script( $script );
	}

	// in JavaScript, object properties are accessed as ajax_object.ajax_url, ajax_object.we_value
	wp_localize_script( 'scripts.js', 'themeAjax',
		array( 
			'ajax_url' => admin_url( 'admin-ajax.php' ),
			'msg100' => __('An unexpected error occurred.', 'smk_theme'),
			'msg101' => __('Please enter a message.', 'smk_theme'),
			'msg102' => __('Your message has been sent.', 'smk_theme'),
			'msg103' => __('Oops?!', 'smk_theme'),
			'login_msg100' => __('Oops?!', 'smk_theme'),
			'login_msg101' => __('Please enter the username', 'smk_theme'),
			'login_msg102' => __('Please enter the password', 'smk_theme'),
			'login_msg103' => __('Invalid username or password', 'smk_theme'),
			'login_msg104' => __('Success. Redirecting...', 'smk_theme'),
			'login_msg105' => __('Unknown error', 'smk_theme'),
			'login_msg106' => __('Please confirm the password', 'smk_theme'),
			'login_msg107' => __('Password does not match', 'smk_theme'),
			'login_msg108' => __('Please enter the email address', 'smk_theme'),
			'login_msg109' => __('Invalid email address', 'smk_theme'),
			'login_msg110' => __('Please enter the username or email', 'smk_theme'),
			'login_msg111' => __('Username already in use', 'smk_theme'),
			'login_msg112' => __('Email already in use', 'smk_theme'),
			'login_msg113' => __('You have successfully registered and logged in', 'smk_theme'),
			'login_msg114' => __('This email is not registered', 'smk_theme'),
			'login_msg115' => __('This username is not registered', 'smk_theme'),
			'login_msg116' => __('Please check your mail inbox', 'smk_theme'),
			'login_msg117' => __('Failed to send the recovery link', 'smk_theme'),
			'login_msg118' => __('You must accept terms and conditions.', 'smk_theme'),
			'login_msg119' => __('Please enter the the captcha form.', 'smk_theme'),
			'login_msg120' => __('Invalid captcha.', 'smk_theme'),
			'submit_recipe' => array(
				'recipe_pending'      => __('Your has been submited and is awaiting for moderation. An admin will review it and if all looks good it will be published as soon as possible.', 'smk_theme'),
				'view_your_recipe'    => __('You can view your recipe here.', 'smk_theme'),
				'check_recipe_status' => __('You can check the recipe status here.', 'smk_theme'),
				'recipe_approved'     => __('Your recipe has been submited.', 'smk_theme'),
				'recipe_updated'      => __('Your recipe has been updated.', 'smk_theme'),
				'your_recipe_id'      => __('Your recipe ID is:', 'smk_theme'),
				'recipe_errors'       => __('Validation errors occurred. Please confirm the fields and submit it again.', 'smk_theme'),
			),
			'confirm_recipe_delete' => __('Are you sure do you want to delete this recipe?', 'smk_theme')
		)
	);

}
add_action('wp_enqueue_scripts', 'smk_theme_scripts_n_styles', 20);