<?php
class Smk_Recipes_Categories extends Smk_Widget {

	function __construct() {
		$widget_settings = array();

		$widget_ops = array(
			'classname' 	=> 'widget_recipes_categories', 
			'description' 	=> __('Display all available recipes categories.','smk_theme')
		);

		Wp_Widget::__construct('widget_recipes_categories', __('Recipes Categories', 'smk_theme'), $widget_ops, $widget_settings );

	}


	function options() {	
		$wgt_opt = array();
		$wgt_opt[] = array(
			'id' 	=> 'title',
			'type' 	=> 'input',
			'label' => __('Title', 'smk_theme'),
			'std' 	=> __('Categories', 'smk_theme'),

		);
		
		$wgt_opt[] = array(
			'id' 	=> 'show_count',
			'type' 	=> 'select',
			'label' => __('Show count', 'smk_theme'),
			'desc' 	=> __('Display the number of recipes in each category', 'smk_theme'),
			'std'   => 'y',
			'options' => array(
				'y' => __('Yes', 'smk_theme'),
				'n' => __('No', 'smk_theme'),
			),
		);

		$wgt_opt[] = array(
			'id' 	=> 'view',
			'type' 	=> 'select',
			'label' => __('Display style', 'smk_theme'),
			'std'   => 'links',
			'options' => array(
				'links' => __('Links', 'smk_theme'),
				'dropdown' => __('Dropdown', 'smk_theme'),
			),
		);

		return $wgt_opt;
	}

	
	public function widget( $args, $instance ) {
	
		echo $args['before_widget'];
		if ( ! empty( $instance['title'] ) ) {
			echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
		}
		
		$show_count = ( ! empty( $instance['show_count'] ) && $instance['show_count'] == 'y' ) ? true : false;
		$view       = ( ! empty( $instance['view'] ) ) ? $instance['view'] : 'links';
		$categories = get_terms('recipe_categories');

		if( $view == 'dropdown' ){
			$open_list = '<select onchange="document.location.href=this.value;">';
			$close_list = '</select>';
		}
		else{
			$open_list = '<ul class="widget-pretty-list">';
			$close_list = '</ul>';
		}

		if( !empty($categories) ){ 
			echo $open_list;
				foreach ( $categories as $cat ) {
					$counter = ( $show_count ) ? $cat->count: '';
					$link    = esc_url( smk_get_recipe_category_url( $cat->slug ) );
					$name    = $cat->name;
					$active  = is_tax( 'recipe_categories', $cat->slug );
					if( $view == 'dropdown' ){
						$active  = $active ? ' selected="selected"' : '';
						$counter = ( $show_count ) ? ' ('. $counter .')' : '';
						echo '<option'. $active .' value="'. $link .'">'. $name . $counter .'</option>';
					}
					else{
						$active  = $active ? ' class="active"' : '';
						$counter = ( $show_count ) ? ' <span class="mark light-gray">'. $counter .'</span>' : '';
						echo '<li'. $active .'><a href="'. $link .'">'. $name . $counter .'</a></li>';
					}
				}
			echo $close_list;
		}

		echo $args['after_widget'];
	}

	public function onUpdate( $new_instance, $old_instance ) {
		delete_transient( 'smk_widget_recipes_categories' );
	}

} // class Foo_Widge