<?php
class Smk_Widget_Top_Users extends Smk_Widget {

	function __construct() {
		$widget_settings = array();

		$widget_ops = array(
			'classname' 	=> 'widget_top_users', 
			'description' 	=> __('Display top users, by reputation, recipes count or number of comments.','smk_theme')
		);

		Wp_Widget::__construct('widget_top_users', __('Top Users', 'smk_theme'), $widget_ops, $widget_settings );

	}


	function options() {	
		$wgt_opt = array();
		$wgt_opt[] = array(
			'id' 	=> 'title',
			'type' 	=> 'input',
			'label' => __('Title', 'smk_theme'),
			'std' 	=> __('Top users', 'smk_theme'),

		);
		$wgt_opt[] = array(
			'id' 	=> 'number_of_users',
			'type' 	=> 'input',
			'label' => __('Number of users to show', 'smk_theme'),
			'std' 	=> '4',
		);
		return $wgt_opt;
	}

	
	public function widget( $args, $instance ) {
	
		echo $args['before_widget'];
		if ( ! empty( $instance['title'] ) ) {
			echo $args['before_title'] . apply_filters( 'widget_title', $instance['title'] ). $args['after_title'];
		}
		$follow     = new Smk_Theme_User_Follow;
		
		$number = ( !empty( $instance['number_of_users'] ) && absint( $instance['number_of_users'] ) > 1 ) ? absint( $instance['number_of_users'] ) : 4;

		global $wpdb;
		$query = "SELECT um1.user_id, um1.meta_value
			FROM $wpdb->usermeta um1
			WHERE um1.meta_key = 'st_reputation'
			ORDER BY CAST(um1.meta_value AS SIGNED) DESC
			LIMIT $number";
			
		$all_users = $wpdb->get_results($query);
			
		// foreach ($users as $user){
		// 	echo get_user_meta($user->ID, 'st_reputation', true) . '<br />';
		// }
		// $all_users = get_users(array(
		// 	'orderby' => 'post_count',
		// 	'order' => 'DESC',
		// 	'number' => $number, // How many users to show?
		// ));


		$position = 1;
		if ( ! empty( $all_users ) ) {
			foreach ($all_users as $user) {
				$user_id    = $user->user_id;
				$reputation = new Smk_Theme_User_Reputation($user_id);
				$user_url   = get_author_posts_url( $user_id );

				if( in_array(smk_user_cooking_level($user_id, 'level'), array('expert', 'professional' ) ) ){
					$user_level = ' <span class="w-level mark '. smk_user_cooking_level($user_id, 'color') .'">'. smk_user_cooking_level($user_id) .'</span>';
				}
				else{
					$user_level = '';
				}
				if( $position == 1 ){
					$class = ' left';
					$end = '';
					$position++;
				}
				else{
					$class = ' right';
					$end = '<div class="clear"></div>';
					$position = 1;
				}
				echo '
				<div class="w-user-card'. $class .'">
					<div class="w-avatar">
						<a href="'. $user_url .'">'. get_avatar( $user_id, '200' ) . $user_level .'</a>
					</div>
					<div class="w-in">
						<div class="author-name"><a href="'. $user_url .'">'. get_user_option( 'display_name', $user_id ) .'</a></div>
						<div class="author-reputation">'. $reputation->show() .'</div>
					</div>
					
					<div class="w-follow">'. $follow->button( $user_id, array( 'btn_class' => array(
						'default' => 'button blue',
						'active' => 'button green active current',
					))) .'</div>
				</div>
				'. $end;
			}
		}
		echo '<div class="clear"></div>';

		echo $args['after_widget'];
	}

} // class Foo_Widge