<?php
/* 
 * Follow on social networks
 *
 * Follow on social networks
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-05-25 15:06:05
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-06-18 21:28:43
 *
 */
if( ! class_exists('Smk_Theme_WidgetFollowSocial') && class_exists('Smk_Widget') ) {
class Smk_Theme_WidgetFollowSocial extends Smk_Widget {

	function __construct() {
		
		$widget_settings = array();

		$widget_ops = array(
			'classname' 	=> 'widget_follow_social', 
			'description' 	=> __('Follow on social networks.','smk_theme')
		);

		Wp_Widget::__construct('widget_follow_social', __('SMK Follow on Social','smk_theme'), $widget_ops, $widget_settings );

	}

	################################################################################
	
	/**
	 * The options to be passed in form() method
	 *
	 * The options to be passed in form() method. If you modify form() method then
	 * these options will have no effect unless you include the form() from parent.
	 *
	 * @return array
	 */
	function options() {
	
		$wgt_opt = array();

		$wgt_opt[] = array(
			'id' 	=> 'title',
			'type' 	=> 'input',
			'label' => __('Title', 'smk_theme'),
			'desc' 	=> __('Widget title', 'smk_theme'),
			'std'   => __('Social', 'smk_theme'),
		);

		$wgt_opt[] = array(
			'id' 	=> 'social',
			'type' 	=> 'combine',
			'label' => __('Social betworks', 'smk_theme'),
			'block_label' => 'network_name',
			'fields'=> array(
				array(
					'id' 	=> 'follow_on',
					'type' 	=> 'input',
					'label' => __('Follow text:', 'smk_theme'),
					'std'   => __('Follow on', 'smk_theme'),
				),
				array(
					'id' 	=> 'network_name',
					'type' 	=> 'input',
					'label' => __('Social network name:', 'smk_theme'),
					// 'std'   => '',
					'desc' 	=> __('Ex: Facebook', 'smk_theme'),
				),
				array(
					'id' 	=> 'url',
					'type' 	=> 'input',
					'label' => __('URL:', 'smk_theme'),
					'desc'   => __('The URL to social network.', 'smk_theme'),
				),
				array(
					'id' 	=> 'icon',
					'type' 	=> 'select',
					'label' => __('Select icon:', 'smk_theme'),
					// 'std'   => '',
					'options' => $this->socialArray(),
				),
				array(
					'id' 	=> 'bg',
					'type' 	=> 'color',
					'label' => __('Background color:', 'smk_theme'),
				),
			),
		);
		
		return $wgt_opt;

	}

	################################################################################
	
	/**
	 * Widget front-end output
	 *
	 * The content to display on front-end
	 *
	 * @param string $args the arguments before_widget, after_widget, etc 
	 * @param array $instance is the saved data. 
	 */
	function widget( $args, $instance ) {
		
		extract($args);

		// smk_print($args);
		// smk_print($instance);

		$title       = smk_get_value($instance, 'title', '');
		$social      = smk_get_value( $instance, 'social', '');


		echo $before_widget;

		if( !empty($title) ){
			echo $before_title;
				echo $title;
			echo $after_title;
		}

		if( is_array(smk_get_value( $social, 0, '' )) ){
			$social = smk_get_value( $social, 0, '' );
			foreach ($social as $key => $soc) {
				$social       = smk_get_value( $social, 0, '' );
				$follow_on    = smk_get_value($soc, 'follow_on',__('Follow on', 'smk_theme'));
				$network_name = smk_get_value($soc, 'network_name','');
				$url          = esc_url( smk_get_value($soc, 'url','') );
				$icon         = smk_get_value($soc, 'icon','fa-facebook');
				$bg           = smk_get_value($soc, 'bg','');
				$icon_bg      = ( Smk_Check::is_hex_color($bg) ) ? ' style="background: '. $bg .';"' : '';
				$netw_color   = ( Smk_Check::is_hex_color($bg) ) ? ' style="color: '. $bg .';"' : '';

				if( !empty($url) && !empty($follow_on) && !empty($network_name) ){
					echo '
					<div class="social_follow">
						<a href="'. $url .'" target="_blank">
							<div class="icon"'. $icon_bg .'>
								<i class="fa '. $icon .'"></i>
							</div>
							<div class="text">
								<div class="follow_on">'. $follow_on .'</div>
								<div class="network"'. $netw_color .'>'. $network_name .'</div>
							</div>
						</a>
					</div>';
				}
			}
		}

		echo $after_widget;

	}

	public function socialArray(){
		$socials =  array(
			'fa-adn',
			'fa-android',
			'fa-apple',
			'fa-behance',
			'fa-behance-square',
			'fa-bitbucket',
			'fa-bitbucket-square',
			'fa-bitcoin',
			'fa-btc',
			'fa-codepen',
			'fa-css3',
			'fa-delicious',
			'fa-deviantart',
			'fa-digg',
			'fa-dribbble',
			'fa-dropbox',
			'fa-drupal',
			'fa-empire',
			'fa-facebook',
			'fa-facebook-square',
			'fa-flickr',
			'fa-foursquare',
			'fa-ge',
			'fa-git',
			'fa-git-square',
			'fa-github',
			'fa-github-alt',
			'fa-github-square',
			'fa-gittip',
			'fa-google',
			'fa-google-plus',
			'fa-google-plus-square',
			'fa-hacker-news',
			'fa-html5',
			'fa-instagram',
			'fa-joomla',
			'fa-jsfiddle',
			'fa-linkedin',
			'fa-linkedin-square',
			'fa-linux',
			'fa-maxcdn',
			'fa-openid',
			'fa-pagelines',
			'fa-pied-piper',
			'fa-pied-piper-alt',
			'fa-pied-piper-square',
			'fa-pinterest',
			'fa-pinterest-square',
			'fa-qq',
			'fa-ra',
			'fa-rebel',
			'fa-reddit',
			'fa-reddit-square',
			'fa-renren',
			'fa-share-alt',
			'fa-share-alt-square',
			'fa-skype',
			'fa-slack',
			'fa-soundcloud',
			'fa-spotify',
			'fa-stack-exchange',
			'fa-stack-overflow',
			'fa-steam',
			'fa-steam-square',
			'fa-stumbleupon',
			'fa-stumbleupon-circle',
			'fa-tencent-weibo',
			'fa-trello',
			'fa-tumblr',
			'fa-tumblr-square',
			'fa-twitter',
			'fa-twitter-square',
			'fa-vimeo-square',
			'fa-vine',
			'fa-vk',
			'fa-wechat',
			'fa-weibo',
			'fa-weixin',
			'fa-windows',
			'fa-wordpress',
			'fa-xing',
			'fa-xing-square',
			'fa-yahoo',
			'fa-youtube',
			'fa-youtube-play',
			'fa-youtube-square',
		);
		$final = array();
		foreach ($socials as $s) {
			$name = ucwords( str_replace(array('fa-', '-'), array('', ' '), $s) );
			$final[ $s ] = $name;
		}
		return $final;

	}

}//End Class
}//End class_exists check
?>