<?php 
	$paged = get_query_var('paged');
	query_posts('cat=-0&paged=' . $paged);

	get_header(); 

?>

<div class="rw-section rw-container right-sidebar">
	<div class="rw-inner clearfix">

		<?php smk_theme_sidebar() ?>

		<!-- Main content -->
		<div class="rw-column rw-content">

			<?php smk_get_template_part("tpl/top-page-title.php", array(
				'page_title' => _x('Blog', 'The blog title', 'smk_theme') 
			)); ?>
			
			<div class="rw-row">
				
				<div class="blog-list">

					<?php 
					if (have_posts()) {
						while (have_posts()) : the_post();
					
						?>
							<!-- Entry -->
							<div id="post-<?php the_ID(); ?>" <?php post_class(array('post', 'clearfix')); ?>>
								<div class="entry-photo"><a href="<?php the_permalink(); ?>">
									<?php 
										if ( has_post_thumbnail() ) { // check if the post has a Post Thumbnail assigned to it.
											$layout_width = smk_theme_setting( 'layout_width', 1140 );
											$photo_width_plus = 0;
											if( 1240 == $layout_width ){
												$photo_width_plus = 100;
											}
											elseif( 1340 == $layout_width ){
												$photo_width_plus = 200;
											}
											elseif( 1440 == $layout_width ){
												$photo_width_plus = 300;
											}

											echo '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 780 + $photo_width_plus, false, true) .'" alt="" />';
										} 
									?>
								</a></div>
								<div class="entry-details">
									<div class="entry-date">
										<span class="date"><?php echo get_the_time('d'); ?></span>
										<span class="month"><?php printf( __('%1$s', 'smk_theme') , get_the_time('F') ); ?></span>
										<span class="year"><?php echo get_the_time('Y'); ?></span>
									</div>
									<div class="entry-title"><h2><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h2></div>
									<div class="entry-content">
									<?php 
										the_excerpt();
										echo '<a href="'. get_the_permalink() .'">'. __('Read more &rarr;', 'smk_theme') .'</a>';
									?>
									</div>
								</div>
							</div> <!-- .entry -->
							<div class="clear"></div>
						<?php
					
						endwhile; 
					}
					else{
						echo '<div class="notification orange light">' . __('No posts were found.', 'smk_theme') . '</div>';
					} 
					?>
					
					
				</div> <!-- .blog-list -->

				<div class="blog-pagination-links">
					<?php
						next_posts_link( sprintf( __('%s Older Posts', 'smk_theme'), '<i class="the-icon to-left fa fa-chevron-left"></i>') );
						previous_posts_link( sprintf( __('Newer Posts %s', 'smk_theme'), '<i class="the-icon to-right fa fa-chevron-right"></i>') );
					?>
				</div>

			</div> <!-- .rw-row -->

		</div>

	</div> <!-- .rw-inner -->
</div> <!-- .rw-container -->

<?php get_footer(); ?>