<?php 
if( !class_exists('Smk_Activities_Cpt') ){
	class Smk_Activities_Cpt{

		public $id;
		public $regcpt = 'register_post_type';

		public function __construct( $id ){
			$this->id = $id;
			add_action( 'init', array( $this, 'postType' ) );
		}

		//------------------------------------//--------------------------------------//
		
		/**
		 * Register Post type
		 *
		 * Register Custom Post Type
		 * 
		 * @action-hook init
		 * 
		 * @return void 
		 */
		public function postType(){

			// Create The Labels (Output) For The Post Type
			$labels = array(
				'name'               => __('Activities', 'smk_theme'), 
				'singular_name'      => __('Activity', 'smk_theme'),
				'add_new'            => __('Add Activity', 'smk_theme'), 
				'edit_item'          => __('Edit Activity', 'smk_theme'),
				'new_item'           => __('New Activity', 'smk_theme'), 
				'view_item'          => __('View Activity', 'smk_theme'),
				'search_items'       => __('Search Activities', 'smk_theme'), 
				'not_found'          => __('No Activities Found', 'smk_theme'),
				'not_found_in_trash' => __('No Activities Found In Trash', 'smk_theme'),
				'parent_item_colon'  => '' 
			);
			
			// Set Up The Arguements
			$args = array(
				'labels'             => $labels, 
				'public'             => false, 
				'has_archive'        => false,
				'publicly_queryable' => false, 
				'show_ui'            => false, 
				'query_var'          => false, 
				'rewrite'            => array(
					'slug' => 'activities',
				),
				'capability_type'    => 'post',
				'menu_icon'          => 'dashicons-id-alt',
				'hierarchical'       => false, 
				'show_in_nav_menus'  => false,
				'menu_position'      => 20,
				'supports'           => array(
					'title',
				),
			);
			
			// Register post type
			$this->regCpt( $args );

		}

		public function regCpt( $args ){
			$fn = $this->regcpt;
			$fn( $this->id, $args );
		}

	}
}