<?php
class Smk_Mark_Post_Ajax{

	public $type;

	public function __construct( $type ){
		$this->type = $type;
		add_action('wp_ajax_smk_mark_post_' . $this->type, array( $this, 'ajaxHandler' ));
	}

	public function ajaxHandler(){
		if( isset($_POST) && !empty($_POST) ){

			$phpClass = new Smk_Mark_Post( $this->type );

			$data     = !empty($_POST['data']) ? $_POST['data'] : false;
			$post_id  = ( !empty($data['post']) && is_numeric($data['post']) ) ? $data['post'] : false;
			$settings = !empty($data['settings']) ? $data['settings'] : false;
			if( ! $settings ) die(); // If somehow the settings are not there, then the user tried to hack it.

			$return_obj   = $settings;
			$return_obj['post_id'] = $post_id;

			if( $post_id ){
				if( $phpClass->userHasMarked($post_id) ){
					$phpClass->removeMark( $post_id );
					$phpClass->removeUserMark( $post_id );
					$return_obj['js_status'] = 'removed';
					do_action( 'smk_mark_post_' . $this->type .'_removed', $post_id );
				}
				else{
					$phpClass->updateMark( $post_id );
					$phpClass->updateUserMark( $post_id );
					$return_obj['js_status'] = 'added';
					do_action( 'smk_mark_post_' . $this->type .'_added', $post_id );
				}
				$phpClass->updateMarksCount( $post_id);

				$return_obj   = $phpClass->prepareSettings( $post_id, $return_obj );
				$return_obj['js_total_number_of_fav'] = $phpClass->getMarksCount($post_id);
				echo json_encode($return_obj);
			} 

		}
		die();
	}

}