<?php
function smk_print_recipe(){
	$recipe_data = new Smk_Recipe_Data;
	if( !empty($_GET['print_recipe']) ) {
		?>
		<!DOCTYPE html>
		<html>
		<head>

			<?php
				$tt = 'title';
				echo '<'. $tt .'>'. get_the_title() .'</'. $tt .'>';
			?>
			<link rel="stylesheet" href="<?php echo SMK_THEME_URI . 'lib/mod/print-recipe/assets/' ?>style.css" />
		</head>
		<body>
		<!-- <body onload="window.print()"> -->
			<div class="content">
				<?php 
				echo '<div class="controls">
					<div class="contols-inner">
						<a href="'. smk_remove_query_arg( 'print_recipe' ) .'" class="button exit-print">'. __('Exit print mode', 'smk_theme') .'</a>

						<span class="button print-again" onclick="window.print();">'. __('Print recipe', 'smk_theme') .'</span>
						<span class="button text-plus" title="'. __('Increase text size', 'smk_theme') .'">A+</span>
						<input class="current-font-size" type="number" />
						<span class="button text-minus" title="'. __('Decrease text size', 'smk_theme') .'">A-</span>
						<span class="button remove-undo-all" title="'. __('Undo all', 'smk_theme') .'">Undo all</span>
					</div>
				</div>';
				if (have_posts()) {
					while (have_posts()) : the_post();
					echo '<div class="printable-content">';
							echo '<h1 class="recipe-title">'. get_the_title() .'</h1>';
							if ( has_post_thumbnail() ) { // check if the post has a Post Thumbnail assigned to it.
								echo '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 780, false, true) .'" alt="" class="center-img" />';
							}

							$first = false;
							$ingredients = $recipe_data->ingredients();
							if( $ingredients ) :
								$first = true;
							?>
							<h3><?php _e('Ingredients:', 'smk_theme'); ?></h3>
								<?php 
								$output = '';
								foreach ($ingredients as $ingredient_id => $val) {
									if( empty($val['ingredient']) ) {
										continue;
									}

									$qt      = !empty($val['quantity']) ? esc_attr($val['quantity']) : '';
									$measure = !empty($val['measurement']) ? esc_attr($val['measurement']) : '';
									$notes   = !empty($val['notes']) ? esc_attr($val['notes']) : '';
									
									$output .= '<div class="single-ingredient">';
										$output .= '<div class="mark-as-ok"><span></span></div>';
										$output .= '<div class="ingredient">'. esc_attr($val['ingredient']) .'</div>';
										$output .= '<div class="ingredient-quantity">'. $qt .' '. $measure .'</div>';
										if( !empty($notes) ){
											$output .= '<div class="ingredient-notes">'. $notes .'</div>';
										}
									$output .= '</div>';
								}
								echo $output;
								?>
							<?php 
							endif;

							echo '<h3>'. __('Preparation mode:', 'smk_theme') .'</h3>';
							the_content();

							if( $recipe_data->footnotes() ) { 
								echo '<h3>'. __('Footnotes:', 'smk_theme') .'</h3>';
								echo wpautop( $recipe_data->footnotes() ); 
							}

							echo '<div class="footer">' . __('Source:', 'smk_theme') .' '. get_the_permalink() .'</div>';
						echo '</div>';
					endwhile;
				}
				?>
			</div>

			<script src="<?php echo SMK_THEME_URI . 'lib/mod/print-recipe/assets/' ?>jquery-1.11.2.min.js"></script>
			<script src="<?php echo SMK_THEME_URI . 'lib/mod/print-recipe/assets/' ?>scripts.js"></script>
		</body>
		</html>
		<?php
	die();
	}
}