<?php

function smk_all_user_recipes_status_title( $status ){
	switch ( $status ) {
		case 'publish':
			$class = 'green';
			$text = __('Published', 'smk_theme');
			break;
		
		case 'pending':
			$class = 'orange';
			$text = __('Pending moderation', 'smk_theme');
			break;
		
		case 'draft':
			$class = 'gray';
			$text = __('Draft', 'smk_theme');
			break;
		
		case 'future':
			$class = 'teal';
			$text = __('Scheduled', 'smk_theme');
			break;
		
		case 'private':
			$class = 'pink';
			$text = __('Private', 'smk_theme');
			break;
	}
	return '<span class="mark '. $class .'">'. $text .'</span>';
}

function smk_all_user_recipes( $user_id ){

	if( $user_id > 0 ){

		$current_user = Smk_Theme_User::currentUser();
		if( $user_id == $current_user->ID || current_user_can('edit_others_posts') ){

			$recipes_page = smk_theme_current_pag();
			$query = array (
				'post_type'      => 'smk_recipes',
				'posts_per_page' => 20,
				'paged'          => $recipes_page,
				'author__in'     => $user_id,
				'post_status'    => array( 'publish', 'pending', 'draft', 'future', 'private' ),
			);

			$recipes_query = new WP_Query($query);

			if ($recipes_query->have_posts()) {
				echo '<div class="smk-all-user-recipes-list">';
				while ($recipes_query->have_posts()) : 
					
					$recipes_query->the_post();

					$recipe_id = get_the_ID();
					$status    = get_post_status( $recipe_id );
					$link      = get_the_title();

					if( $status == 'publish' || current_user_can('edit_others_posts') ){
						$link = '<a href="'. get_permalink() .'">'. get_the_title() .'</a>';
					}

					$output = '<div class="the-recipe clearfix">';
						$output .= '<div class="recipe-col title"><div>'. $link .'</div></div>';
						$output .= '<div class="recipe-col date"><div>'. smk_post_date('j M Y', false) .'</div></div>';
						$output .= '<div class="recipe-col status"><div>'. smk_all_user_recipes_status_title( $status ) .'</div></div>';
						$output .= '<div class="recipe-col controls"><div>'. smk_manage_recipe( $recipe_id, '<i class="fa fa-cog"></i>', 'right' ) .'</div></div>';
					$output .= '</div>';

					echo $output;

				endwhile; 

				smk_theme_pagination($recipes_query, array('block_class' => 'smk-all-user-recipes-pagination'));
				echo '</div>';
			}
			else{
				echo '<div class="notification orange light center">' . __('You have not submitted anything yet.', 'smk_theme') . '</div>';
			} 
		}
		else{
			echo '<div class="notification red center">' . __('Error', 'smk_theme') . '</div>';
			return;
		}
	}
	else{
		echo '<div class="notification red center">' . __('Invalid user ID.', 'smk_theme') . '</div>';
	}
	
}