<?php
//------------------------------------//--------------------------------------//

/**
 * Recipes per page
 *
 * How many recipes to display per page
 * 
 * @return int 
 */
function smk_recipes_possible_per_page(){
	return array(6, 12, 24, 48, 72, 96, 120);
}
//------------------------------------//--------------------------------------//

/**
 * Recipes per page
 *
 * How many recipes to display per page
 * 
 * @return int 
 */
function smk_recipes_filter_per_page(){
	$possible = smk_recipes_possible_per_page();
	$setting = smk_recipe_setting( 'recipes_per_page' );
	$default = !empty( $setting ) && $setting > 0 && in_array($setting, $possible) ? absint( $setting ) : $possible[1];
	return !empty($_GET['per_page_']) && in_array($_GET['per_page_'], $possible)  ? absint($_GET['per_page_']) : $default;
}

//------------------------------------//--------------------------------------//

/**
 * Get all possible categories
 *
 * Get all possible categories
 * 
 * @return array 
 */
function smk_recipes_filter_all_categories( $args = array() ){
	$categories = get_terms('recipe_categories', $args);
	$output     = array();
	if( !empty($categories) ){ 
		foreach ( $categories as $cat ) {
			$output[$cat->slug]['name'] = $cat->name;
			$output[$cat->slug]['count'] = $cat->count;
		}
	}
	return $output;
}

//------------------------------------//--------------------------------------//

/**
 * The category to be displayed from the url
 *
 * The category to be displayed from the url
 * 
 * @return string 
 */
function smk_recipes_filter_by_category(){
	$all = smk_recipes_filter_all_categories();
	return !empty($_GET['r-category']) && array_key_exists($_GET['r-category'], $all) ? $_GET['r-category'] : '';
}

//------------------------------------//--------------------------------------//

/**
 * Get all possible tags
 *
 * Get all possible tags
 * 
 * @return array 
 */
function smk_recipes_filter_all_tags(){
	$tags = get_terms('recipe_tags');
	$output     = array();
	if( !empty($tags) ){ 
		foreach ( $tags as $tag ) {
			$output[$tag->slug]['name'] = $tag->name;
			$output[$tag->slug]['count'] = $tag->count;
		}
	}
	return $output;
}

//------------------------------------//--------------------------------------//

/**
 * The tag to be displayed from the url
 *
 * The tag to be displayed from the url
 * 
 * @return string 
 */
function smk_recipes_filter_by_tag(){
	$all = smk_recipes_filter_all_tags();
	return !empty($_GET['r-tag']) && array_key_exists($_GET['r-tag'], $all) ? $_GET['r-tag'] : '';
}

//------------------------------------//--------------------------------------//

/**
 * The recipes view from url
 *
 * The recipes view from url
 * 
 * @return string 
 */
function smk_recipes_filter_view(){
	$default = smk_recipe_setting( 'default_recipes_view' );
	$default = ( in_array($default, array('list', 'grid', 'large')) ) ? $default : 'large';
	return !empty($_GET['view']) && in_array($_GET['view'], array('list', 'grid', 'large')) ? $_GET['view'] : $default;
}

//------------------------------------//--------------------------------------//

/**
 * The recipes view from url, return class active
 *
 * The recipes view from url, return class active
 * 
 * @return string 
 */
function smk_recipes_filter_view_active( $current ){
	$view = smk_recipes_filter_view();
	return $view == $current ? ' active' : '';
}

//------------------------------------//--------------------------------------//

/**
 * The category to be displayed from the url
 *
 * The category to be displayed from the url
 * 
 * @return string 
 */
function smk_recipes_filter_recipes_link(){
	return get_post_type_archive_link( 'smk_recipes' );
}