<?php
// Init recipes Custom Post Type
new Smk_Recipes_Cpt('smk_recipes');

// Update the recipe views count
function smk_theme_update_the_recipes_views_count(){
	if( is_single() && is_singular( 'smk_recipes' ) && empty( $_GET['print_recipe'] ) ){
		$single_recipe_data = new Smk_Recipe_Data;
		$single_recipe_data->updateViews();
	}
}
add_action('loop_end', 'smk_theme_update_the_recipes_views_count');

// Update the recipe prints number
function smk_theme_update_the_recipes_prints_count(){
	if( is_single() && is_singular( 'smk_recipes' ) && !empty( $_GET['print_recipe'] ) ){
		$single_recipe_data = new Smk_Recipe_Data;
		$single_recipe_data->updatePrintsNumber();
	}
}
add_action('loop_end', 'smk_theme_update_the_recipes_prints_count');

function smk_remove_recipe_ajax_handler(){
	if( !empty($_POST) ){
		$post_id = !empty($_POST['post_id']) ? $_POST['post_id'] : false;
		$by_user_id = Smk_Theme_User::currentUserId();
		$msg = array();
		if( $post_id && smk_user_can_edit_recipe( $post_id ) ){
			$author_id = get_post_field( 'post_author', $post_id );
			wp_delete_post( $post_id );
			$msg['message']  = __('Recipe removed', 'smk_theme');
			$msg['redirect'] = smk_user_recipes_list( $author_id );
			do_action( 'smk_ajax_recipe_removed', $post_id, $author_id, $by_user_id );
		}
		else{
			$msg['message'] = __('Error', 'smk_theme');
		}
		echo json_encode($msg);
	}
	die();
}
add_action('wp_ajax_smk_remove_recipe_ajax_handler', 'smk_remove_recipe_ajax_handler');

function smk_approve_publish_recipe_ajax_handler(){
	$messages = array();
	if( !empty($_POST) ){
		$post_id = !empty($_POST['post_id']) ? $_POST['post_id'] : false;
		if( $post_id && current_user_can( 'edit_others_posts' ) ){
			$post_status = get_post_status( $post_id );
			wp_update_post( array(
				'ID'          => $post_id,
				'post_status' => ( $post_status == 'pending' ) ? 'publish' : 'pending',
			));

			$post_status = get_post_status( $post_id );
			if( $post_status == 'publish' ){
				$messages['text']   = __('Unapprove', 'smk_theme');
				$messages['status'] = 'approved';

				$already_published = get_post_meta( $post_id, 'smk_recipe_already_published', true );
				if( ! $already_published ){
					do_action('smk_publish_recipe', $post_id);
					update_post_meta( $post_id, 'smk_recipe_already_published', 'y' );
				}
			}
			else{
				$messages['text']   = __('Publish', 'smk_theme');
				$messages['status'] = 'unapproved';
			}

		}
		else{
			$messages['error_message'] = __('Error', 'smk_theme');
		}
	}
	echo json_encode($messages);
	die();
}
add_action('wp_ajax_smk_approve_publish_recipe_ajax_handler', 'smk_approve_publish_recipe_ajax_handler');