<?php
$px = 'smk_recipe_';

$measurements = smk_ingredient_measurements();

$fields = array();
$fields[] = array(
	'id' 	=> $px .'tab_1',
	'type' 	=> 'tab',
	'label' => __('General', 'smk_theme'),
	'fields'=> array(
		array(
			'id' 	=> $px .'ingredients',
			'type' 	=> 'combine',
			'label' => __('Ingredients', 'smk_theme'),
			'block_label' => 'ingredient',
			'fields'	=> array(
				array(
					'id' => 'ingredient',
					'type' => 'input',
					'label' => __('Ingredient', 'smk_theme'),
					'std' => ''
				),
				array(
					'id' => 'quantity',
					'type' => 'input',
					'label' => __('Quantity', 'smk_theme'),
					'std' => ''
				),
				array(
					'id' => 'measurement',
					'type' => 'select',
					'label' => __('Measurement', 'smk_theme'),
					'std' => '',
					'options' => $measurements,
				),
				array(
					'id' => 'notes',
					'type' => 'input',
					'label' => __('Notes', 'smk_theme'),
					'std' => ''
				),
			),//fields
		),
		array(
			'id' 	=> $px .'difficulty',
			'type' 	=> 'visual_select',
			'label' => __('Difficulty', 'smk_theme'),
			'desc' 	=> __('Select the level of this recipe.', 'smk_theme'),
			'std'   => 'easy',
			'options' => array(
				array(
					'val'   => 'easy',
					'label' => __('Easy', 'smk_theme'),
				),
				array(
					'val'   => 'moderate',
					'label' => __('Moderate', 'smk_theme'),
				),
				array(
					'val'   => 'hard',
					'label' => __('Hard', 'smk_theme'),
				),
			),
		),

		array(
			'id' 	=> $px .'preparation_time',
			'type' 	=> 'input',
			'label' => __('Preparation time(in minutes)', 'smk_theme'),
			'desc' 	=> __('How long it takes to do and finish everything.', 'smk_theme'),
			'std'   => '',
			'set'   => array(
				'size' 	=> 'min',
			),
		),

		array(
			'id' 	=> $px .'footnotes',
			'type' 	=> 'editor',
			'label' => __('Footnotes', 'smk_theme'),
			'desc' 	=> __('Include info about other ways to cook or serve this dish. Add tips for ingredients substitutions. Don\'t add info that describes the recipe - that goes best in the "Preparation mode" field.', 'smk_theme'),
			'std' 	=> '',
		),

		array(
			'id' 	=> $px .'links',
			'type' 	=> 'combine',
			'label' => __('Links', 'smk_theme'),
			'desc' 	=> __('Have more info about this? Post the links here for reference.', 'smk_theme'),
			'block_label' => 'url',
			'fields'	=> array(
				array(
					'id' => 'url',
					'type' => 'input',
					'label' => __('URL', 'smk_theme'),
					'std' => ''
				),
				array(
					'id' => 'title',
					'type' => 'input',
					'label' => __('Title', 'smk_theme'),
					'std' => ''
				),
			),//fields
		),

	)//fields
);


new Smk_Metabox('recipe_meta', __('Recipe settings', 'smk_theme'), $fields, array('smk_recipes'));