<?php
$panel = new Srps_Settings_Panel( 'smk_recipes_main_settings', __('Recipes settings', 'smk_theme') );

/* Pages
------------------------------------------------*/
$panel->addSection( 'pages', __('Pages', 'smk_theme'), __('Select the pages that should be used for special actions. Every page should include the necesary shortcode in order to work properly.', 'smk_theme') );

$panel->addField( 'submit_recipe_page', 'page_select', array(
	'title' => __('Submit a new recipe', 'smk_theme'),
	'description' => sprintf( __('The page used to submit a new recipe. It must use the following shortcode %s.', 'smk_theme'), '<code>[smk_submit_recipe]</code>'),
));

$panel->addField( 'recipe_search_page', 'page_select', array(
	'title' => __('Recipes search form', 'smk_theme'),
	'description' => sprintf( __('The page used to display a search form for recipes. It must use the following shortcode %s.', 'smk_theme'), '<code>[smk_recipe_search]</code>'),
));

$panel->addField( 'members_list_page', 'page_select', array(
	'title' => __('Members list', 'smk_theme'),
	'description' => sprintf( __('The page used to display all members. This page must use the following shortcode %s.', 'smk_theme'), '<code>[smk_members_list]</code>'),
));

$panel->addField( 'tags_index_page', 'page_select', array(
	'title' => __('Tags index', 'smk_theme'),
	'description' => sprintf( __('The page used to display all tags used in all recipes. This page must use the following shortcode %s.', 'smk_theme'), '<code>[smk_tags_index]</code>'),
));

// $panel->addField( 'registration_page', 'page_select', array(
// 	'title' => __('Registration', 'smk_theme'),
// 	'description' => sprintf( __('The page used to display the registration form. This page must use the following shortcode %s.', 'smk_theme'), '<code>[smk_register_user_form]</code>'),
// ));

// $panel->addField( 'signin_page', 'page_select', array(
// 	'title' => __('Sign In', 'smk_theme'),
// 	'description' => sprintf( __('The page used to display the login form for users. This page must use the following shortcode %s.', 'smk_theme'), '<code>[smk_signin_user_form]</code>'),
// ));

/* Submission
------------------------------------------------*/
$panel->addSection( 'submission', __('Submission', 'smk_theme') );

$panel->addField( 'recipe_submission_enabled', 'checkbox', array(
	'title' => __('Anyone can submit recipes', 'smk_theme'),
	'label' => __('Enabled', 'smk_theme'),
	'default' => 'on',
	'description' => __('If is "Enabled" anyone is allowed to submit recipes, else only the admins can submit new recipes.', 'smk_theme'),
));

$panel->addField( 'recipe_submission_required_fields', 'checkbox', array(
	'title' => __('Required fields', 'smk_theme'),
	'description' => __('Select the fields that are required for a new recipe submission. The user will not be allowed to submit a recipe with these fields left blank.', 'smk_theme'),
	'default'   => array(
		'featured_image', 'ingredients', 'tags', 'prep_mode'
	),
	// 'display_inline' => true,
	'options' => array(
		'featured_image' => __('Image', 'smk_theme'),
		'prep_mode'      => __('Preparation mode', 'smk_theme'),
		'ingredients'    => __('Ingredients', 'smk_theme'),
		'tags'           => __('Tags', 'smk_theme'),
		'difficulty'     => __('Difficulty', 'smk_theme'),
		'prep_time'      => __('Preparation time', 'smk_theme'),
		'footnotes'      => __('Footnotes', 'smk_theme'),
	),
));

$panel->addField( 'recipe_submission_enabled_fields', 'checkbox', array(
	'title' => __('Enabled fields', 'smk_theme'),
	'description' => __('Select the field that should be displayied on submittion page and details page.', 'smk_theme'),
	'default'   => array(
		'featured_image', 'ingredients', 'tags', 'prep_mode', 'difficulty', 'prep_time', 'footnotes', 'links'
	),
	// 'display_inline' => true,
	'options' => array(
		'featured_image' => __('Image', 'smk_theme'),
		'prep_mode'      => __('Preparation mode', 'smk_theme'),
		'ingredients'    => __('Ingredients', 'smk_theme'),
		'tags'           => __('Tags', 'smk_theme'),
		'difficulty'     => __('Difficulty', 'smk_theme'),
		'prep_time'      => __('Preparation time', 'smk_theme'),
		'footnotes'      => __('Footnotes', 'smk_theme'),
		'links'          => __('Links', 'smk_theme'),
	),
));

$panel->addField( 'recipe_measurements', 'textarea', array(
	'title' => __('Recipe measurements', 'smk_theme'),
	'size'  => 'wide',
	'rows'  => 3,
	'description' =>__('Enter all possible recipe measurements here(plural version), separated by a comma(,).', 'smk_theme'),
	'default'   => 
		__('Cups', 'smk_theme') .', '.
		__('Teaspoons', 'smk_theme') .', '.
		__('Tablespoons', 'smk_theme') .', '.
		__('Liters', 'smk_theme') .', '.
		__('Milliliters', 'smk_theme') .', '.
		__('Grams', 'smk_theme') .', '.
		__('Kilograms', 'smk_theme') .', '.
		__('Ounces', 'smk_theme') .', '.
		__('Pints', 'smk_theme') .', '.
		__('Quarts', 'smk_theme') .', '.
		__('Gallons', 'smk_theme')
	,
));

$panel->addField( 'recipe_submission_min_image_width', 'text', array(
	'title' => __('Minimum image width', 'smk_theme'),
	'default' => '400',
	'type_attr' => 'number',
	'size' => 'small',
	'description' => __('Enter the minimum image width(in pixels) that a user is allowed to upload(eg. 400). Leave empty or enter 0 to disable.', 'smk_theme'),
));

/* Registration
------------------------------------------------*/
$panel->addSection( 'registration', __('Registration', 'smk_theme') );

$panel->addField( 'registration_terms_enable', 'checkbox', array(
	'title' => __('Registration TOS', 'smk_theme'),
	'label' =>__('Enable "Terms and contitions".', 'smk_theme'),
	'default'   => 'on',
));

$panel->addField( 'registration_terms_text', 'textarea', array(
	'title' => __('Registration TOS text', 'smk_theme'),
	'size'  => 'wide',
	'rows'  => 2,
	'description' =>__('"Terms and contitions" text. This text is shown as a label in registration form. You should create a link to the page with all details. Safe HTML allowed.', 'smk_theme'),
	'default'   => __('I accept <a href="#">terms and conditions</a>.', 'smk_theme'),
));

$panel->addField( 'registration_captcha_enable', 'checkbox', array(
	'title' => __('Registration captcha', 'smk_theme'),
	'label' =>__('Enable Google reCaptcha.', 'smk_theme'),
	'default'   => '',
));

$panel->addField( 'registration_captcha_site_key', 'text', array(
	'title' => __('Google reCaptcha SITE KEY.', 'smk_theme'),
	'description' => sprintf( __('Enter the SITE KEY generated by Google reChaptcha service. %s Get it here. %s', 'smk_theme'), '<a href="https://www.google.com/recaptcha/intro/index.html" target="_blank">', '</a>'),
	'default'   => '',
));

$panel->addField( 'registration_captcha_secret_key', 'text', array(
	'title' => __('Google reCaptcha SECRET KEY.', 'smk_theme'),
	'description' => sprintf( __('Enter the SECRET KEY generated by Google reChaptcha service. %s Get it here. %s', 'smk_theme'), '<a href="https://www.google.com/recaptcha/intro/index.html" target="_blank">', '</a>'),
	'default'   => '',
));

$panel->addField( 'registration_captcha_donot_load_script', 'checkbox', array(
	'title' => __('Registration captcha script', 'smk_theme'),
	'label' =>__('Do not load the Google reCaptcha javascript. Check this option if the script is already loaded by another plugin and do not want to load it twice. This option will <strong>remove</strong> it from the site head.', 'smk_theme'),
	'default'   => '',
));

/* User reputation
------------------------------------------------*/
$panel->addSection( 'user_reputation', __('User reputation', 'smk_theme') );

$panel->addField( 'add_to_fav_points', 'text', array(
	'title' => __('Add a recipe to favorite', 'smk_theme'),
	'description' =>__('The number of points to award a user when somebody adds to favorite its recipe. Set to 0 to disable.', 'smk_theme'),
	'default'   => 10,
	'type_attr' => 'number',
	'size' => 'small',
));

$panel->addField( 'sanction_points_for_remove_fav', 'text', array(
	'title' => __('"Remove from favorites" sanction', 'smk_theme'),
	'description' =>__('Sanction. The number of points to remove when a user remove from favorites a recipe. This value is applied to the user that click the "favorite" button, not to the author of recipe. Set to 0 to disable.', 'smk_theme'),
	'default'   => -2,
	'type_attr' => 'number',
	'size' => 'small',
));

$panel->addField( 'like_recipe_points', 'text', array(
	'title' => __('Like a recipe', 'smk_theme'),
	'description' =>__('The number of points to award a user when somebody adds to favorite its recipe. Set to 0 to disable.', 'smk_theme'),
	'default'   => 10,
	'type_attr' => 'number',
	'size' => 'small',
));

$panel->addField( 'sanction_points_for_dislike', 'text', array(
	'title' => __('"Dislike" a recipe sanction', 'smk_theme'),
	'description' =>__('Sanction. The number of points to remove when a user dislike a recipe. This value is applied to the user that click the "Like" button, not to the author of recipe. Set to 0 to disable.', 'smk_theme'),
	'default'   => -2,
	'type_attr' => 'number',
	'size' => 'small',
));

$panel->addField( 'publish_recipe_points', 'text', array(
	'title' => __('Publish a recipe', 'smk_theme'),
	'description' =>__('The number of points to award a user for publishing a new recipe recipe. Set to 0 to disable.', 'smk_theme'),
	'default'   => 50,
	'type_attr' => 'number',
	'size' => 'small',
));

/* User interaction
------------------------------------------------*/
$panel->addSection( 'user_interaction', __('User interaction', 'smk_theme') );

$panel->addField( 'ui_enable_filter', 'checkbox', array(
	'title' => __('Enable recipes filter', 'smk_theme'),
	'label' =>__('Allow users filter the recipes using an advanced search form.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'ui_enable_favorites', 'checkbox', array(
	'title' => __('Enable favorites', 'smk_theme'),
	'label' =>__('Allow users to add recipes to favorites.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'ui_enable_likes', 'checkbox', array(
	'title' => __('Enable likes', 'smk_theme'),
	'label' =>__('Allow users to like recipes.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'ui_enable_print', 'checkbox', array(
	'title' => __('Enable printing', 'smk_theme'),
	'label' =>__('Allow users to print recipes.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'ui_enable_views', 'checkbox', array(
	'title' => __('Enable views', 'smk_theme'),
	'label' =>__('Allow users see how many views has a recipe.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'ui_enable_ratings', 'checkbox', array(
	'title' => __('Enable ratings', 'smk_theme'),
	'label' =>__('Allow users to rate recipes.', 'smk_theme'),
	'default'   => 'on',
));

/* Recipes list
------------------------------------------------*/
$panel->addSection( 'recipes_list', __('Recipes list', 'smk_theme') );

$possible_number_of_recipes_per_page = array(
	6 => 6, 
	12 => 12, 
	24 => 24, 
	48 => 48, 
	72 => 72, 
	96 => 96, 
	120 => 120,
);
$panel->addField( 'recipes_per_page', 'radio', array(
	'title' => __('Default number of recipes per page', 'smk_theme'),
	'default'   => 12,
	'options' => $possible_number_of_recipes_per_page,
	'display_inline' => true,
));

$panel->addField( 'default_recipes_view', 'radio', array(
	'title' => __('Default recipes view', 'smk_theme'),
	'default'   => 'large',
	'options' => array(
		'large' => __('Large', 'smk_theme'),
		'grid' => __('Grid', 'smk_theme'), 
		'list' => __('Compact', 'smk_theme'), 
	),
	'display_inline' => true,
));

$panel->addField( 'recipes_view_grid_number_of_columns', 'radio', array(
	'title' => __('Grid view number of columns', 'smk_theme'),
	'description' => __('If the previous selected option is "Grid", please specify the number of columns.', 'smk_theme'),
	'default'   => 3,
	'options' => array(
		3 => 3,
		4 => 4,
		5 => 5,
		6 => 6,
		7 => 7,
		8 => 8,
		9 => 9,
		9 => 9,
		10 => 10,
	),
	'display_inline' => true,
));


/* Administration
------------------------------------------------*/
$panel->addSection( 'administration', __('Administration', 'smk_theme') );

$panel->addField( 'admin_list_unapproved_recipes', 'checkbox', array(
	'title' => __('List unapproved recipes', 'smk_theme'),
	'label' =>__('Enable this to show unapproved recipes in the same list with others. They will be visible only to administrators and marked with a red message.', 'smk_theme'),
	'default'   => 'on',
));
$panel->addField( 'registered_only_can_view_recipes', 'checkbox', array(
	'title' => __('Registered only can view recipes', 'smk_theme'),
	'label' =>__('If this option is enabled, only registered users will be able to view recipes.', 'smk_theme'),
	'default'   => 'off',
));