<?php
abstract class Smk_Add_Recipe_Shortcode{
	public $name;

	public function __construct(){
		add_shortcode( $this->name, array( $this, 'render' ) );
	}
	
	abstract public function render( $atts = array() );
	
	public function atts( $pairs, $atts ){
		return shortcode_atts( $pairs , $atts, $this->name );
	}
}

/*
-------------------------------------------------------------------------------
[smk_submit_recipe]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Submit_Recipe extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_submit_recipe';

	public function render( $atts = array() ){
		smk_submit_recipe_form();
	}
}
new Smk_Shortcode_Submit_Recipe;

/*
-------------------------------------------------------------------------------
[smk_edit_recipe]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Edit_Recipe extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_edit_recipe';

	public function render( $atts = array() ){
		$post_id = ( !empty($_GET['id']) && absint($_GET['id']) > 0 ) ? absint($_GET['id']) : false;
		if( $post_id ){
			smk_submit_recipe_form( $post_id ); 
		}
		else{
			echo '<div class="notification red light center">'. __('You are not allowed to access this page.', 'smk_theme') .'</div>';
		}
	}
}
new Smk_Shortcode_Edit_Recipe;

/*
-------------------------------------------------------------------------------
[smk_members_list]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Members_List extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_members_list';

	public function render( $atts = array() ){
		smk_get_members_list();
	}
}
new Smk_Shortcode_Members_List;

/*
-------------------------------------------------------------------------------
[smk_recipe_tags_index]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Recipes_Tags_Index extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_tags_index';

	public function render( $atts = array() ){
		$atts = $this->atts( array(
			'title' => __('Filter tags:', 'smk_theme'),
		), $atts );
		smk_tags_index( $atts['title'] );
	}
}
new Smk_Shortcode_Recipes_Tags_Index;

/*
-------------------------------------------------------------------------------
[smk_register_user_form]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Registration_Form extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_register_user_form';

	public function render( $atts = array() ){
		$atts = $this->atts( array(
			'class' => '',
		), $atts );
		$class = !empty($atts['class']) ? ' '. sanitize_html_class( $atts['class'] ) : '';

		// $form = new Smk_Auth_Form;
		// echo '<div class="recipe-login-form-shortcode'. $class .'">';
		// 	$form->getForm();
		// echo '</div>';
	}
}
new Smk_Shortcode_Registration_Form;

/*
-------------------------------------------------------------------------------
[smk_recipe_search]
-------------------------------------------------------------------------------
*/
class Smk_Shortcode_Recipe_Search extends Smk_Add_Recipe_Shortcode{
	public $name = 'smk_recipe_search';

	public function render( $atts = array() ){
		$atts = $this->atts( array(
			'compact' => 0,
		), $atts );
		$compact = isset($atts['compact']) && $atts['compact'] != 0 ? true : false;

		echo smk_recipes_search( $compact );
	}
}
new Smk_Shortcode_Recipe_Search;