<?php
function smk_recipe_upload_image_result( $src = false, $attributes = array(), $img_block_class = '' ){
	$atts = array();
	if( !empty($attributes) ){
		foreach ($attributes as $att_name => $att_val) {
			$atts[] = $att_name .'="'. $att_val .'"';
		}
	}
	$src = ( !empty($src) && 'http' == substr($src, 0, 4) ) ? ' src="'. $src .'"' : '';
	$img_block_class = ( !empty($img_block_class) ) ? ' '. sanitize_html_class($img_block_class) : '';

	return '<div class="the-image'. $img_block_class .'">
		<div class="the-image-div"><img'. $src .' alt="" /></div>
		<span class="smk-uploader-remove-image remove">'. __('Remove', 'smk_theme') .'</span>
		<input type="hidden" '. implode(' ', $atts) .' />
	</div>';
}

function smk_submit_recipe_upload($id, $value, $uploader_size = 'size-thumbnail', $uploader_class = '') {

	if( $uploader_size == 'size-thumbnail' ){
		$width = 150;
		$height = 150;
	}
	elseif( $uploader_size == 'size-medium' ){
		$width = 300;
		$height = false;
	}
	elseif( $uploader_size == 'size-large' ){
		$width = 960;
		$height = false;
	}
	else{
		$width = 80;
		$height = 80;
	}

	$uploader_class = ( !empty($uploader_class) ) ? ' '. sanitize_html_class($uploader_class) : '';

	$value   = trim($value);
	$uploader_size  = ( !empty($uploader_size) ) ? ' '. sanitize_html_class($uploader_size) : '';
	$hide_upload_button = '';
	$output  = '';
	$output .= '<div class="smk-image-uploader'. $uploader_size . $uploader_class .'">';
		$output .= '<div class="smk-image-uploader-images-list the-images">';
			
			$output .= smk_recipe_upload_image_result( 
				'__the_src__', 
				array(
					'data-name'  => $id,
					'value' => '__the_value__',
				),
				'smk-the-image-hidden'
			);

			if( !empty( $value ) ){
				$output .= smk_recipe_upload_image_result( 
					smk_theme_resize( $value, $width, $height, true ), 
					array(
						'name'  => $id,
						'value' => $value,
					),
					'static-upload'
				);
				$hide_upload_button = ' style="display: none;"';
			}

		$output .= '</div>';
		$output .= '<div class="smk-image-uploader-button upload-button" title="'. __('Select image', 'smk_theme') .'"'. $hide_upload_button .'><i class="the-upload-icon fa fa-upload"></i></div>';
	$output .= '</div>';

	return $output;

}
function smk_submit_recipe_editor( $id, $name, $value, $settings = array() ) {

	$output = '';
	
	$settings = ( isset($settings) ) ? $settings : array();

	//Some settings, if they are not overwriten by options.
	$not_set = array(
		'textarea_rows' => 17,
		'media_buttons' => true,
	);

	//Do not allow these settings to be overwriten by options.
	$default_settings = array(
		'textarea_name' => $name,
		'tinymce' => array( 'plugins' => 'wordpress' )
	);

	//Final editor settings
	$editor_settings = array();
	if ( isset( $settings ) ) {
		$editor_settings = $settings;
	}
		$editor_settings = array_merge($not_set, array_merge($editor_settings, $default_settings) ) ;


	//Start the object
	ob_start();

	wp_editor( $value, esc_attr($id), $editor_settings);

	$output = ob_get_contents();

	ob_end_clean();

	return $output;

}

function smk_ingredient_acc_list( $settings = array() ){
	$def = array(
		'li_class' => '',
		'key_name' => '',
		'i'        => '',
		'q'        => '',
		'm'        => '',
		'n'        => '',
	);
	$s = wp_parse_args( $settings, $def );
	$li_class = !empty($s['li_class']) ? ' class="'. $s['li_class'] .'"' : '';

	$measurements = smk_ingredient_measurements();
	$select_measurements = '<select name="smk_recipe_ingredients[0]['. $s['key_name'] .'][measurement]" class="fullwidth this-section-measure-field">';
		$select_measurements .= '<option value="">- - - - -</option>';
		foreach ($measurements as $ms) {
			$select_measurements .= '<option value="'. $ms .'" '. selected( $ms, $s['m'], false) .'>'. $ms .'</option>';
		}
	$select_measurements .= '</select>';

	return '<li'. $li_class .'>
		<div>
			<span class="section-title mark light-gray">'. $s['i'] .'</span>
			<span class="delete-section mark red" title="'. __('Delete', 'smk_theme') .'"><i class="fa fa-close"></i></span>
			<span class="section-measure mark purple">'. $s['m'] .'</span>
			<span class="section-label mark blue">'. $s['q'] .'</span>
		</div>
		<div>
			<div class="grid-container">
				<div class="grid desk-7">
					<div class="form-label">'. __('Ingredient', 'smk_theme') .':</div>
					<input name="smk_recipe_ingredients[0]['. $s['key_name'] .'][ingredient]" type="text" class="fullwidth this-section-title-field" value="'. $s['i'] .'" />
				</div>
				<div class="grid desk-2">
					<div class="form-label">'. __('Quantity', 'smk_theme') .':</div>
					<input name="smk_recipe_ingredients[0]['. $s['key_name'] .'][quantity]" type="text" class="fullwidth this-section-label-field" value="'. $s['q'] .'" />
				</div>
				<div class="grid desk-3">
					<div class="form-label">'. __('Measurement', 'smk_theme') .':</div>
					'. $select_measurements .'
				</div>
				
				<div class="grid desk-12">
					<div class="form-label">'. __('Additional notes(optional)', 'smk_theme') .':</div>
					<input name="smk_recipe_ingredients[0]['. $s['key_name'] .'][notes]" type="text" class="fullwidth" value="'. $s['n'] .'" />
				</div>

			</div>
		</div>
	</li>';
}	

function smk_submit_recipe_form( $post_id = false ){
	$submit_type         = false;
	$post_image          = '';
	$post_title          = '';
	$post_category       = array();
	$post_ingredients    = '';
	$post_content        = '';
	$post_footnotes      = '';
	$post_tags           = '';
	$post_difficulty     = 'easy';
	$post_prep_time      = '';
	$post_links          = '';
	
	$post_id_field       = '';
	$recipe_edit_message = '';
	
	// Upadate post
	if( !empty( $post_id ) && absint( $post_id ) > 0 ){
		if( smk_user_can_edit_recipe( $post_id ) && smk_recipe_exists( $post_id ) ){

			// Post data
			$post_image       = wp_get_attachment_url( get_post_thumbnail_id( $post_id ) );

			$post_title       = get_post_field( 'post_title', $post_id );
			$post_category    = get_the_terms( $post_id, 'recipe_categories' );
			$post_category    = ( is_array($post_category) ) ? $post_category : array();
			if( !empty($post_category) ){
				$slugs = array();
				foreach ($post_category as $term) {
					$slugs[] = $term->slug;
				}
				$post_category = $slugs;
			}

			$post_ingredients = get_post_meta( $post_id, 'smk_recipe_ingredients', true );
			$post_ingredients = !empty($post_ingredients[0]) ? $post_ingredients[0] : false;

			$post_content     = get_post_field( 'post_content', $post_id );
			$post_footnotes   = get_post_meta( $post_id, 'smk_recipe_footnotes', true );

			$post_tags        = get_the_terms( $post_id, 'recipe_tags' );
			$post_tags        = ( is_array($post_tags) ) ? $post_tags : array();
			if( !empty($post_tags) ){
				$names = array();
				foreach ($post_tags as $term) {
					$names[] = $term->name;
				}
				$post_tags = $names;
			}
			$post_tags = ( ! empty($post_tags) && is_array($post_tags) ) ? join(', ', $post_tags) : '';

			$post_difficulty  = get_post_meta( $post_id, 'smk_recipe_difficulty', true );
			$post_difficulty  = ( !empty($post_difficulty) && in_array($post_difficulty, array('easy','moderate','hard', ) ) ) ? $post_difficulty : 'easy';

			$post_prep_time   = get_post_meta( $post_id, 'smk_recipe_preparation_time', true );

			$post_links = get_post_meta( $post_id, 'smk_recipe_links', true );
			$post_links = !empty($post_links[0]) ? $post_links[0] : false;

			$post_id_field    = '<input name="post_id" type="hidden" value="'. $post_id .'" />';
			
			$recipe_edit_message = '<div class="notification blue super-light">'. sprintf( 
				__('You are editing the recipe: %s', 'smk_theme'),
				'<a href="'. get_permalink( $post_id ) .'">'. get_the_title( $post_id ) .'</a>'
			) .'</div>';

			$submit_type = 'update';
		}
		else{
			echo '<div class="notification red light center">'. __('You are not allowed to access this page.', 'smk_theme') .'</div>';
			return;
		}
	}

	// Submit new post
	else{
		if( smk_recipe_submission_enabled() === false && ! smk_user_role_is( 'administrator' ) && ! smk_user_role_is( 'editor' )  ){
			echo '<div class="notification red light center">'. __('The recipe submission is disabled.', 'smk_theme') .'</div>';
			return;
		}
		$submit_type = 'new';
	}

	// Enabled fields, set from admin panel
	$enabled = smk_recipe_setting( 'recipe_submission_enabled_fields', array() );
	if( !is_array($enabled) ){
		$enabled = array();
	}
	$e_featured_image = in_array('featured_image', $enabled);
	$e_ingredients    = in_array('ingredients', $enabled);
	$e_prep_mode      = in_array('prep_mode', $enabled);
	$e_tags           = in_array('tags', $enabled);
	$e_difficulty     = in_array('difficulty', $enabled);
	$e_prep_time      = in_array('prep_time', $enabled);
	$e_footnotes      = in_array('footnotes', $enabled);
	$e_links          = in_array('links', $enabled);


	$output = '';
	$output .= $recipe_edit_message;

	$output .= '<div class="grid-container">';
	$output .= '<form method="post" id="smk-submit-recipe">';
		
		$output .= $post_id_field;
		
		if($e_featured_image){
			$output .= '<div class="grid desk-12 both" data-field="featured_image">
				<div class="form-label">'. __('Image', 'smk_theme') .'</div>
				<div class="form-description">'. __('Please select a large image file to upload and set it for this recipe. Allowed image extensions are: *.jpg, *.jpeg or *.png. Min. image size: 780x400 pixels.', 'smk_theme') .'</div>
				'. smk_submit_recipe_upload('featured_image', $post_image, 'size-large') .'
			</div>';
			
		}

		$output .= '<div class="grid desk-8 alpha" data-field="title">
			<div class="form-label">'. __('Title', 'smk_theme') .'</div>
			<input name="title" type="text" class="fullwidth" value="'. $post_title .'" />
		</div>';
		
		$all_categories = smk_recipes_filter_all_categories( array( 'hide_empty' => false ) );
		$cats = '<option value=""></option>';
		if( !empty( $all_categories ) ){
			foreach ($all_categories as $val => $att) {
				$cat_selected = ( in_array($val, $post_category) ) ? ' selected="selected"' : '';
				$cats .= '<option value="'. $val .'"'. $cat_selected .'>'. $att['name'] .'</option>';
			}
		}
		$output .= '<div class="grid desk-4 omega" data-field="category">
			<div class="form-label">'. __('Category', 'smk_theme') .'</div>
			<select name="category" class="fullwidth">
				'. $cats .'
			</select>
		</div>';

		if($e_ingredients){
			$output .= '<div class="grid desk-12 both" data-field="smk_recipe_ingredients">
				<div class="form-label">'. __('Ingredients', 'smk_theme') .'</div>
				<div class="form-description">'. __('Include amounts/measurements for each ingredient. (Note: Recipes that don\'t have ingredient measurements can\'t be approved and published.). Also you may add some additional for each ingredient if required.', 'smk_theme') .'</div>
				<!-- Accordion begin -->
				<ul class="submission-form-repeatable">'; 

					// Default invisible, not saved, used for clone
					$output .= smk_ingredient_acc_list(array(
						'li_class' => 'sfa-noindex',
						'key_name' => '__noindex__',
					));

					// Post update
					if( !empty($post_ingredients) && is_array($post_ingredients) ){
						foreach ($post_ingredients as $ingr_id => $ingr_val) {
							$output .= smk_ingredient_acc_list(array(
								'key_name' => $ingr_id,
								'i'        => ( !empty($ingr_val['ingredient']) ) ? $ingr_val['ingredient'] : '',
								'q'        => ( !empty($ingr_val['quantity']) ) ? $ingr_val['quantity'] : '',
								'm'        => ( !empty($ingr_val['measurement']) ) ? $ingr_val['measurement'] : '',
								'n'        => ( !empty($ingr_val['notes']) ) ? $ingr_val['notes'] : '',
							));
						}
					}

					// New post
					else{
						$output .= smk_ingredient_acc_list(array(
							'li_class' => 'acc_active',
							'key_name' => 'first_ingredient',
						));
					}

				$output .= '</ul>
				<!-- Accordion end -->

				<div class="submission-form-repeatable-add-new"><i class="the-icon fa fa-plus"></i> '. __('Add new', 'smk_theme') .'</div>

			</div>';
		}

		if($e_prep_mode){
			$output .= '<div class="grid desk-12 both" data-field="preparation_mode">
				<div class="form-label">'. __('Preparation mode', 'smk_theme') .'</div>
				<div class="form-description">'. __('List steps in the way they should be done in order to successfully make the dish. Be specific, but keep it short.', 'smk_theme') .'</div>
				<div class="recipe-editor-mce">'. smk_submit_recipe_editor( 'preparation_mode', 'preparation_mode', $post_content ) .'</div>
			</div>';
		}
		
		if($e_footnotes){
			$output .= '<div class="grid desk-12 both" data-field="footnotes">
				<div class="form-label">'. __('Footnotes(optional)', 'smk_theme') .'</div>
				<div class="form-description">'. __('Include info about other ways to cook or serve this dish. Add tips for ingredients substitutions. Don\'t add info that describes the recipe - that goes best in the "Preparation mode" field.', 'smk_theme') .'</div>
				<div class="recipe-editor-mce">'. smk_submit_recipe_editor( 'footnotes', 'footnotes', $post_footnotes ) .'</div>
			</div>';
		}

		if($e_tags){
			$output .= '<div class="grid desk-12 both" data-field="tags">
				<div class="form-label">'. __('Tags', 'smk_theme') .'</div>
				<div class="form-description">'. __('Enter a maximum of 15 tags separated by comma.', 'smk_theme') .'</div>
				<input name="tags" type="text" class="fullwidth" value="'. $post_tags .'" />
			</div>';	
		}

		if($e_difficulty){
			$output .= '<div class="grid desk-12 both" data-field="difficulty">
				<div class="form-label">'. __('Difficulty', 'smk_theme') .'</div>
				<div class="form-description">'. __('Select the level of this recipe.', 'smk_theme') .'</div>
				<div class="visual-select">
					<label><input type="radio" name="difficulty" value="easy" data-label="'. __('Easy', 'smk_theme') .'" '. checked( 'easy', $post_difficulty, false ) .'>'. __('Easy', 'smk_theme') .'</label>
					<label><input type="radio" name="difficulty" value="moderate" data-label="'. __('Moderate', 'smk_theme') .'" '. checked( 'moderate', $post_difficulty, false ) .'>'. __('Moderate', 'smk_theme') .'</label>
					<label><input type="radio" name="difficulty" value="hard" data-label="'. __('Hard', 'smk_theme') .'" '. checked( 'hard', $post_difficulty, false ) .'>'. __('Hard', 'smk_theme') .'</label><br><br>
				</div>
			</div>';
		}

		if($e_prep_time){
			$output .= '<div class="grid desk-12 both" data-field="preparation_time">
				<div class="form-label">'. __('Preparation time(in minutes)', 'smk_theme') .'</div>
				<div class="form-description">'. __('How long it takes to do and finish everything.', 'smk_theme') .'</div>
				<input name="preparation_time" type="number" value="'. $post_prep_time .'" />
			</div>';
		}

		if($e_links){
			$output .= '<div class="grid desk-12 both" data-field="smk_recipe_links">
				<div class="form-label">'. __('Links(optional)', 'smk_theme') .'</div>
				<div class="form-description">'. __('Have more info about this? Post the links here for reference.', 'smk_theme') .'</div>
				<!-- Accordion begin -->
				<ul class="submission-form-repeatable">

					<li class="sfa-noindex">
						<div>
							<span class="section-title mark light-gray"></span>
							<span class="delete-section mark red" title="'. __('Delete', 'smk_theme') .'"><i class="fa fa-close"></i></span>
							<span class="section-label mark blue"></span>
						</div>
						<div>
							<div class="grid-container">
								<div class="grid desk-6">
									<div class="form-label">'. __('URL', 'smk_theme') .':</div>
									<input name="smk_recipe_links[0][__noindex__][url]" type="text" class="fullwidth this-section-title-field" value="" />
								</div>
								<div class="grid desk-6">
									<div class="form-label">'. __('Title', 'smk_theme') .':</div>
									<input name="smk_recipe_links[0][__noindex__][title]" type="text" class="fullwidth this-section-label-field" value="" />
								</div>
							</div>
						</div>
					</li>';

					// Post update
					if( !empty($post_links) && is_array($post_links) ){
						foreach ($post_links as $link_id => $link_val) {
							$u = ( !empty($link_val['url']) ) ? $link_val['url'] : '';
							$t = ( !empty($link_val['title']) ) ? $link_val['title'] : '';

							$output .= '<li>
								<div>
									<span class="section-title mark light-gray">'. $u .'</span>
									<span class="delete-section mark red" title="'. __('Delete', 'smk_theme') .'"><i class="fa fa-close"></i></span>
									<span class="section-label mark blue">'. $t .'</span>
								</div>
								<div>
									<div class="grid-container">
										<div class="grid desk-6">
											<div class="form-label">'. __('URL', 'smk_theme') .':</div>
											<input name="smk_recipe_links[0]['. $link_id .'][url]" type="text" class="fullwidth this-section-title-field" value="'. $u .'" />
										</div>
										<div class="grid desk-6">
											<div class="form-label">'. __('Title', 'smk_theme') .':</div>
											<input name="smk_recipe_links[0]['. $link_id .'][title]" type="text" class="fullwidth this-section-label-field" value="'. $t .'" />
										</div>
									</div>
								</div>
							</li>';
						}
					}
					else{
						$output .= '<li class="acc_active">
							<div>
								<span class="section-title mark light-gray"></span>
								<span class="delete-section mark red" title="'. __('Delete', 'smk_theme') .'"><i class="fa fa-close"></i></span>
								<span class="section-label mark blue"></span>
							</div>
							<div>
								<div class="grid-container">
									<div class="grid desk-6">
										<div class="form-label">'. __('URL', 'smk_theme') .':</div>
										<input name="smk_recipe_links[0][first_link][url]" type="text" class="fullwidth this-section-title-field" value="" />
									</div>
									<div class="grid desk-6">
										<div class="form-label">'. __('Title', 'smk_theme') .':</div>
										<input name="smk_recipe_links[0][first_link][title]" type="text" class="fullwidth this-section-label-field" value="" />
									</div>
								</div>
							</div>
						</li>';
					}

				$output .= '</ul>
				<!-- Accordion end -->

				<div class="submission-form-repeatable-add-new"><i class="the-icon fa fa-plus"></i> '. __('Add new', 'smk_theme') .'</div>

			</div>
			<p class="clearfix"></p>
			';
		}

		$output .= '<div class="grid desk-12 both clearfix">
			<input id="smk-submit-recipe-button" type="submit" value="'. __('Submit', 'smk_theme') .'" class="button primary" /><br /><br />
		</div>';

	$output .= '</form>';
	$output .= '</div>';
	if( is_user_logged_in() ){
		do_action('smk_submit_recipe_before_form', $submit_type, $post_id);
		echo $output;
		do_action('smk_submit_recipe_after_form', $submit_type, $post_id);
	}
	else{
		echo '<div class="notification red light center">'. __('Please log in.', 'smk_theme') .'</div>';
	}
	
}

/*
-------------------------------------------------------------------------------
Example:
smk_insert_recipe( array(
	'post_content'   => '',
	'post_title'     => '',
	'recipe_meta'    => array(
		'featured_image'   => '',
		'categories'       => '',
		'ingredients'      => '',
		'footnotes'        => '',
		'preparation_time' => '',
		'difficulty'       => '',
		'links'            => '',
		'tags'             => '',
	),
) );
-------------------------------------------------------------------------------
*/
function smk_insert_recipe( $post_data = array() ){
	$post_id = ( !empty( $post_data['ID']) && absint( $post_data['ID'] ) > 0 ) ? absint( $post_data['ID'] ) : false;
	
	$post_data_defaults = array(
		'post_content'   => '', // The full text of the post.
		'post_title'     => '',
		'recipe_meta'    => array(),  // Recipe meta info
	); 

	$post_data = wp_parse_args( $post_data, $post_data_defaults );
	$post_data['post_type']   = 'smk_recipes';
	$post_data['ping_status'] = 'closed';

	if( empty($post_id) ){
		if( current_user_can( 'edit_others_posts' ) ){
			$post_data['post_status'] = 'publish';
		}
		else{
			$post_data['post_status'] = 'pending';
		}
	}
	else{
		$post_status = get_post_status( $post_id );
		$post_data['post_status'] = $post_status;
	}

	$post_meta = wp_parse_args( $post_data['recipe_meta'], array(
		'featured_image'   => '',
		'categories'       => '',
		'ingredients'      => '',
		'footnotes'        => '',
		'preparation_time' => '',
		'difficulty'       => '',
		'links'            => '',
		'tags'             => '',
	) );

	// Submit main data
	if( $post_id ){
		$post_id = wp_update_post( $post_data );
		if( $post_id > 0 && $post_data['post_status'] == 'publish' ){
			do_action('smk_update_recipe', $post_id);
		}
	}
	else{
		$post_id = wp_insert_post( $post_data );
		if( $post_id > 0 && $post_data['post_status'] == 'publish' ){
			do_action('smk_publish_recipe', $post_id);
		}
	}

	// If all is ok, we have a valid ID, update post info
	if( absint($post_id) > 0 ){
		
		// Set featured image
		$featured_image = ( !empty( $post_meta['featured_image'] ) ) ? esc_url( $post_meta['featured_image'] ) : '';
		if( !empty($featured_image) ){
			$image_id       = smk_get_image_id_by_url( $featured_image );
			set_post_thumbnail( $post_id, $image_id );
		}

		// Set category
		wp_set_object_terms( $post_id, $post_meta['categories'], 'recipe_categories', false );

		// Set ingredients
		update_post_meta($post_id, 'smk_recipe_ingredients', $post_meta['ingredients']);
		$ingredients_tax = array();
		if( !empty( $post_meta['ingredients'][0] ) ){
			foreach ($post_meta['ingredients'][0] as $ingr_index => $ingredient) {
				if( !empty($ingredient['ingredient']) ){
					$ingredients_tax[] = $ingredient['ingredient'];
				}
			}
		}
		wp_set_object_terms( $post_id, $ingredients_tax, 'recipe_ingredients', false );

		// Set footnotes
		update_post_meta($post_id, 'smk_recipe_footnotes', $post_meta['footnotes']);

		// Prep time
		update_post_meta($post_id, 'smk_recipe_preparation_time', $post_meta['preparation_time']);

		// Difficulty
		update_post_meta($post_id, 'smk_recipe_difficulty', $post_meta['difficulty']);

		// Set links
		update_post_meta($post_id, 'smk_recipe_links', $post_meta['links']);

		// Set tags
		wp_set_object_terms( $post_id, $post_meta['tags'], 'recipe_tags', false );

		// Make not featured from start
		$is_featured = get_post_meta( $post_id, 'smk_recipe_is_featured', true );
		if( empty($is_featured) ){
			update_post_meta( $post_id, 'smk_recipe_is_featured', 'no' );
			update_post_meta( $post_id, 'smk_recipe_featured_time', '0' );
		}

	}
	return $post_id;
}

/*
-------------------------------------------------------------------------------
Update is the same as insert, just it require a secondary parameter with the post ID
-------------------------------------------------------------------------------
*/
function smk_update_recipe( $post_data = array(), $post_id = false ){
	$post_data['ID'] = $post_id;
	$the_post_id = smk_insert_recipe( $post_data );
	return $the_post_id;
}

/*
-------------------------------------------------------------------------------
The ajax handler
-------------------------------------------------------------------------------
*/
function smk_submit_recipe_ajax_handler(){
	if( isset($_POST) ){
		$req_fields = smk_recipe_setting( 'recipe_submission_required_fields' );
		$req_fields = ( isset($req_fields) ) ? (array) $req_fields : array();

		/* Set the variable for response messages
		------------------------------------------------*/
		$msg = array();

		/* Get submitted data
		------------------------------------------------*/
		$form_data = !empty($_POST['data']) ? $_POST['data'] : false;
		parse_str($form_data, $data);
		// print_r($data);

		/* Enabled fields, set from admin panel
		------------------------------------------------*/
		$enabled = smk_recipe_setting( 'recipe_submission_enabled_fields', array() );
		if( !is_array($enabled) ){
			$enabled = array();
		}
		$e_featured_image = in_array('featured_image', $enabled);
		$e_ingredients    = in_array('ingredients', $enabled);
		$e_prep_mode      = in_array('prep_mode', $enabled);
		$e_tags           = in_array('tags', $enabled);
		$e_difficulty     = in_array('difficulty', $enabled);
		$e_prep_time      = in_array('prep_time', $enabled);
		$e_footnotes      = in_array('footnotes', $enabled);
		$e_links          = in_array('links', $enabled);


		/* Sanitize and validate everything
		------------------------------------------------*/
		// Title
		$featured_image = ( !empty($data['featured_image']) ) ? esc_url( $data['featured_image'] ) : false;
		$featured_image_required = in_array( 'featured_image', $req_fields );
		if( $e_featured_image && $featured_image_required && empty($featured_image) ) {
			$msg['featured_image'] = __('Please select an image.', 'smk_theme');
		}
		elseif( !empty($featured_image) ){
			$min_img_width = absint( smk_recipe_setting( 'recipe_submission_min_image_width', 0 ) );
			$f_img_id      = smk_get_image_id_by_url( $featured_image );
			$f_attr        = wp_get_attachment_image_src( $f_img_id, 'full' );

			if( !empty($f_attr[1]) && absint($f_attr[1]) < $min_img_width ){
				$msg['featured_image'] = sprintf( 
					__('The selected image is too small. Please select another image that is bigger.', 'smk_theme'), 
					$f_attr[1],
					$f_attr[2]
				);
			}
			$f_imgtype = get_post_mime_type($f_img_id);
			if( !empty($f_imgtype) && ! in_array( $f_imgtype, array('image/jpeg', 'image/png') ) ){
				$msg['featured_image'] = __('Invalid image type.', 'smk_theme');
			}
		}

		// Title
		$title = ( !empty($data['title']) ) ? trim( strip_tags( $data['title'] ) ) : false;
		if( empty($title) ) {
			$msg['title'] = __('Please enter a valid title.', 'smk_theme');
		}

		// Preparation Mode
		$preparation_mode = ( !empty($data['preparation_mode']) ) ? $data['preparation_mode'] : false;
		$prep_mode_required = in_array( 'prep_mode', $req_fields );
		if( $e_prep_mode && empty($preparation_mode) && $prep_mode_required ) {
			$msg['preparation_mode'] = __('Please write the preparation instructions here.', 'smk_theme');
		}

		// Category
		$category       = ( !empty($data['category']) ) ? $data['category'] : false;
		$all_categories = smk_recipes_filter_all_categories( array( 'hide_empty' => false ) );
		if( empty($category) ) {
			$msg['category'] = __('Please select a category.', 'smk_theme');
		}
		elseif( !array_key_exists($category, $all_categories) ){
			$msg['category'] = __('Invalid category.', 'smk_theme');
		}

		// Ingredients 
		$ingredients = ( !empty($data['smk_recipe_ingredients'][0]) && is_array($data['smk_recipe_ingredients'][0]) ) ? $data['smk_recipe_ingredients'][0] : false;
		$ingredients_required = in_array( 'ingredients', $req_fields );
		unset($ingredients['__noindex__']);
		if( $e_ingredients && $ingredients_required && empty($ingredients) ){
			$msg['smk_recipe_ingredients'] = __('Please add the ingredients.', 'smk_theme');
		}
		elseif( !empty($ingredients) ){
			$new_ingr = array();
			foreach ($ingredients as $ingr_id => $ingr_value) {
				$i = ( !empty($ingr_value['ingredient']) ) ? strip_tags( trim($ingr_value['ingredient']) ) : false;
				$q = ( !empty($ingr_value['quantity']) ) ? strip_tags( trim($ingr_value['quantity']) ) : false;
				$m = ( !empty($ingr_value['measurement']) ) ? strip_tags( trim($ingr_value['measurement']) ) : false;
				$n = ( !empty($ingr_value['notes']) ) ? strip_tags( trim($ingr_value['notes']) ) : false;
				if( !empty($i) ){
					$new_ingr[ $ingr_id ] = array(
						'ingredient'  => $i,
						'quantity'    => $q,
						'measurement' => $m,
						'notes'       => $n,
					);
				}
			}
			$ingredients = $new_ingr;
		}

		if( $e_ingredients && $ingredients_required && empty($ingredients) ){
			$msg['smk_recipe_ingredients'] = __('Please add the ingredients.', 'smk_theme');
		}
		else{
			$final_ingredients = array();
			$final_ingredients[0] = $ingredients;
		}

		// Footnotes 
		$footnotes = ( !empty($data['footnotes']) ) ? wp_kses_post( $data['footnotes'] ) : '';
		$footnotes_required = in_array( 'footnotes', $req_fields );
		if( $e_footnotes && $footnotes_required && empty($footnotes) ){
			$msg['footnotes'] = __('Please add some notes.', 'smk_theme');
		}

		// Preparation time
		$preparation_time = ( !empty($data['preparation_time']) ) ? absint( $data['preparation_time'] ) : false;
		$prep_time_required = in_array( 'prep_time', $req_fields );
		if( $e_prep_time && $prep_time_required && ($preparation_time > 0) == false ){
			$msg['preparation_time'] = __('The preparation time must be greater than 1 minute.', 'smk_theme');
		}

		// Difficulty
		$difficulty = ( !empty($data['difficulty']) && in_array( $data['difficulty'], array('easy','moderate','hard', ) ) ) ? $data['difficulty'] : 'easy';
		if( $e_difficulty && empty( $difficulty ) ){
			$msg['difficulty'] = __('Please select the difficulty', 'smk_theme');
		}

		// Tags
		$the_tags = !empty($data['tags']) ? array_map( 'trim', explode(',', $data['tags']) ) : false;
		$tags_required = in_array( 'tags', $req_fields );
		if( $e_tags && $tags_required && empty( $the_tags ) ){
			$msg['tags'] = __('Please enter the tags.', 'smk_theme');
		}

		// Ingredients 
		$links = ( !empty($data['smk_recipe_links'][0]) && is_array($data['smk_recipe_links'][0]) ) ? $data['smk_recipe_links'][0] : false;
		unset($links['__noindex__']);
		if( !empty($links) ){
			$new_links = array();
			foreach ($links as $link_id => $link_value) {
				$u = ( !empty($link_value['url']) ) ? strip_tags( trim($link_value['url']) ) : false;
				$t = ( !empty($link_value['title']) ) ? strip_tags( trim($link_value['title']) ) : false;
				if( !empty($u) ){
					if( 'http' != substr($u, 0, 4) ){
						$u = 'http://'. $u;
					}
					if (strpos($u, '.') == false) {
						$u = $u .'.com';
					}
					$new_links[ $link_id ] = array(
						'url'   => $u,
						'title' => $t,
					);
				}
			}
			$links[0] = $new_links;
		}

		/* If there are no error messages, proceed and submit this entry.
		------------------------------------------------*/
		if( empty($msg) ){

			$post_id = false;
			
			$post_data = array(
				'post_content'   => $preparation_mode, // The full text of the post.
				'post_title'     => $title,
				'recipe_meta'    => array(
					'featured_image'   => $featured_image,
					'categories'       => $category,
					'ingredients'      => $final_ingredients,
					'footnotes'        => $footnotes,
					'preparation_time' => $preparation_time,
					'difficulty'       => $difficulty,
					'links'            => $links,
					'tags'             => $the_tags,
				),
			); 

			// Update recipe
			if( !empty( $data['post_id'] ) ){
				$post_id = absint($data['post_id']);
				if( $post_id > 0 ){
					if( smk_user_can_edit_recipe( $post_id ) ){
						$post_id = smk_update_recipe( $post_data, $post_id );
						$msg['submit_type']  = 'updated';
						$msg['post_status']  = 'publish';
					}
				}
			}

			// Submit new recipe
			else{
				$post_id = smk_insert_recipe( $post_data);
				$msg['submit_type']  = 'new';
				$msg['post_status']  = get_post_status( $post_id );
			}

			// If all is ok, we have a valid ID
			if( absint($post_id) > 0 ){
				$msg['post_id']  = $post_id;
				$msg['post_url'] = get_permalink( $post_id );
				$msg['user_recipes_url'] = smk_user_recipes_list( get_post_field( 'post_author', $post_id ) );
			}
		}

		/* Return final message(s)
		------------------------------------------------*/
		echo json_encode($msg);
	}
	die();
}
add_action( 'wp_ajax_smk_submit_recipe_ajax_handler', 'smk_submit_recipe_ajax_handler' );