<?php
require_once (SMK_THEME_LIB . 'mod/user/user.php');
require_once (SMK_THEME_LIB . 'mod/user/links.php');
require_once (SMK_THEME_LIB . 'mod/user/user-reputation.php');
require_once (SMK_THEME_LIB . 'mod/user/user-last-visit.php');
require_once (SMK_THEME_LIB . 'mod/user/user-views.php');
require_once (SMK_THEME_LIB . 'mod/user/user-location.php');
require_once (SMK_THEME_LIB . 'mod/user/user-registration-date.php');
require_once (SMK_THEME_LIB . 'mod/user/user-cooking-level.php');

require_once (SMK_THEME_LIB . 'mod/user/user-following.php');
require_once (SMK_THEME_LIB . 'mod/user/user-followers.php');
require_once (SMK_THEME_LIB . 'mod/user/follow.php');

require_once (SMK_THEME_LIB . 'mod/user/fields/base.php');
require_once (SMK_THEME_LIB . 'mod/user/fields/input-type.php');

require_once (SMK_THEME_LIB . 'mod/user/fields/create.php');

require_once (SMK_THEME_LIB . 'mod/user/add-meta.php');

/* Private messages
------------------------------------------------*/
require_once (SMK_THEME_LIB . 'mod/user/pm/private-messages-cpt.php');
require_once (SMK_THEME_LIB . 'mod/user/pm/private-messages-form.php');
require_once (SMK_THEME_LIB . 'mod/user/pm/private-messages-list.php');
require_once (SMK_THEME_LIB . 'mod/user/pm/private-messages.php');

/* Authentification system
------------------------------------------------*/
require_once (SMK_THEME_LIB . 'mod/user/auth/form.php');

/* Reputation system
------------------------------------------------*/
require_once (SMK_THEME_LIB . 'mod/user/reputation/reputation.php');

/* User settings
------------------------------------------------*/
require_once (SMK_THEME_LIB . 'mod/user/settings/settings.php');

$login_form = new Smk_Auth_Form;
$login_form->register();

$follow_user = new Smk_Theme_User_Follow;
$follow_user->register();

function smk_theme_user_update_last_visit(){
	$last_visit = new Smk_Theme_User_LastVisit;
	$last_visit->updateLastVisit();
}
add_action('wp_head', 'smk_theme_user_update_last_visit', 20);

/* Custom user avatar
------------------------------------------------*/

function smk_custom_avatar( $avatar, $id_or_email, $size, $default, $alt ) {
	$user = false;
		
	if ( is_numeric( $id_or_email ) ) {
			
		$id = (int) $id_or_email;
		$user = get_user_by( 'id' , $id );
			
	} 
	elseif ( is_object( $id_or_email ) ) {
		if ( ! empty( $id_or_email->user_id ) ) {
			$id = (int) $id_or_email->user_id;
			$user = get_user_by( 'id' , $id );
		}	
	} 
	else {
		$user = get_user_by( 'email', $id_or_email );	
	}
		
	if ( $user && is_object( $user ) ) {
		$user_id = $user->data->ID;

		$custom_avatar_url = get_user_meta( $user_id, 'custom_user_avatar', true );
		if( !empty($custom_avatar_url) ){
			$avatar_url = smk_theme_resize($custom_avatar_url, $size, $size, true, true, true);
			$avatar = "<img alt='{$alt}' src='{$avatar_url}' class='avatar avatar-{$size} photo' />";
		}
	}

	return $avatar;
}
add_filter( 'get_avatar' , 'smk_custom_avatar' , 1 , 5 );

/* User settings
------------------------------------------------*/
require_once (SMK_THEME_LIB . 'mod/user/summary.php');