<?php 
function smk_user_summary_tabs($curauth){
	do_action('smk_user_summary_tabs', $curauth);
}
function smk_user_summary_tabs_content($curauth){
	do_action('smk_user_summary_tabs_content', $curauth);
}

function smk_user_summary_all_tabs(){
	return apply_filters('smk_user_summary_all_tabs', array());
}


abstract class Smk_User_Summary_Tab{

	protected $id;
	protected $label;
	protected $tabs;
	protected $tabsInclusive;
	protected $activeTab;

	public function __construct($id, $label){
		$this->id    = $id;
		$this->label = $label;
		$this->tabs  = smk_user_summary_all_tabs();

		if( !in_array( $this->id, $this->tabs ) ){
			add_filter( 'smk_user_summary_all_tabs', array( $this, 'registerTab' ) );
			add_action( 'smk_user_summary_tabs', array( $this, 'tabDisplay' ) );
			add_action( 'smk_user_summary_tabs_content', array( $this, 'contentDisplay' ) );
		}

		$this->tabsInclusive = smk_user_summary_all_tabs();
		$this->activeTab     = $this->getActiveTab();
	}

	abstract public function content( $user );

	public function returnTab(){
		return true;
	}

	public function count( $user ){
		return false;
	}

	public function tabDisplay( $user ){
		if( $this->returnTab() ){
			$link  = get_author_posts_url( $user->ID ) .'?profile-summary='.  $this->id;
			$label = '<span class="title">'. $this->label .'</span>';
			$count = $this->count( $user );
			$count = ( $count !== false ) ? '<span class="count">'. absint($count) .'</span>' : '';
			$active = ( $this->getActiveTab() == $this->id ) ? ' class="active"' : '';
			echo '<li'. $active .'><a href="'. $link .'">'. $label . $count .'</a></li>';
		}
	}

	public function contentDisplay( $user ){
		if( $this->getActiveTab() == $this->id && $this->returnTab() ){
			$this->content( $user );
		}
	}

	public function registerTab($tabs){
		$tabs[] = $this->id;
		return $tabs;
	}

	public function getActiveTab(){
		return ( !empty($_GET['profile-summary']) ) ? $_GET['profile-summary'] : 'activity';
	}

}