<?php
if( class_exists( 'Smk_Theme_User' ) && ! class_exists('Smk_Theme_User_RegistrationDate') ){
	class Smk_Theme_User_RegistrationDate extends Smk_Theme_User{
		
		public function settings(){
		 	return array(
				'id' => 'user_registered',
				'std' => '',
				'title' => __('Member since', 'smk_theme'),
			);
		}

		//------------------------------------//--------------------------------------//
				
		/**
		 * Registration date show
		 *
		 * Get the registration date
		 *
		 * @param string $format Date format http://php.net/manual/en/function.date.php#refsect1-function.date-parameters  
		 * @return string 
		 */
		public function show( $format = 'd F Y' ){
			$date_return = false;
			$current_user = $this->currentAuthor();
			if( !empty( $current_user ) && is_object( $current_user ) ){
				$date = date_create_from_format('Y-m-d H:i:s', $current_user->user_registered);
				if( !empty( $date ) ){
					$date_return = date_format($date, $format);
				}
			}
			return $date_return;
		}

	}
}