<?php
if( class_exists( 'Smk_Theme_User' ) && ! class_exists('Smk_Theme_User_ProfileViews') ){
	class Smk_Theme_User_ProfileViews extends Smk_Theme_User{
		
		public function settings(){
		 	return array(
				'id' => 'st_profile_views',
				'std' => '1',
				'title' => __('Profile views', 'smk_theme'),
			);
		}

		//------------------------------------//--------------------------------------//
				
		/**
		 * Profile views number
		 *
		 * Get the number of profile views
		 *
		 * @return string 
		 */
		public function show(){
			$meta = $this->getMeta();
			return isset( $meta ) ? number_format($meta, 0, '.', ' ') : false;
		}

		public function updateViews(){
			if( is_author() ){
				$user = $this->currentUser();
				$author = $this->currentAuthor();

				// If this profile is not the current user update info
				if( $user != $author ){
					$prev = $this->getMeta();
					update_user_meta( $author->ID, $this->field['id'], absint( $prev + 1 ), $prev );
				}
			}
		}

	}
}