<?php
/* 
 * Log
 *
 * Cach errors and add them to Smk Toolkit log page.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-02 19:18:57
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-03 00:22:25
 *
 */

//------------------------------------//--------------------------------------//

/**
 * Get all log messages
 *
 * @return array 
 */
function smk_toolkit_log_messages(){
	return apply_filters('smk_toolkit_log_messages', array());
}

//------------------------------------//--------------------------------------//

/**
 * Log class
 *
 * The class that allows to catch log messages
 *
 * @param string $type Message type
 * @param string $message Message text
 * @return void 
 */
if( ! class_exists('Smk_Log') ){
	class Smk_Log{

		//------------------------------------//--------------------------------------//
		
		/**
		 * Message type
		 *
		 * @return string 
		 */
		public $type;

		//------------------------------------//--------------------------------------//
		
		/**
		 * Message text
		 *
		 * @return string 
		 */
		public $message;

		//------------------------------------//--------------------------------------//
		
		public function __construct($type = 'w', $message = ''){
			$this->type = $type;
			$this->message = $message;
			add_filter('smk_toolkit_log_messages', array($this, 'message'), 99);
		}//__construct

		//------------------------------------//--------------------------------------//
		
		/**
		 * Message
		 *
		 * A single error message
		 * 
		 * @param string $other_messages Other messages from log
		 * @return void
		 */
		public function message($other_messages){
			$new[] = array(
				'type' => $this->type,
				'msg'  => $this->message,
			);
			return array_merge($other_messages, $new);
		}

	}
}


//------------------------------------//--------------------------------------//

/**
 * Smk Log
 *
 * Add new message to log
 *
 * @param string $type Message type
 * @param string $message Message text
 * @return void
 */
if( ! function_exists('smk_log') ){
	function smk_log($type = '', $message = ''){
		return new Smk_Log($type, $message);
	}
}