<?php
/* 
 * All registered fields
 *
 * Get a list of all registered fields and relevant info for each of them.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-05 07:35:47
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 07:43:13
 *
 */
if( ! function_exists('add_action') ) die();

if( !class_exists('Smk_AdminPage_SystemInfo_RegisteredFields') ){
	class Smk_AdminPage_SystemInfo_RegisteredFields{
		
		public $parent;

		public function __construct(){
			$this->parent = new Smk_AdminPage_SystemInfo('smk_toolkit_system_info');
			$this->parent->add_tabs( array( $this, 'tab' ) ); 
		}

		public function page(){
			$fields = smk_registered_fields();
			if(!empty($fields)){
				echo '
				<table class="sys-info-table">
					<tbody>
						<tr valign="top">
							<th scope="row"><span><strong>ID:</strong></span></th>
							<td><span><strong>CLASS:</strong></span></td>
						</tr>
						';
						
						foreach ($fields as $key => $val) {
							echo '
							<tr valign="top">
								<th scope="row"><span>'. $key .'</span></th>
								<td><span>'. $val .'</span></td>
							</tr>
							';
						}
						
						echo '
					</tbody>
				</table>
				';
			}
		}

		public function tab($sect){
			$sect[] = array(
				'id'       => 'toolkit_fields',
				'label'    => 'Registered Fields',
				'callback' => array( $this, 'page' ),
			);
			return $sect;
		}

	}
}
new Smk_AdminPage_SystemInfo_RegisteredFields;