<?php
/* 
 * All registered admin panels
 *
 * Get a list of all registered admin panels and relevant info for each of them.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-05 07:35:47
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 09:21:35
 *
 */
if( ! function_exists('add_action') ) die();

if( !class_exists('Smk_AdminPage_SystemInfo_RegisteredAdminPanels') ){
	class Smk_AdminPage_SystemInfo_RegisteredAdminPanels{
		
		public $parent;

		public function __construct(){
			$this->parent = new Smk_AdminPage_SystemInfo('smk_toolkit_system_info');
			$this->parent->add_tabs( array( $this, 'tab' ) ); 
		}

		public function page(){
			$panels = smk_mod_all_panels();

			if( !empty($_GET['panel_option_name']) ){
				echo '<h2>Admin panel: <code style="font-size: 20px;">'. $_GET['panel_option_name'] .'</code></h2>';
				if( $panel_option_name = get_option($_GET['panel_option_name']) ){
					if( !empty($panel_option_name) && is_array($panel_option_name) ){
						echo '
						<table class="sys-info-table">
							<tbody>
								<tr valign="top">
									<th scope="row"><span><strong>OPTION:</strong></span></th>
									<td><span><strong>DATA:</strong></span></td>
								</tr>
								';
								
								foreach ($panel_option_name as $option => $data) {
									echo '
									<tr valign="top">
										<th scope="row"><span>'. $option .'</span></th>
										<td><span>';
										if( is_array($data) ){
											smk_print($data, '100%');
										}
										else{
											echo esc_html( $data );
										}
										echo '</span></td>
									</tr>
									';
								}
								
								echo '
							</tbody>
						</table>
						';
					}
					else{
						echo $panel_option_name;
					}
				}
			}
			else{
				if(!empty($panels)){
					echo '
					<table class="sys-info-table">
						<tbody>
							<tr valign="top">
								<th scope="row"><span><strong>ID:</strong></span></th>
								<td><span><strong>INFO:</strong></span></td>
								<td><span><strong>SAVED DATA:</strong></span></td>
							</tr>
							';
							
							foreach ($panels as $id => $panel) {
								$table_panel_info = '
								<table class="sys-info-table">
									<tr>
										<td><span><strong>Title:</strong></span></td> 
										<td><code>'. $panel['page_title'] .'</code></td>
									</tr>
									<tr>
										<td><span><strong>Option name:</strong></span></td> 
										<td><code>'. $panel['options_name'] .'</code></td>
									</tr>
									<tr>
										<td><span><strong>Parent slug:</strong></span></td> 
										<td><code>'. $panel['parent_slug'] .'</code></td>
									</tr>
									<tr>
										<td><span><strong>Capability:</strong></span></td> 
										<td><code>'. $panel['capability'] .'</code></td>
									</tr>
								</table>
								';

								echo '
								<tr valign="top">
									<th scope="row"><span>'. $id .'</span></th>
									<td><span>'. $table_panel_info .'</span></td>
									<td><span>
										<a href="'. smk_add_query_arg( array('panel_option_name' => $panel['options_name']) ) .'">View saved data</a>
									</span></td>
								</tr>
								';
							}
							
							echo '
						</tbody>
					</table>
					';
				}
				smk_print(smk_mod_all_panels());
			}
		}

		public function tab($sect){
			$sect[] = array(
				'id'         => 'toolkit_admin_panels',
				'label'      => 'Admin panels',
				'callback'   => array( $this, 'page' ),
				'query_args' => array('panel_option_name'),
			);
			return $sect;
		}

	}
}
new Smk_AdminPage_SystemInfo_RegisteredAdminPanels;