<?php
/* 
 * PHP Info
 *
 * Get all info about current PHP setup. Equal to phpinfo() function.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-05 07:06:05
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 07:34:08
 *
 */
if( ! function_exists('add_action') ) die();

if( !class_exists('Smk_AdminPage_SystemInfo_PhpInfo') ){
	class Smk_AdminPage_SystemInfo_PhpInfo{
		
		public $parent;

		public function __construct(){
			$this->parent = new Smk_AdminPage_SystemInfo('smk_toolkit_system_info');
			$this->parent->add_sections( array( $this, 'section' ) ); 
		}

		public function page(){
			ob_start();
			phpinfo();
			$pinfo = ob_get_contents();
			ob_end_clean();
			 
			$pinfo = preg_replace( '%^.*<body>(.*)</body>.*$%ms','$1',$pinfo);
			
			echo '<div id="phpinfo">'. $pinfo .'</div>';
		}

		public function section($sect){
			$sect[] = array(
				'id'       => 'phpinfo',
				'tab'      => 'general',
				'label'    => 'PHP Info',
				'callback' => array( $this, 'page' ),
			);
			return $sect;
		}

	}
}
new Smk_AdminPage_SystemInfo_PhpInfo;