<?php
/* 
 * System Info Page
 *
 * Display a page in the admin dashboard with all information about the current system.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-06-26 21:49:51
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 07:48:26
 *
 */
if( ! function_exists('add_action') ) die();

if( class_exists('Smk_AdminPage_Toolkit') && ! class_exists('Smk_AdminPage_SystemInfo') ){
	class Smk_AdminPage_SystemInfo extends Smk_AdminPage_Toolkit{

		public function settings(){
			return array(
				'parent_slug'   => 'smk_toolkit',
				'menu_title'    => 'System Info',
			);
		}

		public function enqueue(){
			wp_register_style( 'smk_tk_system_info', SMK_TOOLKIT_URI .'admin/assets/sys-info.css');
			wp_enqueue_style( 'smk_tk_system_info' );
		}

		public function page(){
			
			$sys_info = new Smk_SysInfo;
			$sys_arr = $sys_info->sysArray();

			echo '
			<table class="sys-info-table">
				<tbody>
					';
					
					if( isset( $sys_arr ) && is_array( $sys_arr ) && !empty( $sys_arr ) ){
						foreach ($sys_arr as $arr_val) {
							$name = ( isset( $arr_val[0] ) && is_string( $arr_val[0] ) ) ? $arr_val[0] : '';
							$info = ( isset( $arr_val[1] ) && is_string( $arr_val[1] ) ) ? $arr_val[1] : '';
							$good_bad = ( isset( $arr_val[2] ) && is_string( $arr_val[2] ) ) ? $arr_val[2] : '';
							$why = ( isset( $arr_val[3] ) && is_string( $arr_val[3] ) ) ? $arr_val[3] : '';
							echo $this->createTableRow( $name, $info, $good_bad, $why );
						}
					}
					
					echo '
				</tbody>
			</table>
			';

		}

		public function createTableRow($title = '', $content = '', $good_bad = '', $why = ''){
			$mark_class = $mark_class_why = '';
			if( in_array($good_bad, array('good', 'bad', 'recommended') ) ){
				$mark_class = ' class="sys-info-'. $good_bad .'"';
				$mark_class_why = ' class="sys-info-'. $good_bad .'-why"';
			}

			$why = ( in_array($good_bad, array('bad', 'recommended') ) ) ? $why : '';

			return '
			<tr valign="top">
				<th scope="row"><span>'. $title .'</span></th>
				<td><span'. $mark_class .'>'. $content .'</span> <span'. $mark_class_why .'>'. $why .'</span></td>
			</tr>
			';

		}

	}
}

$system_info = new Smk_AdminPage_SystemInfo('smk_toolkit_system_info');
$system_info->init();