<?php
/* 
 * WP Options
 *
 * Get all options from wp_options table, show them in a list and display readable data
 * for each option on a separated page.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-05 07:06:05
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 15:34:59
 *
 */
if( ! function_exists('add_action') ) die();

if( !class_exists('Smk_AdminPage_SystemInfo_WpOptions') ){
	class Smk_AdminPage_SystemInfo_WpOptions{
		
		public $parent;

		public function __construct(){
			$this->parent = new Smk_AdminPage_SystemInfo('smk_toolkit_system_info');
			$this->parent->add_tabs( array( $this, 'tab' ) ); 
		}

		public function page($unserialize = false){
			$all_wpo = wp_load_alloptions();

			if( !empty($_GET['wpo_option']) ){
				echo '<h2>Option: <code style="font-size: 20px;">'. $_GET['wpo_option'] .'</code></h2>';
				if( $wpo_option = get_option($_GET['wpo_option']) ){
					if( !empty($wpo_option) && is_array($wpo_option) ){
						smk_ppprint($wpo_option, '100%');
					}
					else{
						echo $wpo_option;
					}
				}
			}
			else{
				echo '
				<table class="sys-info-table">
					<tbody>
						';
						// ksort($all_wpo);
						foreach ($all_wpo as $opt_key => $opt_val) {
							echo '
							<tr valign="top">
								<th scope="row"><span><a href="'. smk_add_query_arg( array('wpo_option' => $opt_key) ) .'">'. $opt_key .'</a></span></th>
								<td><span style="max-width: 630px; overflow: auto;">';
								echo esc_html( $opt_val );
								echo '</span></td>
							</tr>
							';
							$new_val = '';
						}
						
						echo '
					</tbody>
				</table>
				';
			}

		}

		public function tab($tabs){
			$tabs[] = array(
				'id'         => 'wpoptions',
				'label'      => 'WP Options',
				'callback'   => array( $this, 'page' ),
				'query_args' => array('wpo_option'),
			);
			return $tabs;
		}

	}
}
new Smk_AdminPage_SystemInfo_WpOptions;