/**
 * SMK Toolkit Fields JS
 * @used for : define field functions for SMK Toolkit
 */
jQuery.noConflict();
jQuery(document).ready(function($){

	/**
	 * SMK Toolkit ALL Fields
	 * @use : <smk_toolkit_dir>/js/scripts.js, to get the field functions
	 * @desc : this is for all fields
	 * BEGIN
	 */

	/*
	-----------------------------------------------------------------------
	Color picker
	-----------------------------------------------------------------------
	*/
	smk_toolkit_color_init = function(){
		$('.tk_color_picker').not('.stk_field.tk_combine li .cb_body .element .tk_color_picker').each( function(){
			var live_bg = $(this).data('live-bg');
			$(this).wpColorPicker({
				change: function(event, ui) {
			        $(live_bg).css( 'background-color', ui.color.toString());
			    }
			});
		});
		return this;
	}
	smk_toolkit_color_init();

	/*
	-----------------------------------------------------------------------
	Media Uploader
	-----------------------------------------------------------------------
	*/
	smk_toolkit_upload_field_full_init = function() {
		
		var main_section = '.tk_upload_field_main_section',
			upload_btn   = '.upload_field .select_file',
			result_field = '.tk_upload_input_result',
			remove_btn   = '.uploaded_file_info .remove',
			default_btn  = '.uploaded_file_info .default',
			title_sel    = '.uploaded_file_info .title',
			file_prev    = '.uploaded_file .file';

		function tk_upload_add_file(event, selector) {
		
			var upload  = $(".uploaded-file"), frame;
			var $el     = $(this);
				
			event.preventDefault();

			// If the media frame already exists, reopen it.
			if ( frame ) {
				frame.open();
				return;
			}

			// Create the media frame.
			frame = wp.media({
    			multiple: false,
				// Set the title of the modal.
				title: $el.data('choose'),

				// Customize the submit button.
				button: {
					// Set the text of the button.
					text: $el.data('update'),
					// Tell the button not to close the modal, since we're
					// going to refresh the page when the image is selected.
					close: false
				}
			});

			// When an image is selected, run a callback.
			frame.on( 'select', function() {
				// Grab the selected attachment.
				var attachment = frame.state().get('selection').first(),
					the_url = attachment.attributes.url,
					ext = the_url.split('.').pop().toLowerCase();
					console.log(attachment);
				frame.close();
				selector.find( result_field ).val(the_url);
				selector.find(title_sel).html('<a href="' + the_url + '" target="_blank">' + attachment.attributes.filename + '</a>');
				
				if ( attachment.attributes.type == 'image' ) {
					selector.find(file_prev)
						.html('<a href="' + the_url + '" target="_blank"><img src="' + the_url + '" alt="" /></a>')
						.removeClass (function (index, css) {
							return (css.match (/\bext-\S+/g) || []).join(' ');
						})
						.addClass('ext-' + ext);
				}
				else{
					selector.find(file_prev)
						.html('')
						.removeClass (function (index, css) {
							return (css.match (/\bext-\S+/g) || []).join(' ');
						})
						.addClass('ext-' + ext);
				}

				selector.find(upload_btn).unbind();
				selector.find(remove_btn + ', ' + default_btn).show().removeClass('smk_tk_hide_element');//show "Remove" button
				tk_upload_file_bindings();
			});

			// Finally, open the modal.
			frame.open();
		}
	    
		function tk_upload_remove_file(selector) {
			selector.find( remove_btn ).hide().addClass('smk_tk_hide_element');//hide "Remove" button
			selector.find( result_field ).val('');
			selector.find( file_prev ).html('').removeClass (function (index, css) {
				return (css.match (/\bext-\S+/g) || []).join(' ');
			});
			selector.find( title_sel ).html('<em>(please select a file)</em>');
			tk_upload_file_bindings();
		}
		function tk_upload_default_file(selector, def) {
			var f_type = def.split('.').pop().toLowerCase();
			selector.find( result_field ).val(def);
			if( f_type == 'jpg' || f_type == 'jpeg' || f_type == 'png' || f_type == 'gif' || f_type == 'ico' ){
				selector.find( file_prev )
					.html('<a href="' + def + '" target="_blank"><img src="' + def + '" alt="" /></a>')
					.removeClass (function (index, css) {
						return (css.match (/\bext-\S+/g) || []).join(' ');
					})
					.addClass('ext-' + f_type);
			}
			else{
				selector.find( file_prev )
					.html('')
					.removeClass (function (index, css) {
						return (css.match (/\bext-\S+/g) || []).join(' ');
					})
					.addClass('ext-' + f_type);

			}
			if(def == '' || f_type == '' || f_type == 'undefined'){
				$(remove_btn).hide().addClass('smk_tk_hide_element');
				selector.find(title_sel).html('<em>(please select a file)</em>');
			}
			else{
				$(remove_btn).show().removeClass('smk_tk_hide_element');
				selector.find(title_sel).html('<a href="' + def + '" target="_blank">' + def.split('/').pop() + '</a>');
			}
			tk_upload_file_bindings();
		}
		
		function tk_upload_file_bindings() {
			$(remove_btn).on('click', function() {
				tk_upload_remove_file( $(this).parents( main_section ) );
	        });
	        
	        $(upload_btn).unbind('click').on('click', function( event ) {
	        	tk_upload_add_file(event, $(this).parents( main_section ));
	        });

	        $(default_btn).unbind('click').on('click', function( event ) {
	        	tk_upload_default_file($(this).parents( main_section ), $(this).data('default'));
	        });
	    }
	    
	    tk_upload_file_bindings();
	}
	smk_toolkit_upload_field_full_init();


	/*
	-----------------------------------------------------------------------
	JQuery UI Slider function
	-----------------------------------------------------------------------
	*/
	smk_toolkit_sliderui_init = function() {
		jQuery('.smk_toolkit_sliderui').each(function() {
			
			var obj   = jQuery(this);
			var sId   = "#" + obj.data('id');
			var val   = parseInt(obj.data('val'));
			var min   = parseInt(obj.data('min'));
			var max   = parseInt(obj.data('max'));
			var step  = parseInt(obj.data('step'));
			
			//slider init
			obj.slider({
				value: val,
				min: min,
				max: max,
				step: step,
				range: "min",
				slide: function( event, ui ) {
					jQuery(sId).val( ui.value );
				}
			});
			
		});
	}
	smk_toolkit_sliderui_init();


	/*
	-----------------------------------------------------------------------
	Switch
	-----------------------------------------------------------------------
	*/
	smk_toolkit_switch_init = function() {
		jQuery('.tk_switch_options').each(function() {
			
			var obj    = jQuery(this);
			var enb    = obj.children('.enable');
			var dsb    = obj.children('.disable');
			var input  = obj.children('input');			
			var the_id = obj.data('id');//get id's

			//hide all
			if( 1 == input.val() ){
				$('.smk_fold_' + the_id).show();
			}
			else{
				$('.smk_fold_' + the_id).hide();
			}
			//alert(input.val());
			

			//Action on user's click(ON)
			$(enb).on('click', function(){
				$(dsb).removeClass('selected');
				$(this).addClass('selected');
				$(input).val(1).change();


				$('.smk_fold_' + the_id).slideDown('fast');
			});

			//Action on user's click(OFF)
			$(dsb).on('click', function(){
				$(enb).removeClass('selected');
				$(this).addClass('selected');
				$(input).val(0).change();

				$('.smk_fold_' + the_id).slideUp('fast');
			});

		});
			
	}
	smk_toolkit_switch_init();

	/*
	-----------------------------------------------------------------------
	Visual Select Filter
	-----------------------------------------------------------------------
	*/
	smk_toolkit_visual_select_filter = function(obj) {
		var span     = obj.children('span');
		var filter   = obj.prev('.tk_tab_select_filter').children('input');

		filter.keyup(function() {
			var h = obj.outerHeight(true);
			obj.css('min-height', h);
			var f = $(this).val();
			var regex = new RegExp(f, 'gi');

			span.hide().each(function() {
				if($(this).data('val').match(regex)) {
					$(this).show();
				}
			});
		});
		
	}

	/*
	-----------------------------------------------------------------------
	Visual Select
	-----------------------------------------------------------------------
	*/
	smk_toolkit_visual_select_init = function() {
		jQuery('.tk_tab_select').each(function() {
			
			var obj      = jQuery(this);
			var blocks   = obj.data('blocks');
			var span     = obj.children('span');
			var input    = obj.children('.tk_tab_select_val');
			var selected = obj.children('span.selected').data('block');
			$(selected).show();

			//Action on user's click
			$(span).on('click', function(){
				
				var this_block = $(this).data('block');

				$(blocks).slideUp('fast');
				$(this_block).slideDown('fast');				

				$(span).removeClass('selected');
				$(this).addClass('selected');
				$(input).val( $(this).data('val') ).change();

			});

			smk_toolkit_visual_select_filter(obj);
		});
			
	}
	smk_toolkit_visual_select_init();

	/*
	-----------------------------------------------------------------------
	Image Select Upload
	-----------------------------------------------------------------------
	*/
	smk_toolkit_apply_isl_upload_image = function( elem ){
		var obj        = elem.parents('.smk_tk_image_select')
		deselect       = obj.data('deselect'),
		preview        = obj.find('.isl_preview .isl_live_preview'),
		input          = obj.find('.tk_isl_val');

		if( elem.parent().hasClass('label_selected') ){
			if(deselect == 'yes'){
				elem.parent('.isl_item').removeClass('label_selected');
				input.val('').change();
				preview.css('background-image', '');
			}
			else{
				return false;
			}
		}
		else{
			if( !elem.parent().hasClass('to_delete_queue') ){
				var _src = elem.attr('src');

				obj.find('.isl_item').removeClass('label_selected');
				elem.parent('.isl_item').addClass('label_selected');

				input.val(_src).change();
				preview.css('background-image', 'url(' + _src + ')');
			}
			else{
				return false;
			}
		}
	};

	smk_toolkit_isl_upload = function() {
		
		var upload_btn   = '.smk_tk_image_select .isl_upload';

		function tk_upload_add_file(event, selector) {
		
			var upload  = $(".uploaded-file"), frame;
			var $el     = $(this);
				
			event.preventDefault();

			// If the media frame already exists, reopen it.
			if ( frame ) {
				frame.open();
				return;
			}

			// Create the media frame.
			frame = wp.media({
				multiple: true,
				// Set the title of the modal.
				title: $el.data('choose'),

				// Customize the submit button.
				button: {
					// Set the text of the button.
					text: $el.data('update'),
					// Tell the button not to close the modal, since we're
					// going to refresh the page when the image is selected.
					close: false
				},
				library: {
					type: 'image'
				},
			});

			// When an image is selected, run a callback.
			frame.on( 'select', function() {
				// Grab the selected attachment.
				var attachment = frame.state().get('selection');
				frame.close();
				
				var all_attach = attachment.toJSON();//all attachments in array
				var all_images = selector.find('.isl_item img');//Get all images/options(default+uploaded)
				var the_id = selector.find('.tk_isl_val').attr('name').replace('[image]', '[0]');//Get the id(default+uploaded)

				// console.log(attachment.toJSON());
				// console.log(all_attach.length);
				// console.log(selector.find('.isl_item img'));
				
				for (var i=0; i<all_attach.length; i++){
					selector.find('.isl_upload').before('<span class="isl_item"><span class="delete"></span><img src="' + all_attach[i]['url'] + '" alt=""><input type="hidden" value="' + all_attach[i]['url'] + '" name="'+ the_id +'[]" /></span>');
				}

				selector.find(upload_btn).unbind();
				isl_upload_file_bindings();
				smk_toolkit_image_select_init();
				smk_toolkit_apply_isl_upload_image( selector.find( '.isl_item:last img' ) );
			});

			// Finally, open the modal.
			frame.open();
		}
		function isl_upload_file_bindings() {
	        $(upload_btn).unbind('click').on('click', function( event ) {
	        	tk_upload_add_file(event, $(this).parents( '.smk_tk_image_select' ));
	        });
	    }
	    
	    isl_upload_file_bindings();
	    
	}
	smk_toolkit_isl_upload();

	smk_toolkit_image_select_init = function() {
		$('.smk_tk_image_select').each(function() {
			
			var obj            = jQuery(this),
				deselect       = obj.data('deselect'),
				item           = obj.find('.isl_item img'),
				del_msg        = obj.find('.isl_remove_selected'),
				delt           = obj.find('.isl_item .delete'),
				preview_parent = obj.find('.isl_preview'),
				preview        = obj.find('.isl_preview .isl_live_preview'),
				preview_height = obj.find('.isl_preview .isl_preview_set_height .isl_preview_height'),
				input          = obj.find('.tk_isl_val'),
				id             = obj.find('.tk_isl_val').attr('id'),
				selected       = obj.find('.isl_item.label_selected');


			//Select option
			$(item).unbind().on('click', function(e){
				smk_toolkit_apply_isl_upload_image( $(this) );
			});

			$('#' + id + '_bg_position').on('change', function(){
				var _val = $(this).val();
				preview.css('background-position', _val);
			});

			$('#' + id + '_bg_repeat').on('change', function(){
				var _val = $(this).val();
				preview.css('background-repeat', _val);
			});

			/* Custom preview height */
			preview_height.on('click', function(){
				var _val = $(this).data('height');
				if(_val !== 'default'){
					preview_parent.css('height', _val);
				}
				else{
					preview_parent.css('height', '')
				}
			});

		});
			
	}
	smk_toolkit_image_select_init();

	smk_toolkit_isl_delete_uploaded_images = function (){

		$('body').on('click', '.isl_item .delete', function(){
			var obj     = $(this).parents('.smk_tk_image_select');
			var del_msg = obj.find('.isl_remove_selected');

			if($(this).parent('.isl_item').hasClass('to_delete_queue')){
				$(this).parent('.isl_item').removeClass('to_delete_queue');
				if(obj.find('.isl_item.to_delete_queue').length){
					del_msg.show();
				}
				else{
					del_msg.hide();
				}
			}
			else{
				if( !$(this).parent('.isl_item').hasClass('label_selected') ){
					$(this).parent('.isl_item').addClass('to_delete_queue');
					
					if(obj.find('.isl_item.to_delete_queue').length){
						del_msg.show();
					}
					else{
						del_msg.hide();
					}
				}
				else{
					return false;
				}
			}
		});

		$('body').on('click', '.remove_all_imgs', function(){
			var obj     = $(this).parents('.smk_tk_image_select');
			var del_msg = obj.find('.isl_remove_selected');

			obj.find('.to_delete_queue').remove();
			del_msg.hide();
		});

	};
	smk_toolkit_isl_delete_uploaded_images();

	//Used to slide up/down other options for image select field
	//Deprecated.
	smk_toolkit_image_select_other = function(){
		// $('.isl_other_options').hide();
		// $('.isl_other_options_button').unbind().on('click', function(){

		// 	var this_parents = $(this).parents('.smk_tk_image_select');
		// 	var id = $(this).data('id');
		// 	$(this).toggleClass('active');
		// 	this_parents.find('#' + id).slideToggle('fast');

		// });
		
	}
	smk_toolkit_image_select_other();


	/*
	-----------------------------------------------------------------------
	Combine field function
	-----------------------------------------------------------------------
	*/

	//Make item sortable
	//----------------------------------
	smk_toolkit_field_combine_sortable = function(){
		$('.smk_toolkit_combine').sortable({
			opacity: 0.6,
			items: 'li.cb_item',
			// handle: '.cb_handle',
			cursor: 'move',
			axis: 'y',
		});
	}
	smk_toolkit_field_combine_sortable();

	smk_toolkit_field_combine_init = function(){
		$('.smk_toolkit_combine').each(function(index, elem){
			
			//Slide all up
			$(elem).find('.cb_item').removeClass('active');
			$(elem).find('.cb_item .cb_body').hide();
			$(elem).find('.cb_item .cb_collapse').removeClass('active');

			var theid = $(this).data('theid');
			var add_new = '.smk_toolkit_combine_new_' + theid;

			//"Add new" button
			//--------------------------------------------------
			$(add_new).unbind().click( function() {

				var ul = $(this).prev('.smk_toolkit_combine'),
				    theid = ul.data('theid'),
				    thename = $(this).data('name'),
				    block_label = $(this).data('block-label'),
				    fields = $(this).data('fields');

				$.ajax({
					type: "POST",
					url: ajaxurl,
					data: {
						"action": "smk_combine_single_li_ajax",
						"fields": fields,
						"theid": theid,
						"thename": thename,
						"block_label": block_label
					},
					success: function(data){
						ul.append(data);
						smk_toolkit_field_combine_sortable();
					},
					complete: function(data){
						smk_toolkit_field_combine_init();
						smk_toolkit_field_combine_remove();
						smk_toolkit_field_combine_collapse();
						smk_toolkit_field_combine_sortable();
						smk_toolkit_field_combine_block_label();
						smk_toolkit_color_init();
						smk_toolkit_upload_field_full_init();
						smk_toolkit_sliderui_init();
						smk_toolkit_switch_init();
						smk_toolkit_visual_select_init();
						smk_toolkit_image_select_init();
						smk_toolkit_isl_upload();
						smk_toolkit_image_select_init();
						smk_toolkit_image_select_other();

						ul.find('.cb_item').removeClass('active');
						ul.find('.cb_item .cb_body').slideUp('fast');
						ul.find('.cb_item .cb_collapse').removeClass('active');

						ul.find('.cb_item').last().addClass('active');
						ul.find('.cb_item .cb_collapse').last().addClass('active');
						ul.find('.cb_item .cb_body').last().slideDown('fast');

					}
				});

			});

			//"Remove" button
			//---------------------------------
			function smk_toolkit_field_combine_remove(){
				$('.smk_toolkit_combine_remove').click( function(e) {

					e.preventDefault();

					var this_block = $(this).parents('.cb_item');
					if( this_block.hasClass('cb_item_default') ){
						return false;
					}
					else{
						this_block.slideUp('fast', function() { 
							$(this).remove(); 
						});
					}
					
				});
			}
			smk_toolkit_field_combine_remove();

			//Block Label
			//---------------------------------
			function smk_toolkit_field_combine_block_label(){
				$('.smk_toolkit_combine .cb_head_label .block_label').each( function(index, elem) {
					var block_label = $(elem).data('block-label'),
					    head_label = $(this);
					if( $('#' + block_label).length > 0 ){
						$('#' + block_label).on('change', function(){
							head_label.text( $(this).val() );
						});
						$('#' + block_label).on('keyup', function(){
							head_label.text( $(this).val() );
						});
					}
					
				});
			}
			smk_toolkit_field_combine_block_label();

			//Create color picker
			//----------------------------------
			$('.cb_item .tk_color_picker').wpColorPicker();

		});

	}//function smk_toolkit_field_combine_init(){
	smk_toolkit_field_combine_init();

	//"Slide" button
	//---------------------------------
	smk_toolkit_field_combine_collapse = function(){
		$('.smk_toolkit_combine').unbind().on('click','.cb_collapse', function() {
			var _this = $(this);
			var slide_tog = _this.parents('.cb_item');
			if( _this.hasClass('active') ){
				$('.cb_body', slide_tog).slideUp('fast');
				slide_tog.removeClass('active');
				_this.removeClass('active');
			}
			else{
				var cb_obj = _this.parents('.smk_toolkit_combine');
				cb_obj.find('.cb_item').removeClass('active');
				cb_obj.find('.cb_item .cb_body').slideUp('fast');
				cb_obj.find('.cb_item .cb_collapse').removeClass('active');

				slide_tog.addClass('active');
				_this.addClass('active');

				$('.cb_body', slide_tog).slideDown('fast');

			}
		});
	}
	smk_toolkit_field_combine_collapse();

	// Load all form functions
	//---------------------------------
	smk_toolkit_load_form_functions = function(){
		smk_toolkit_color_init();
		smk_toolkit_upload_field_full_init();
		smk_toolkit_sliderui_init();
		smk_toolkit_switch_init();
		smk_toolkit_visual_select_init();
		smk_toolkit_image_select_init();
		smk_toolkit_field_combine_init();
		smk_toolkit_field_combine_collapse();
		smk_toolkit_field_combine_sortable();
		smk_toolkit_isl_upload();
		smk_toolkit_image_select_init();
		smk_toolkit_image_select_other();
	}


	/**
	 * SMK Toolkit Widgets JS
	 * @use : <smk_toolkit_dir>/js/scripts.js, to get the field functions
	 * @desc : this is for widgets page only
	 * BEGIN
	 */
	/*
	-----------------------------------------------------------------------
	Re-init the javascript in widget form after submit
	This allow to use JS in widgets
	Init the object after this function in a .bind('saved_widget', function(event, widget){ ... })
	This is called for '#widgets-right', as jQuery 1.8 this method must use `document` as selector
	-----------------------------------------------------------------------
	*/
	if($('#widgets-right, #accordion-panel-widgets').length){
		$(document).ajaxComplete(function(event, XMLHttpRequest, ajaxOptions){

			// determine which ajax request is this (we're after "save-widget")
			var request = {}, 
				pairs = ajaxOptions.data.split('&'), 
				i, 
				split, 
				widget;

			for(i in pairs){
				split = pairs[i].split('=');
				request[decodeURIComponent(split[0])] = decodeURIComponent(split[1]);
			}

			// only proceed if this was a widget-save request
			if(request.action && (request.action === 'save-widget')){

				// locate the widget block
				widget = $('input.widget-id[value="' + request['widget-id'] + '"]').parents('.widget');

				// trigger manual save, if this was the save request 
				// and if we didn't get the form html response (the wp bug)
				if(!XMLHttpRequest.responseText){
					
					wpWidgets.save(widget, 0, 1, 0);

					// we got an response, this could be either our request above,
					// or a correct widget-save call, so fire an event on which we can hook our js
				}
				else{
					$(document).trigger('saved_widget', widget);
				}

			}

		});


		/*
		-----------------------------------------------------------------------
		Bind ALL after widget ajax save.
		-----------------------------------------------------------------------
		*/
		$(document).bind('saved_widget', function(event, widget){
			smk_toolkit_load_form_functions();
		});
	}


}); //END OF: jQuery(document).ready(function($){ ...