/**
 * SMK Toolkit Page Builder JS
 * @used for : define page builder functions for SMK Toolkit
 */
jQuery.noConflict();
jQuery(document).ready(function($){

	//Page builder full screen
	//----------------------------------
	smk_toolkit_pb_full_screen = function(){
		$('#pb_to_full_screen').on('click', function(event){
			event.preventDefault();
			
			//Exit full screen
			if($(this).hasClass('is_full')){
				$(this).removeClass('is_full')
				$(this).children('.full_screen_text').text(smk_tk_lang.pb.full_screen);
				$(this).children('.full_screen_icon').removeClass('smk-icon-contract').addClass('smk-icon-expand');
				$('#pb_to_full_screen_overlay').fadeOut('fast');
				$('#smk_page_builder').removeClass('smk_pb_full_screen');
				$('body').removeClass('smk_pb_full_body_scroll_none');
				// $('#publish').appendTo('#publishing-action');
			}
			//Go full screen
			else{
				$(this).addClass('is_full');
				$(this).children('.full_screen_text').text(smk_tk_lang.pb.full_screen_exit);
				$(this).children('.full_screen_icon').removeClass('smk-icon-expand').addClass('smk-icon-contract');

				if($('#pb_to_full_screen_overlay').length < 1){
					$('body').prepend('<div id="pb_to_full_screen_overlay" class="smk_page_builder_full_overlay"></div>');
				}
				$('#pb_to_full_screen_overlay').fadeIn('fast');
				
				$('#smk_page_builder').addClass('smk_pb_full_screen').removeClass('closed');
				// $('#publish').prependTo('#smk_page_builder > .inside');
				$('body').addClass('smk_pb_full_body_scroll_none');
			}

		});
	}
	smk_toolkit_pb_full_screen();

	//Page builder modal form html
	//----------------------------------
	smk_toolkit_pb_modal_form_html = function(response, _form_container){
		var _content;

		if( response !== 'fail' && parseInt(response, 10) !== 0 ){
			_content = '<form class="smk_builder_modal_form">' + response;
				_content += '<div class="smk_pb_savebutton_block">';
					_content += '<span class="button button-primary button-large smk_content_builder_submit_button">';
						_content += smk_tk_lang.pb.submit_form;
					_content += '</span>';
				_content += '</div>';
			_content += '</form>';
			//clear html and append form. if we use direct html(''), then the form will not be created because it will not be a valid html structure(form inside of another form)
			$(_form_container).html('').append(_content);
		}
		else{
			//if load form fails, display an error message
			$(_form_container).html(smk_tk_lang.form_load_fail);
		}
	}

	/* Page builder disable text selection
	-----------------------------------------------------------------*/
	smk_pb_disable_text_selection = function(){
		$('.smk_pbuilder_admin_grid').attr('unselectable', 'on').css('user-select', 'none').on('selectstart', false);
	}
	smk_pb_disable_text_selection();

	/* Page builder loader
	-----------------------------------------------------------------*/
	smk_pb_loader = function(_state){
		if(_state == 'show'){
			$('.smk_pb_loading_message').addClass('activated');
		}
		else{
			$('.smk_pb_loading_message').removeClass('activated');
		}
	}

	/* Page builder serialize the from from modal window
	-----------------------------------------------------------------*/
	smk_toolkit_pb_modal_form_serialize = function(_form_id){
		return encodeURIComponent( $(_form_id).serialize() ).replace(/'/g, "%27").replace(/"/g, "%22");
	}

	//Collapse page builder rows
	//----------------------------------
	smk_toolkit_pb_rows_collapse = function(){
		$('.smk_pb_collapse_links a.cl_close').on('click', function(event){
			event.preventDefault();
			$('.smk_pb_admin_row').addClass('row_close');
		});
		$('.smk_pb_collapse_links a.cl_open').on('click', function(event){
			event.preventDefault();
			$('.smk_pb_admin_row').removeClass('row_close');
		});
	}
	smk_toolkit_pb_rows_collapse();

	//Some things that may be needed for PB or its modules
	//----------------------------------
	smk_toolkit_pb_add_el = function(){
		$('.smk_pbuilder_admin_grid .tk_col_controls_l').append('<div class="resize_minus" title="'+ smk_tk_lang.pb.decrease +'"></div>');
		$('.smk_pbuilder_admin_grid .tk_col_controls_l').append('<div class="resize_plus" title="'+ smk_tk_lang.pb.increase +'"></div>');
		$('.smk_pbuilder_admin_grid .tk_col_controls_l').append('<div class="col_settings" title="'+ smk_tk_lang.pb.settings +'"></div>');
		$('.smk_pbuilder_admin_grid .tk_col_controls_l').append('<div class="sortable_handle" title="'+ smk_tk_lang.pb.move +'"></div>');
		$('.smk_pbuilder_admin_grid .tk_col_controls_r').append('<div class="col_remove" title="'+ smk_tk_lang.pb.delete +'"></div>');
		smk_toolkit_pb_columns_resizable();
	}
	smk_toolkit_pb_add_el();

	//Module title in modal window
	//----------------------------------
	smk_toolkit_pb_amod_ttl_mw = function(){
		var input_width = $('#smk_pb_modal_module_title').prev('.mod_ttl').outerWidth(true);
		$('#smk_pb_modal_module_title').css('padding-left', parseInt(input_width, 10) + 10);
	}
	smk_toolkit_pb_amod_ttl_mw();

	/**
	 * ------------------------------------------------------------
	 * Init PB Row plugin
	 * ------------------------------------------------------------
	 */
	var spb_row_init = $('.smk_page_builder_container').smk_PB_Row();

}); //END OF: jQuery(document).ready(function($){ ...