/**
 * SMK Toolkit Page Builder Module JS
 * @used for : define page builder module functions for SMK Toolkit
 */
jQuery(document).ready(function($){

	/*Create and init page builder modal window
	----------------------------------------------------------------*/
	var spb_module_modal_init = $('#module_modal').smk_Modal({
		targetBtn: '.pb_module_add_new',
		// closeBtn: '.pb_modal_close',
		animationName: 'scaleUp',
		maxWidth: 1240,
		maxHeight: 1000,
		beforeOpen: function(){
			if($('#module_modal .sm_content .smk_pb_module_form').length > 0){
				$('#module_modal .sm_content .smk_pb_module_form').html('');
			}
		},
		afterClose: function(){
			if($('#module_modal .sm_content .smk_pb_module_form').length > 0){
				$('#module_modal .sm_content .smk_pb_module_form').html('');
			}
			this.removeModalClass('pb_module_edit_mode');
			this.removeModalClass('new_pb_module');
			$('.smk_pb_modules_menu .smk_pb_module_menu_item').children('.pbm_inner').removeClass('menu_highlight');
		},
	});

	$('.smk_pbuilder_admin_grid').on('click', '.pb_module_add_new', function(){
		spb_module_modal_init.addModalClass('new_pb_module');
		$('.smk_pb_modules_menu .modules_filter a').removeClass('active').first().addClass('active');
		$('.smk_pb_modules_menu .all_modules .smk_pb_module_menu_item').removeClass('hide_module');
	});

	/*Create and init page builder modal window
	----------------------------------------------------------------*/
	var spb_module_init = $('.smk_page_builder_container').smk_PB_Module();

	//Modules filter
	//----------------------------------
	smk_toolkit_pb_modules_filter = function(){
		$('.smk_pb_modules_menu .modules_filter a').on('click', function(event){
			event.preventDefault();
			var link = $(this),
				category = link.data('filter'),
				all_links = $('.smk_pb_modules_menu .modules_filter a');
				all_modules = $('.smk_pb_modules_menu .all_modules .smk_pb_module_menu_item');
				
				//Add class to selected item
				all_links.removeClass('active');
				link.addClass('active');

				//Show only selected modules
				all_modules.each(function(){
					if( $(this).data('filter').indexOf(category) != -1 ){
						$(this).removeClass('hide_module');
					}
					else if( category == 'all' ){
						$(this).removeClass('hide_module');
					}
					else{
						$(this).addClass('hide_module');
					}
				});


		});
	}
	smk_toolkit_pb_modules_filter();

	/* Save form and create module
	-----------------------------------------------------------------*/
	smk_pb_submit_module = function(_mode, _edit_id){

		jQuery('.smk_pb_module_form').on('click', '.smk_pb_module_button', function(){
			jQuery('.smk_pb_module_form').unbind('click');
			var _dataType,
			    _data = new Array(),
			    module_content;

			    _data['column_id']   = $('#smk_pb_modal_module_colid').val();
				_data['row_key']     = $('#smk_pb_modal_module_rowkey').val();
				_data['section_key'] = $('#smk_pb_modal_module_sectionkey').val();
				_data['column_key']  = $('#smk_pb_modal_module_colkey').val();
				_data['type']        = $('#smk_pb_modal_module_type').val();
				_data['php_class']   = $('#smk_pb_modal_module_class').val();
				_data['icon']        = $('#smk_pb_modal_module_icon').val();
				_data['module_key']  = _data['section_key'] +'_'+ smk_generate_string(5, true);

			smk_pb_loader('show');
			var _form = smk_toolkit_pb_modal_form_serialize('.smk_pb_module_main_form');
			jQuery.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					'action': 'save_page_builder_module',
					'data': {
						form_data: _form,
						php_class: $('#smk_pb_modal_module_class').val(),
						row_key: _data['row_key'],
						section_key: _data['section_key'],
						column_key: _data['column_key'],
						module_key: _data['module_key'],
					}
				},
				success: function(response){
					// alert(response);
					
					if( _mode === 'create' ){
						$('#' + _data['column_id']).append(response);
					}
					else{
						$('#' + _edit_id).after(response);
						$('#' + _edit_id).remove();
					}

					$('#' + _data['module_key']).addClass('edited');
					setTimeout(function(){
						$('#' + _data['module_key']).removeClass('edited');
					}, 500);

				},
				complete: function(){
					smk_pb_loader('hide');
					spb_module_modal_init.closeWindow();
					jQuery('.smk_pb_module_form').unbind('click');

				}
			});//ajax
		});//on click

	}

	/* Data inside modal popup. Ajax procesing form and modules
	-----------------------------------------------------------------*/
	smk_pb_module_load_form = function(_selector, _parent){
		jQuery(_parent).on('click', _selector, function(){

			// If the form is already loaded return false and do not allow to load again the same form
			if( $(this).children('.pbm_inner').hasClass('menu_highlight') )
				return false;

			// If we add a new module then mark the menu item
			if( $(this).hasClass('smk_pb_module_menu_item') ){
				$('.smk_pb_module_menu_item').children('.pbm_inner').removeClass('menu_highlight');
				$(this).children('.pbm_inner').addClass('menu_highlight');
				spb_module_modal_init.removeModalClass('new_pb_module');
			}

			spb_module_modal_init.openWindow();
			$('.smk_pb_module_form').unbind('click');

			var _class    = $(this).data('class'),
				_action   = $(this).data('action'),
				_mode     = $(this).data('mode'),
				_icon     = $(this).find('.pbm_icon span').attr('class'),
				_type     = $(this).find('.pbm_type').text(),
				_saved_data, 
				_edit_id="";

				_mode = (_mode === 'edit') ? _mode : 'create';

				if( _mode === 'edit' ){
					_edit_id = $(this).parents('.pb_module').attr('id');
					spb_module_modal_init.addModalClass('pb_module_edit_mode');
				}

				if($(this).parents('.pb_module')){
					_saved_data = $(this).parents('.pb_module').find('.tk_module_value').val();
				}
				else{
					_saved_data = '';
				}

				$('#smk_pb_modal_module_icon').val(_icon).change();
				$('#smk_pb_modal_module_type').val(_type).change();
				$('#smk_pb_modal_module_class').val(_class).change();


			smk_pb_loader('show');

			jQuery.ajax({
	  			type: "POST",
				url: ajaxurl, 
				data: {
					'action': _action,
					'data': { 
						php_class: _class, 
						saved_data: _saved_data 
					}
				}, 
				success: function(response){
					var _content;

					if( response != 'fail' ){
						_content = '<form class="smk_pb_module_main_form">' + response;
							_content += '<div class="smk_pb_savebutton_block">';
								_content += '<span class="button button-primary button-large smk_pb_module_button" data-phpclass="'+ _class +'">';
									_content += smk_tk_lang.pb.submit_form;
								_content += '</span>';
							_content += '</div>';
						_content += '</form>';
						//clear html and append form. if we use direct html(''), then the form will not be created because it will not be a valid html structure(form inside of another form)
						$('.smk_pb_module_form').html('').append(_content);
					}
					else{
						//if load form fails, display an error message
						$('.smk_pb_module_form').html(smk_tk_lang.form_load_fail);
					}
					// alert(response);
					// alert(_mode);
					
				},
				complete: function(){
					smk_toolkit_load_form_functions();
					smk_pb_loader('hide');
					smk_pb_submit_module(_mode, _edit_id);
					
				}//ajax complete
			});//ajax
		});//.smk_pb_module_menu_item on click
	}//smk_pb_module_load_form

	smk_pb_module_load_form('.smk_pb_module_menu_item', '.smk_pb_modules_menu'); //Add module
	smk_pb_module_load_form('.smk_module_edit', '.smk_pbuilder_admin_grid');	//Edit module

});//document ready
