/**
 * SMK Toolkit Page Builder Module JS
 * @used for : define page builder module functions for SMK Toolkit
 */
jQuery.noConflict();
jQuery(document).ready(function($){

	// Cache in vars
	var _row_modal_id    = '#smk_builder_row_settings_modal',
	    _form_container  = _row_modal_id + ' .smk_builder_row_settings_form',
	    _settings_button = '.smk_pb_admin_row .row_controls .settings';

	/*Create and init page builder modal window
	----------------------------------------------------------------*/
	var spb_row_modal_init = $(_row_modal_id).smk_Modal({
		targetBtn: '.smk_pb_admin_row .row_controls .settings',
		animationName: 'scaleUp',
		maxWidth: 1000,
		maxHeight: 1000,
		beforeOpen: function(){
			if($(_form_container).length > 0){
				$(_form_container).html('');
			}
		},
		afterClose: function(){
			if($(_form_container).length > 0){
				$(_form_container).html('');
			}
		},
	});

	// /* Submit form
	// -----------------------------------------------------------------*/
	smk_builder_row_settings_submit_form = function(_row_id_to_save){

		jQuery(_form_container).on('click', '.smk_content_builder_submit_button', function(){

			jQuery(_form_container).unbind('click');
			smk_pb_loader('show');

			var _form = smk_toolkit_pb_modal_form_serialize('.smk_builder_modal_form');
			jQuery.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					'action': 'smk_content_builder_row_settings_form_submit',
					'data':   { form_data: _form }
				},
				success: function(response){
					// alert(response);
					$(_row_id_to_save).find('.smk_pb_row_settings').val(response).change();

				},
				complete: function(){
					smk_pb_loader('hide');
					spb_row_modal_init.closeWindow();
					jQuery(_form_container).unbind('click');

				}
			});//ajax
		});//on click

	}

	/* Data inside modal popup. Ajax procesing form and modules
	-----------------------------------------------------------------*/
	smk_builder_row_settings_load_form = function(_selector, _parent){
		jQuery(_parent).on('click', _selector, function(){

			spb_row_modal_init.openWindow();
			$(_form_container).unbind('click');

			var _row_id_to_save = '#' + $(this).parents('.smk_pb_admin_row').attr('id'),
			    _saved_data  = ( $(this).parents('.smk_pb_admin_row') ) ? $(this).parents('.smk_pb_admin_row').find('.smk_pb_row_settings').val() : '';

			smk_pb_loader('show');

			jQuery.ajax({
	  			type: "POST",
				url: ajaxurl, 
				data: {
					'action': 'smk_content_builder_row_settings_form_load',
					'data':   { 
						saved_data: _saved_data 
					}
				}, 
				success: function(response){
					smk_toolkit_pb_modal_form_html(response, _form_container);
					// alert(response);
					
				},
				complete: function(){
					smk_toolkit_load_form_functions();
					smk_pb_loader('hide');
					smk_builder_row_settings_submit_form(_row_id_to_save);

				}//ajax complete
			});//ajax
		});
	}//smk_builder_row_settings_load_form

	smk_builder_row_settings_load_form(_settings_button, '.smk_pbuilder_admin_grid');	//Edit module

});//document ready
