/**
 * SMK Toolkit Page Builder Sortable Elements
 */
jQuery.noConflict();
jQuery(document).ready(function($){

	//Make page builder columns sortable
	//----------------------------------
	smk_toolkit_pb_columns_sortable = function(){
		$('.smk_pbuilder_admin_grid .tk_container_12 .content').sortable({
			opacity: 0.6,
			items: '.tk_sortable_grid',
			handle: '.tk_col_controls_l .sortable_handle',
			helper: "original",
			cursor: 'move',
			axis: 'x',
  			start: function( event, ui ) {
  				ui.item.children('.tk_col').addClass('sortable_active');
  			},
  			stop: function( event, ui ) {
  				ui.item.children('.tk_col').removeClass('sortable_active');
  			},
		});
	}
	smk_toolkit_pb_columns_sortable();

	//Make page builder modules sortable
	//----------------------------------
	smk_toolkit_pb_modules_sortable = function(){
		$('.smk_pbuilder_admin_grid .tk_container_12 .content .tk_col .pb_modules .pb_module').children().on('click', function(event){
			event.preventDefault();
		});
		$('.smk_pbuilder_admin_grid .tk_container_12 .content .tk_col .pb_modules').sortable({
			opacity: 0.3,
			items: '.pb_module',
			// handle: '.pb_module_title',
			placeholder: 'pb_module_placeholder',
			cancel: '.mc_child',
			cursor: 'move',
			tolerance: 'pointer',
			connectWith: '.smk_pbuilder_admin_grid .tk_container_12 .content .tk_col .pb_modules',
  			start: function( event, ui ) {
  				$('.smk_pbuilder_admin_grid .smk_pb_admin_row .smk_pb_section').css('z-index', '');
  				$('.smk_pbuilder_admin_grid .tk_sortable_grid').css('z-index', '');
  			},
  			stop: function( event, ui ) {
  				var _parent = ui.item.parents('.pb_modules'),
  					_row_key = _parent.data('row-key').toString(),
  					_section_key = _parent.data('section-key').toString(),
  					_col_key = _parent.data('col-key').toString(),
  					_val_name = ui.item.find('.tk_module_value').attr('name').split("["),
  					_class_name = ui.item.find('.tk_module_class').attr('name').split("["),
  					_cm_key  = _section_key +'_'+ smk_generate_string(5, true)
  					_name_string = '[rows]['+ _row_key +'][row_sections]['+ _section_key +'][column]['+ _col_key +'][column_modules]['+ _cm_key +']';

  				if(ui.item.find('.tk_module_value').length > 0){
	  				ui.item.find('.tk_module_value').attr('name', _val_name[0] + _name_string + '[val]');
  				}
  				if(ui.item.find('.tk_module_class').length > 0){
	  				ui.item.find('.tk_module_class').attr('name', _class_name[0] + _name_string + '[class]');
  				}
  				ui.item.attr('id', _cm_key);
  			},
		});
	}
	smk_toolkit_pb_modules_sortable();

	//Make page builder sections sortable
	//----------------------------------
	smk_toolkit_pb_sections_sortable = function(){
		$('.smk_pbuilder_admin_grid .smk_pb_admin_row').sortable({
			opacity: 0.6,
			items: '.smk_pb_section',
			// handle: '',
			helper: "original",
			cursor: 'move',
			axis: 'y',
			cancel: '.tk_col',
			// `connectWith` right now it's not perfect, need to remove z-index and create a better placeholder on start and stop.
			// connectWith: '.smk_pbuilder_admin_grid .smk_pb_admin_row',
		});
	}
	smk_toolkit_pb_sections_sortable();



});//document ready
