jQuery.noConflict();
jQuery(document).ready(function($){

	//Init tabs plugin
	$('.smk_toolkit_plugin_container').smk_Toolkit_Tabs();

	//Set cookie
	$('.smk_toolkit_plugin_container .smk_nav .nav_item a').on('click', function(){
		var this_cookie = $(this).parents('.smk_toolkit_plugin_container .smk_nav').data('panel');
		$.cookie.raw = true;
		$.cookie(this_cookie, $(this).data('id'), { expires: 7 });
	});

	//Message for save/reset actions
	if( $('.ajax_save_message').length <= 0 ){
		$('.smk_toolkit_plugin_container').prepend('<div class="ajax_save_message"></div>');
	}
	var this_msg = $('.ajax_save_message');

	//Save options via ajax
	//----------------------------------
	smk_save_all_options_via_ajax = function(selector){

		var msg_hide;

		$(selector).submit( function () {

			if (typeof(tinyMCE) !== "undefined") {
				tinyMCE.triggerSave(); // Allow saving tinyMCE via ajax, without this the changes made in visual mode won't be saved, only in `text mode` will be saved. Small stupid bug
			}
			clearTimeout(msg_hide);
			var this_form = $(this);

			$('#submit').attr('disabled', 'disabled');
			this_form.css('opacity', 0.2);
			
			//Message vars
			var this_msg = $('.ajax_save_message');

			//Add new classes
			this_msg.addClass('smk_tk_saving_visible').html(smk_tk_lang.spin);
			
			var all_fields =  this_form.serialize();
			
			$.post( 'options.php', all_fields ).error( 
				function() {
					
					this_form.css('opacity', 1);

					this_msg.html(smk_tk_lang.options_not_saved);
					
					msg_hide = setTimeout(function(){
						this_msg.removeClass('smk_tk_saving_visible');
					},1000);

					$('#submit').removeAttr('disabled');

				}).success( function() {

					this_msg.html(smk_tk_lang.options_saved);
					
					msg_hide = setTimeout(function(){
						this_msg.removeClass('smk_tk_saving_visible');
					},1000);

					this_form.css('opacity', 1);
					$('#submit').removeAttr('disabled');

				});
			return false;
		});
	}
	smk_save_all_options_via_ajax('.smk_toolkit_plugin_main_form');

	// Save options when Ctrl+S is pressed, not implemented yet.
	// Requires a mix between previous function and this.
	//-------------------------------------------------------------------
	// $(window).bind('keydown', function(event) {
	// 	if (event.ctrlKey || event.metaKey) {
	// 		var the_key = String.fromCharCode(event.which).toLowerCase();
	// 		if(the_key === 's'){
	// 			event.preventDefault();
	// 			if( $('.smk_toolkit_plugin_main_form').length > 0 ){
	// 				smk_save_all_options_via_ajax('.smk_toolkit_plugin_main_form');
	// 				alert('y');
	// 			}
	// 		}
	// 	}
	// }); 

	//Reset options via ajax
	//-------------------------------------------------------------------
	function smk_toolkit_reset_options(selector){

		var msg_hide;

		$(selector).on('click', function(){

			clearTimeout(msg_hide);

			if( confirm('Click OK to reset all options. Any theme settings will be lost!') ){
				
				//Message vars
				var this_msg = $('.ajax_save_message');

				//Add new classes
				this_msg.addClass('smk_tk_saving_visible').html(smk_tk_lang.spin);
				
				$.ajax({
					type: "POST",
					url: ajaxurl,
					data: {
						"action": "smk_toolkit_reset_opt"
					},
					success: function(data){

						if( 1 == parseInt( data ) ){
							this_msg.html(smk_tk_lang.options_reset);
							msg_hide = setTimeout(function(){
								this_msg.removeClass('smk_tk_saving_visible');
								location.reload(false);
							},1000);
						}
						else{
							this_msg.html(smk_tk_lang.options_not_reset);
							msg_hide = setTimeout(function(){
								this_msg.removeClass('smk_tk_saving_visible');
								location.reload(false);
							},1000);
						}

					}
				});
				
			}

		});
	}
	smk_toolkit_reset_options('.smk_reset_button');

});