<?php
/**
 * Enqueue
 *
 * Register scripts and styles. Also enqueue general scripts and styles.
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */

function smk_toolkit_enqueue_scripts_admin() {
	
	$tk_plugin_info = get_plugin_data(SMK_TOOLKIT_PATH . 'plugin-base.php');
	$version        = $tk_plugin_info['Version'];
	$toolkit_css    = SMK_ASSETS_URI . 'css/';
	$toolkit_js     = SMK_ASSETS_URI . 'js/';
	$toolkit_fonts  = SMK_ASSETS_URI . 'fonts/';

	if(is_admin()) {
		
		/*
		--------------------------------------------------------------------------------
		Register styles
		--------------------------------------------------------------------------------
		*/
		wp_register_style( 'smk_tk_fields',           $toolkit_css .'fields/all-fields.css', false, $version );
		wp_register_style( 'smk_tk_structure',        $toolkit_css .'structure.css', false, $version );
		
		//Page builder
		wp_register_style( 'smk_tk_page_builder',     $toolkit_css .'page-builder/page-builder.css', false, $version );
		
		//Fonts
		// wp_register_style( 'smk_tk_font_awesome',     $toolkit_fonts .'font-awesome/css/font-awesome.css', false, $version );
		
		/*
		--------------------------------------------------------------------------------
		Register JS
		--------------------------------------------------------------------------------
		*/
		//Common JS scripts
		wp_register_script( 'smk_common_js',          $toolkit_js .'common/common-dist.js', array( 'jquery' ), $version );//Include all previuos in one minified
		
		//Fields
		wp_register_script( 'smk_tk_fields',          $toolkit_js .'fields/scripts.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-sortable' ), $version );
		
		//Panel
		wp_register_script( 'smk_tk_panel',           $toolkit_js .'panel/plugin-panel.js', array( 'jquery' ), $version );
		
		//Page builder
		wp_register_script( 'smk_tk_page_builder',    $toolkit_js .'page-builder/page-builder-dist.js', array( 'jquery', 'jquery-ui-core', 'jquery-ui-sortable' ), $version );

		/*
		--------------------------------------------------------------------------------
		Enqueue styles
		--------------------------------------------------------------------------------
		*/
		wp_enqueue_style( 'smk_tk_fields' );
		wp_enqueue_style( 'smk_tk_structure' );
		wp_enqueue_style( 'smk_tk_page_builder' );
		// wp_enqueue_style( 'smk_tk_font_awesome' );
		wp_enqueue_style( 'wp-color-picker' );

		/*
		--------------------------------------------------------------------------------
		Enqueue scripts
		--------------------------------------------------------------------------------
		*/
		wp_enqueue_script('jquery-ui-core');
		wp_enqueue_script('jquery-ui-sortable');
		wp_enqueue_script('jquery-ui-slider');
		wp_enqueue_script( 'wp-color-picker' );
		wp_enqueue_media();//Enqueue scripts for file uploader
		
		wp_enqueue_script( 'smk_common_js');

		wp_enqueue_script( 'smk_tk_panel');

		//Page builder
		wp_enqueue_script( 'smk_tk_page_builder');

		/**
		 * Localize script
		 * Allow to translate strings used directly in JS files
		 * Usage: `smk_tk_lang.KEY` - `KEY` is the key from the following array, for a multidimensional array
		 * add next key separated by a dot. Ex: `smk_tk_lang.pb.add_new_module`
		 */
		wp_enqueue_script( 'smk_tk_fields' );
 		wp_localize_script( 'smk_tk_fields', 'smk_tk_lang', include(SMK_TOOLKIT_PATH . 'base/localize.php') );

	} //is_admin()

}
add_action('admin_enqueue_scripts', 'smk_toolkit_enqueue_scripts_admin');
add_action('customize_enqueue_scripts', 'smk_toolkit_enqueue_scripts_admin');


/*
-----------------------------------------------------------------------------------
ENQUEUE PAGE BUILDER STYLES & SCRIPTS ON FRONT-END
-----------------------------------------------------------------------------------
*/
function smk_pb_enqueue_styles_n_scripts(){

	wp_register_style( 'spb_toolkit_frontend', SMK_ASSETS_URI . 'css/frontend.css', false );
	// wp_register_style( 'spb_toolkit_font_awesome', SMK_ASSETS_URI . 'fonts/font-awesome/css/font-awesome.css', false );
	wp_enqueue_style( 'spb_toolkit_frontend' );
	// wp_enqueue_style( 'spb_toolkit_font_awesome' );
}
add_action('wp_enqueue_scripts', 'smk_pb_enqueue_styles_n_scripts');
