<?php
/* 
 * Admin page test
 *
 * Test admin page creation
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-06-28 01:40:01
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-01 20:32:23
 *
 */

/*
-------------------------------------------------------------------------------
Test class without methods
 * Must create an invisible admin page.
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_NoMethods extends Smk_AdminPage{}

$page_nomethods = new Smk_AdminPage_Test_NoMethods('admin_page_test_no_methods');
$page_nomethods->init();

/*
-------------------------------------------------------------------------------
Test menu
 * Must add a parent menu
 * Set a custom icon
 * Display it after `Pages` menu
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_Menu extends Smk_AdminPage{

	public function settings(){
		return array(
			'menu_type'     => 'menu',
			'menu_title'    => 'Page test 1',
			'menu_icon'     => 'dashicons-smiley',
			'menu_position' => 21,
		);
	}
	
}

$page_menu = new Smk_AdminPage_Test_Menu('admin_page_test_menu');
$page_menu->init();

/*
-------------------------------------------------------------------------------
Test submenu
 * Must add a submenu under Smk Toolkit main menu
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_SubMenu extends Smk_AdminPage{

	public function settings(){
		return array(
			'parent_slug'   => 'smk_toolkit',
			'menu_title'    => 'Page test 2',
		);
	}
	
}

$page_submenu = new Smk_AdminPage_Test_SubMenu('admin_page_test_submenu');
$page_submenu->init();

/*
-------------------------------------------------------------------------------
Test submenu and page content
 * Must add a submenu under Tools main menu and display custom content
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_SubMenu_CustomContent extends Smk_AdminPage{

	public function settings(){
		return array(
			'parent_slug'   => 'tools.php',
			'menu_title'    => 'Page test 3',
		);
	}

	public function page(){
		echo '<h2>Custom content. Works!</h2>';
	}

}

$page_submenu_custom_content = new Smk_AdminPage_Test_SubMenu_CustomContent('admin_page_test_submenu_custom_content');
$page_submenu_custom_content->init();

/*
-------------------------------------------------------------------------------
Test capability
 * Must add a submenu under Posts main menu and display custom content for 
   users with the capability `upload_files`. Starting from `Author`
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_Capability extends Smk_AdminPage{

	public function settings(){
		return array(
			'parent_slug'   => 'edit.php',
			'menu_title'    => 'Page test 4',
			'capability'    => 'upload_files',
		);
	}

	public function page(){
		echo '<h2>This content should not be visible for Contributors and Subscribers.</h2>';
	}

}

$page_capability = new Smk_AdminPage_Test_Capability('admin_page_test_capability');
$page_capability->init();

/*
-------------------------------------------------------------------------------
Test tabs
 * Test the integrity of page tabs
-------------------------------------------------------------------------------
*/
class Smk_AdminPage_Test_Tabs extends Smk_AdminPage{

	public function settings(){
		return array(
			'parent_slug'   => 'smk_toolkit',
			'menu_title'    => 'Page test 5',
			'default_tab_label' => 'Test',
			'default_section_label' => 'Test section',
		);
	}

	public function page(){
		echo '<h2>Page content</h2>';
	}

}

$page_tabs = new Smk_AdminPage_Test_Tabs('admin_page_test_tabs');
$page_tabs->init();

function smk_admin_page_test_tabs($tabs){
	$tabs[] = array(
		'id' => 'all_good',
		'label' => 'All good',
	);
	$tabs[] = array(
		'label' => 'No id',
	);
	$tabs[] = array(
		'id' => 'no_label',
	);
	$tabs[] = array(
		'id' => '',
		'label' => 'Empty id',
	);
	$tabs[] = array(
		'id' => 'empty_label',
		'label' => '',
	);
	$tabs[] = array(
		'id' => 'Not valid id',
	);
	$tabs[] = array(//nothing
	);
	return $tabs;
}
$page_tabs->add_tabs('smk_admin_page_test_tabs');


/*
-------------------------------------------------------------------------------
Test actions
 * Test the integrity of page actions
-------------------------------------------------------------------------------
*/
// function ap1234_bp(){
// 	echo 'before page';
// }
// $page_actions->add_action( 'before_page', 'ap1234_bp' );

// function ap1234_ap(){
// 	echo 'after page';
// }
// $page_actions->add_action( 'after_page', 'ap1234_ap' );;

// function ap1234_uk(){
// 	echo 'unknown';
// }
// $page_actions->add_action( 'unknown', 'ap1234_uk' );