<?php
/* 
 * Input
 *
 * Input. Text, checkbox, radio fields, etc.
 *
 * -------------------------------------------------------------------------------------
 * @Author: Smartik
 * @Author URI: http://smartik.ws/
 * @Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @Date:   2014-07-01 06:20:51
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-12 02:48:52
 *
 */

if( !class_exists('Smk_Field_Input') ){
	class Smk_Field_Input extends Smk_Field{
		
		public function settings(){
			return array(
				'id' => 'input',
				'name' => 'Text input'
			);
		}

		public function render( $id, $name, $value, $args = array() ) {
			
			$size  = !empty( $args['size'] ) ? trim( $args['size'] ) : 'full';
			$class = !empty( $args['class'] ) ? (array) $args['class'] : array();

			$predefined_class = array( 
				'widefat', 
				'stk_field', 
				$size ? 'size_'. $size : 'size_full'
			);

			return $this->html->input($id, $name, $value, array(
				'class' => array_merge($class, $predefined_class),
				'type'  => !empty( $args['input_type'] ) ? $args['input_type'] : 'text',
			));

		}
	}
}
$fields = new Smk_Field_Input;