<?php
/**
 * ---------------------------------------------------------------
 * Validate options
 * 
 * @param $form Options array that created the form. Multidimensional array
 * @param $data Data to be validated. It is an multidimensional array id => value
 *
 * @return array
 * ---------------------------------------------------------------
 */
function smk_validate_options( $form, $data="" ){

	$id_type_combined = array();
	$validated_data = array();

	// Collect the id and type from default form array
	if( is_array($form) ){
		foreach ($form as $value) {
			$id = ( isset($value['id']) && ! empty($value['id']) ) ? $value['id'] : '';
			$type = ( isset($value['type']) && ! empty($value['type']) ) ? $value['type'] : '';
			$id_type_combined[$id] = $type;
		}
	}

	// Validate Data
	if( is_array($data) ){
		foreach ($data as $key => $value) {
			//Set field type. Required to determine Smk_Validate method
			$field_type = $id_type_combined[$key];

			//Sanitize value
			if(class_exists('Smk_Validate')){
				if(method_exists('Smk_Validate', $field_type)){
					$validated_data[$key] = Smk_Validate::$field_type($value);
				}
				else{
					$validated_data[$key] = $value;// If validation method does not exists
				}
			}
			else{
				$validated_data[$key] = $value;// If validation class does not exists
			}
		}
	}

	return $validated_data;
}