<?php
/**
 * Encode or decode data
 *
 * This class is used to encode or decode elements.
 *
 */

if( ! class_exists('Smk_Data') ){
	class Smk_Data{

		################################################################################
		
		/**
		 * Encode JSON and HTML escape
		 *
		 *
		 * @param $array array The array to be JSON encoded
		 * @return string JSON encoded and HTML escaped 
		 */
		
		public static function encodeJsonE($array){
			return htmlspecialchars( json_encode( $array ), ENT_COMPAT, "UTF-8");
		}//encodeJson
		
		################################################################################
		
		/**
		 * Decode HTML escaped and decode JSON
		 *
		 * @param $string string The string to be HTML decoded and JSON decoded
		 * @return string JSON decoded and HTML decoded 
		 */
		
		public static function decodeJsonE($string){
			return json_decode( htmlspecialchars_decode( $string ), true );
		}//decodeJson
		
		################################################################################
		
		/**
		 * Encode HTML
		 *
		 * @param $string string
		 * @return string
		 */
		
		public static function encodeHtml($string, $flags = ENT_COMPAT, $encoding = "UTF-8"){
			return htmlspecialchars( $string, $flags, "UTF-8");
		}//encodeHtml

		################################################################################
		
		/**
		 * Decode HTML
		 *
		 * @param $string string
		 * @return string
		 */
		
		public static function decodeHtml($string){
			return htmlspecialchars_decode( $string );
		}//decodeHtml
		

	}//Smk_Data class
}//class_exists 'Smk_Data'
