<?php
if( ! class_exists('Smk_Check') ){
	class Smk_Check{

		/**
		 * Check array value
		 *
		 * @param array $array Main array
		 * @param string $key The key to check
		 * @param string $mode Key mode. What should return this key 's' - string, 'a' - array, 'i' - integer
		 * @return bool
		 *
		 */
		public static function array_val($array, $key, $mode='s'){

			$result = false;

			if( $array && is_array($array) ){
				if( isset($array[$key]) ){
					if( $mode == 'a' ){
						$result = ( is_array($array[$key]) && count($array[$key]) > 0 ) ? true : false;
					}
					elseif( $mode == 'i' ){
						if( ! empty($array[$key]) && is_numeric($array[$key]) ){
							$array[$key] = trim($array[$key]);
							$result = ( $array[$key] && !empty($array[$key]) ) ? true : false;
						}
					}
					else{
						if( ! empty($array[$key]) ){
							$array[$key] = trim($array[$key]);
							$result = ( $array[$key] && !empty($array[$key]) ) ? true : false;
						}
					}
				}
			}

			return $result;
		}

		/**
		 * Check if value is a HEX color
		 *
		 * @param string $value Main value
		 * @return bool
		 *
		 */
		public static function is_hex_color($value){

			$result = false;

			if( !empty($value) && !is_array($value) && !is_bool($value) ){
				if (preg_match("/#([a-f]|[A-F]|[0-9]){3}(([a-f]|[A-F]|[0-9]){3})?\b/", $value)) {
					$result = true;
				}
			}
			
			return $result;
		}

		/**
		 * Check array key existence recursive
		 *
		 * @param string $needle Main array
		 * @param array $haystack Main array
		 * @return bool
		 *
		 */
		public static function array_key_exists_r($needle, $haystack){
			$result = array_key_exists($needle, $haystack);
			if ($result) return $result;
			foreach ($haystack as $v) {
				if (is_array($v)) {
					$result = static::array_key_exists_r($needle, $v);
				}
				if ($result) return $result;
			}
			return $result;
		}

	}//class
}//class_exists