<?php
if( ! class_exists('Smk_Get') ){
	class Smk_Get{

		/**
		 * Get array value
		 *
		 * @param array $array Main array
		 * @param string $key The key to get
		 * @param mixed $def Default if key is not set
		 * @return string|array
		 */
		public static function value($array, $key, $def=''){

			$result = $def;

			if( $array && is_array($array) ){
				if( isset($array[$key]) && ! empty($array[$key]) ){
					if( is_array($array[$key]) && count($array[$key]) > 0 ){
						$result = $array[$key];
					}
					else{
						$array[$key] = trim($array[$key]);
						if($array[$key]){
							$result = $array[$key];
						}
					}
				}
			}

			return $result;
		}

		################################################################################

		/**
		 * Get a saved option from a custom panel 
		 *
		 * @param string $panel The panel ID defined by developer on init
		 * @param string $option The option ID to get the value
		 * @param string $default The default value
		 * @return mixed
		 */
		public static function option($panel, $option, $default = ''){
		
			$opts = ( isset($panel) ) ? 'smkop_'. $panel : false;

			if( false !== $opts ){
				$val = get_option( $opts );
				$opts = ( isset( $val[$option] ) ) ? $val[$option] : $default;
			}

			return $opts;

		}

		################################################################################

		/**
		 * Get a saved key from a metabox
		 *
		 * @param string $key The key to get
		 * @param mixed $default Default value if the metabox key is not set 
		 * @param string $postid The post id if the function is not used within loop 
		 * @return mixed
		 */
		public static function meta($key=null, $default=false, $postid=false ){
			
			//Set the result to false, because it is not available yet.
			$result = $default;

			//if the key is set, proceed
			if( isset($key) && !empty($key) ){
				$postid = ( $postid && isset($postid) && is_numeric($postid) ) ? $postid : get_the_ID();
				$meta = get_post_meta( $postid, $key, true);	//get the result
				$result = ( isset($meta) ) ? $meta : $default;
			}

			return $result;

		}

	}//class
}//class_exists