<?php
/**
 * SMK Content Builder Form
 *
 * The form that is used in modal window.
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( ! class_exists('Smk_ContentBuilder_Form') ){
	class Smk_ContentBuilder_Form{

		################################################################################
		
		/**
		 * Create form
		 *
		 * Create form from options array and fill it with saved data(not required if it
		 * does not exist yet).
		 *
		 * @param array $form Form options array
		 * @param array $saved_data Saved data(if any)
		 * @param string $options_module The module to pass in options switch(optional).
		 * @return string HTML form
		 */
		public static function createForm($form, $saved_data = '', $options_module = 'builder'){
			$saved_i = array();
			
			foreach ($form as $key => $value) {
				$std = ( isset( $value['std'] ) && !empty($value['std']) ) ? $value['std'] : '';
				if( ! isset($value['id']) ) 
					continue;
				$defaults[ $value['id'] ] = $std;
			}

			if(!isset($saved_data) || empty($saved_data)){
				$saved_i = $defaults;
			}
			else{
				$saved_decode = Smk_Data::decodeJsonE( stripslashes($saved_data) );
				$saved_i = wp_parse_args($saved_decode, $defaults);
			}
			
			$args = array(
				'object' => '',
				'fields' => $form,
				'defaults' => $saved_i,
				'saved' => $saved_i,
				'module' => $options_module,
			);

			echo '<div class="content_builder_form_controls">'. smk_toolkit_options_global($args) .'</div>';
			
		}
		
	}//Smk_ContentBuilder_Form class
}//class_exists 'Smk_ContentBuilder_Form'