<?php
/**
 * SMK Content Builder Skeleton
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( ! class_exists('Smk_ContentBuilder_Skeleton') ){
	class Smk_ContentBuilder_Skeleton{

		################################################################################
		
		/**
		 * Builder Row
		 *
		 * From Admin UI.
		 *
		 * @param $builder array The full builder array.
		 * @return string 
		 */
		
		public function builderRows($builder){
			if( $rows = Smk_Get::value($builder, 'rows', false) && is_array( $rows ) ){
				foreach ($rows as $row_key => $row_value) {
					$this->builderSections(array(
						'row_key'   => $row_key,
						'row_value' => $row_value,
					));
				}
			}
		}//builderRows
		
		################################################################################
		
		/**
		 * Builder Section
		 *
		 * From Admin UI.
		 *
		 * @param $args array Row arguments that should contain the section value
		 */
		public function builderSections($args){
			if( $row = Smk_Get::value($args, 'row_value', false) ){
				if( $row_sections = Smk_Get::value($row, 'row_sections', false) ){
					//do stuff
				}
			}
		}
		
	}//Smk_ContentBuilder_Skeleton class
}//class_exists 'Smk_ContentBuilder_Skeleton'