<?php
/**
 * Embed Module
 *
 * Page Builder Default Module
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( class_exists('Smk_PageBuilder_Module') && !class_exists( 'Smk_PageBuilder_Default_Embed' ) ) {
	class Smk_PageBuilder_Default_Embed extends Smk_PageBuilder_Module {

		public function settings(){
			return array(
				'title' => 'Embed',
				'icon'  => array(
					'class' => 'film',
					'color' => '#01A04C',
				),
				'desc' => 'Embed media. On <a href="http://codex.wordpress.org/Embeds#Okay.2C_So_What_Sites_Can_I_Embed_From.3F" target="_blank">WP Codex</a> page are listed all sites that you can embed from.',
				'category' => 'media',
			);
		}

		public function form(){
			return array(

				array(
					'id' 	=> 'url',
					'type' 	=> 'input',
					'label' => __('URL:', 'smk_toolkit'),
					'desc' 	=> sprintf( 
									__('Enter the full url here. On %1$s page are listed all sites that you can embed from. Ex: %2$s', 'smk_toolkit'), 
									'<a href="http://codex.wordpress.org/Embeds#Okay.2C_So_What_Sites_Can_I_Embed_From.3F" target="_blank">Wordpress Codex</a>', 
									'<code>https://www.youtube.com/watch?v=Vo0Cazxj_yc</code>'
								),
				),
				array(
					'id' 	=> 'optional',
					'type' 	=> 'section',
					'content' => __('Optional settings', 'smk_toolkit'),
					'align'	=> 'center',//'left', 'center' or 'right'
				),
				array(
					'id' 	=> 'maxwidth',
					'type' 	=> 'sliderui',
					'label' => __('Max width:', 'smk_toolkit'),
					'desc' 	=> __('The maximum width of the embedded resource', 'smk_toolkit'),
					'std'   => 960,
					'min'   => 100,
					'max'   => 1500,
					'step'  => 5,
					'set'   => array(
						'grid' => 6,
						'grid_pos' => 'first',
					),
				),
				array(
					'id' 	=> 'maxheight',
					'type' 	=> 'sliderui',
					'label' => __('Max height:', 'smk_toolkit'),
					'desc' 	=> __('The maximum height of the embedded resource', 'smk_toolkit'),
					'std'   => 640,
					'min'   => 100,
					'max'   => 1500,
					'step'  => 5,
					'set'   => array(
						'grid' => 6,
						'grid_pos' => 'last',
					),
				),

			);
		}

		public function render($data){
			
			global $wp_embed;

			//Data
			$url       = Smk_Get::value($data, 'url');
			$maxwidth  = Smk_Get::value($data, 'maxwidth');
			$maxheight = Smk_Get::value($data, 'maxheight');
			
			if ( !empty($url) ){

				$width  = ( is_numeric($maxwidth) ) ? $maxwidth : 960;
				$height = ( is_numeric($maxheight) ) ? $maxheight : 640;

				$atts = array(
					'width'  => $width,
					'height' => $height,
				);
				echo '<div class="smk_pb_embed_container">'. $wp_embed->shortcode( $atts, $url ) .'</div>';
			}

		}

	}//class
}//check class_exists
