<?php
/**
 * Text Module
 *
 * Page Builder Default Module
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( class_exists('Smk_PageBuilder_Module') && !class_exists( 'Smk_PageBuilder_Default_Text' ) ) {
	class Smk_PageBuilder_Default_Text extends Smk_PageBuilder_Module {

		public function settings(){
			return array(
				'title' => 'Text',
				'icon'  => array(
					'class' => 'paragraph-left',
					'color' => '#CD853F',
				),
				'desc' => __('Plain text module', 'smk_toolkit'),
				'category' => 'content',
			);
		}

		public function form(){
			return array(

				array(
					'id' 	=> 'text',
					'type' 	=> 'textarea',
					'label' => __('Text:', 'smk_toolkit'),
					'desc' 	=> __('Content here. Required', 'smk_toolkit'),
					'set'   => array(
						'rows'  => 15,
					),
				),
				array(
					'id' 	=> 'wpautop',
					'type' 	=> 'switch',
					'label' => __('Auto paragraphs:', 'smk_toolkit'),
					'desc' 	=> __('Automatically create paragraphs. ', 'smk_toolkit'),
					'std'   => 1,
					// 'set'   => array(
					// 	'grid' => 3,
					// 	'grid_pos' => 'first',
					// ),
				),

			);
		}

		public function render($data){

			//Data
			$text    = Smk_Get::value($data, 'text');
			$wpautop = Smk_Get::value($data, 'wpautop', 1);

			//Content text
			if( !empty($text) ){
				echo ($wpautop == 1) ? do_shortcode( wpautop( $text ) ) : do_shortcode( $text );
			}

		}

		public function preview($data){
			$this->render($data);
		}

	}//class
}//check class_exists
