<?php
/**
 * Inject page builder data
 *
 * Inject page builder data in the current page content. It will be rendered in
 * the_content() only if the current instance is single(page.php, single.php, single-cpt.php, etc.)
 *
 * @param $content string Not required because it is passed through a filter(`the_content`) 
 * @return string Final content
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
function smk_page_builder_data() {
	$all_meta = get_post_meta( get_the_ID() );
	if(empty( $all_meta['smk_page_builder_data'] ))
		return false;

	if( ! is_array( $all_meta['smk_page_builder_data'] ) )
		return false;

	if( empty($all_meta['smk_page_builder_data'][0]) )
		return false;

	$pb = unserialize($all_meta['smk_page_builder_data'][0]);

	return $pb;
}

if( ! function_exists('smk_add_pb_data_to_content') ) {
	function smk_add_pb_data_to_content($content) {
		if( ! current_theme_supports('smk_toolkit_page_builder') ){
			$pb = smk_page_builder_data();
			if( !empty($pb) && function_exists('smk_pb_output') ){
				if( is_singular() && is_main_query() ) {
					// $content = smk_pb_output($pb) . '<div class="smk_toolkit_grid_container smk_clearfix"><div class="smk_tk_grid desk_12">' . $content . '</div></div>' /*. smk_ppprint( $pb )*/;
				}
			}
		}
		return $content;
	}
}
add_filter( 'the_content', 'smk_add_pb_data_to_content', 690);