<?php
/**
 * Page Builder Module Category
 *
 * SMK Toolkit Page Builder categories
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( ! class_exists('Smk_PageBuilder_ModuleCategory') ) {
	class Smk_PageBuilder_ModuleCategory {
		
		/**
		 * Add new categories
		 *
		 * This is passed in constructor
		 *
		 */
		protected $_add; 

		################################################################################
		
		/**
		 * Constructor
		 *
		 * @param $add array The categories to be added.
		 */
		public function __construct( $add = array() ){
			$this->_add = ( isset($add) && is_array($add) && count($add) > 0 ) ? $add : array();
			add_action( 'page_builder_module_categories', array( &$this, 'categories' ) );
		}
		
		################################################################################
		
		/**
		 * Categories
		 *
		 * This is passed via add_action
		 *
		 * @return string The HTML
		 */
		public function categories(){
			$cats = $this->_add;
			if(isset($cats) && is_array($cats) && !empty($cats)){
				foreach ($cats as $key => $value) {
					echo '<a href="#" data-filter="'. $key .'">'. $value .'</a>';
				}
			}
		}

	}//class

}//check class_exists

//Add default page builder categories
new Smk_PageBuilder_ModuleCategory(array(
	'all'     => __('All', 'smk_toolkit'),
	'content' => __('Content', 'smk_toolkit'),
	'media'   => __('Media', 'smk_toolkit'),
));