<?php
/**
 * Default Page Builder Rows
 *
 * Default Page Builder Rows. This is a final class which could not be extended.
 * To add other custom rows, extend base class `Smk_PageBuilder_Row`
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( class_exists('Smk_PageBuilder_Row') && ! class_exists('Smk_PageBuilder_RowDefaults') ){
	final class Smk_PageBuilder_RowDefaults extends Smk_PageBuilder_Row{
		
		/**
		 * Default Options
		 *
		 * Default Page Builder Rows
		 *
		 * @param $options array
		 * @return array 
		 */
		public function options(){
			return array(
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/1.png',
					'description'   => __('1 column. Grid - 12', 'smk_toolkit'),
					'columns'       => array(12),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/66.png',
					'description'   => __('2 columns. Grid - 6:6', 'smk_toolkit'),
					'columns'       => array(6,6),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/444.png',
					'description'   => __('3 columns. Grid - 4:4:4', 'smk_toolkit'),
					'columns'       => array(4,4,4),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/363.png',
					'description'   => __('3 columns. Grid - 3:6:3', 'smk_toolkit'),
					'columns'       => array(3,6,3),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/3333.png',
					'description'   => __('4 columns. Grid - 3:3:3:3', 'smk_toolkit'),
					'columns'       => array(3,3,3,3),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/32223.png',
					'description'   => __('5 columns. Grid - 3:2:2:2:3', 'smk_toolkit'),
					'columns'       => array(3,2,2,2,3),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/222222.png',
					'description'   => __('6 columns. Grid - 2:2:2:2:2:2', 'smk_toolkit'),
					'columns'       => array(2,2,2,2,2,2),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/48.png',
					'description'   => __('2 columns. Grid - 4:8', 'smk_toolkit'),
					'columns'       => array(4,8),
				),
				array(
					'icon'          => SMK_ASSETS_URI .'images/column/84.png',
					'description'   => __('2 columns. Grid - 8:4', 'smk_toolkit'),
					'columns'       => array(8,4),
				),
			);
		}
		
	}//Smk_PageBuilder_RowDefaults class
}//class_exists

new Smk_PageBuilder_RowDefaults;