<?php
/**
 * Page Builder Row
 *
 * Pre-defined Page Builder Rows. 
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 */
if( ! class_exists('Smk_PageBuilder_Row') ) {
	abstract class Smk_PageBuilder_Row {

		/**
		 * Page builder id
		 *
		 * The ID defined in `Smk_PageBuilder_Base`
		 *
		 * @param string 
		 * @return string 
		 */
		protected $_id = 'smk_page_builder';

		################################################################################
		
		/**
		 * Constructor
		 *
		 * @param $id string New Page Builder ID 
		 * @return string 
		 */
		public function __construct($id = ''){
			$this->_id = ( isset($id) && !empty($id) ) ? $id : $this->_id;
			add_action( $this->_id . '_row', array( &$this, 'add_row' ) );
		}

		################################################################################
		
		/**
		 * Add row
		 *
		 * Add the HTML. Used in `add_action`
		 *
		 */
		public function add_row(){
			$opt = $this->options();
			if(is_array($opt) && count($opt) > 0){
				foreach ($opt as $value) {
					echo '<div class="rblock" data-columns="'. join($value['columns'], ':') .'" title="'. $value['description'] .'" style="background-image: url('. $value['icon'] .')"></div>';	
				}
			}
		}

		################################################################################
		
		/**
		 * Options
		 *
		 * Options array to create rows.
		 *
		 * @return array 
		 */
		abstract public function options();

	}//class
}//check class_exists