<?php
/**
 * Smk Widget
 *
 * Base module class designed to be extended to create custom WP Widgets.
 *
 * -------------------------------------------------------------------------------------
 * Author: Smartik
 * Author URI: http://smartik.ws/
 * Copyright: (c) 2014 Smartik. All rights reserved
 * -------------------------------------------------------------------------------------
 *
 * @todo Make it abstract
 * @todo Include parent constructor
 * @todo Use PHP5 constructor
 * @todo Add enqueue method
 * @todo Rewrite defaults, form and update methods.
 */
if( class_exists('WP_Widget') && ! class_exists('Smk_Widget') ) {
abstract class Smk_Widget extends WP_Widget {

	public $current_class;

/*-----------------------------------------------------------
	Constructor
-------------------------------------------------------------*/
	function __construct() {
		
		$widget_ops = array(
			'classname' 	=> 'options_widget', 
			'description' 	=> 'SMK Toolkit Widget'
		);

		/*
		//If you're using WP Color Picker, is recomended to set the widget width to a number greater then 270
		//Uncomment line below if needed.
		$widget_settings = array(
			'width' => 270, 
			'height' => 350
		);
		*/

		Wp_Widget::__construct('options_widget', 'Smk_Widget', $widget_ops/*, $widget_settings*/ );

		$this->current_class = get_class($this);

	}

	public function widgetSettings(){

	}


/*-----------------------------------------------------------
	Options
-------------------------------------------------------------*/
	function options() {
		return false;
	}

/*-----------------------------------------------------------
	Defaults
-------------------------------------------------------------*/
	function defaults( $options ) {
		$output = array();

		foreach ($options as $value) {
			if(isset($value['id'])){
				$value['std'] = ( isset($value['std'])) ? $value['std'] : '';
				$output[$value['id']] = $value['std'];
			}			
		}

		return $output;
	}

/*-----------------------------------------------------------
	Form
-------------------------------------------------------------*/
	function form( $instance ) {
		
		$wgt_opt = $this->options();

		//Set defaults
		$instance = wp_parse_args( (array) $instance, $this->defaults($wgt_opt) );
		
		// //Saved values for checkbox groups
		$saved_instance = array();
		foreach ($wgt_opt as $value) {
			if(isset($value['id'])){
				$saved_instance[$value['id']] = $instance[$value['id']];
			}
		}

		//This is the form itself

		$args = array(
			'object' => $this,
			'fields' => $wgt_opt,
			'defaults' => $instance,
			'saved' => $saved_instance,
			'module' => 'widget'
		);

		echo smk_toolkit_options_global($args);
		// smk_print($instance);

	}	
	

/*-----------------------------------------------------------
	On Update function
-------------------------------------------------------------*/
	function onUpdate( $new_instance, $old_instance ) {
		return false;
	}

/*-----------------------------------------------------------
	Update function
-------------------------------------------------------------*/
	function update( $new_instance, $old_instance ) {
		
		//Validate/Sanitize
		$fields_type = Smk_xGet::options_type_specific( $this->options() );
		$new_instance = Smk_Sanitize::options_array($new_instance, $fields_type);

		//Get the old value
		$instance = $old_instance;
		
		//All options
		$wgt_opt = $this->options();
		
		//Update value
		foreach ($wgt_opt as $value) {
			if(isset($value['id'])){
				$id = $value['id'];
				$instance[$id] = $new_instance[$id];
			}
		}
		
		$this->onUpdate( $new_instance, $old_instance ); // Run on update		
		return $instance;
	
	}


/*-----------------------------------------------------------
	The Widget
-------------------------------------------------------------*/	
	function widget( $args, $instance ) {
		return false;
	}

}//End Class
}//End class_exists check
?>