<?php
/*
Plugin Name: SMK Toolkit
Plugin URI: http://smk-toolkit.com/
Description: A powerful plugin that will help you to develop themes and plugins in a fast and easy way with only a few basic PHP knowledge. 
Author: Smartik
Author URI: http://smartik.ws/
Version: 0.8.7
Copyright: (c) 2014 Andrei Surdu. All rights reserved
*/
/*
 *
 * @Date:   2014-02-26 22:34:06
 * @Last Modified by:   Smartik
 * @Last Modified time: 2014-07-05 07:44:56
 *
 */

//Do not allow direct access to this file.
if( ! function_exists('add_action') ) die();

//This class is for future use, and shouldn't be escaped with class_exists.
class Smk_Toolkit{}

/*
--------------------------------------------------------------------------------
Constants
--------------------------------------------------------------------------------
*/
//General
if(!defined('SMK_TOOLKIT_PATH'))   define( 'SMK_TOOLKIT_PATH', plugin_dir_path(__FILE__) );
if(!defined('SMK_TOOLKIT_URI'))    define( 'SMK_TOOLKIT_URI', plugin_dir_url(__FILE__) );

//Fields
if(!defined('SMK_FIELDS_URI'))     define( 'SMK_FIELDS_URI', SMK_TOOLKIT_URI .'fields/' );
if(!defined('SMK_FIELDS_PATH'))    define( 'SMK_FIELDS_PATH', SMK_TOOLKIT_PATH .'fields/' );

//Mods
if(!defined('SMK_MOD_URI'))        define( 'SMK_MOD_URI', SMK_TOOLKIT_URI .'mod/' );
if(!defined('SMK_MOD_PATH'))       define( 'SMK_MOD_PATH', SMK_TOOLKIT_PATH .'mod/' );

//Assets
if(!defined('SMK_ASSETS_URI'))     define( 'SMK_ASSETS_URI', SMK_TOOLKIT_URI .'assets/' );
if(!defined('SMK_ASSETS_PATH'))    define( 'SMK_ASSETS_PATH', SMK_TOOLKIT_PATH .'assets/' );

// Define DEV Mode
if(!defined('SMK_DEVMODE'))        define( 'SMK_DEVMODE', true );

//Global End Of Line
if(!defined('SMK_EOL'))            define( 'SMK_EOL', ( defined(PHP_EOL) ) ? PHP_EOL : "\r\n" );

/*
--------------------------------------------------------------------------------
Plugin's specific
--------------------------------------------------------------------------------
*/
add_action( 'plugins_loaded', 'smk_tookit_load_translations' );
function smk_tookit_load_translations() {
	load_plugin_textdomain( 
		'smk_toolkit', 
		false, 
		dirname( plugin_basename( __FILE__ ) ) . '/languages/' 
	); 
}

/*
-------------------------------------------------------------------------------
Access to plugin directory
-------------------------------------------------------------------------------
*/
require_once SMK_TOOLKIT_PATH .'admin/access.php';

/*
--------------------------------------------------------------------------------
Global data
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'admin', array(
	'global.php',
));
/*
--------------------------------------------------------------------------------
Admin
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'admin', array(
	'log/log.php',
));

/*
--------------------------------------------------------------------------------
Helpers
--------------------------------------------------------------------------------
*/
smk_toolkit_require( false, array(
	'helpers/include-helpers.php',
	'helpers-admin/include-helpers-admin.php',
));

/*
--------------------------------------------------------------------------------
LESS PHP
--------------------------------------------------------------------------------
*/
if( ! class_exists("Less_Parser") ){
smk_toolkit_require( false, array(
	'less/Less.php',
));
}

/*
--------------------------------------------------------------------------------
Validation
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'validate', 'sanitize.php');

/*
--------------------------------------------------------------------------------
Fields
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'fields', array(
	'validate-options.php',
	'options.php',
	'data-validation.php',
	'fields.php',
	'default.php',
));

/*
--------------------------------------------------------------------------------
Mods
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'mod', array(
	'admin-page/admin-page.php',
	'panel/panel.php',
	'widget/widget.php',
	'metabox/metabox.php',
));

/*
--------------------------------------------------------------------------------
Content Builder
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'mod/content-builder', array(
	'skeleton.php',
	'ajax.php',
	'form.php',
));

/*
--------------------------------------------------------------------------------
Page Builder
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'mod/page-builder', array(
	'base.php',
	'row.php',
	'row-defaults.php',
	'row-init.php',
	'row-form-fields.php',
	'module.php',
	'module-category.php',
	'module-init.php',
	'front-end-output.php',
	'front-end-the-content-inject.php',
	'front-end-wp-head-styles.php',
));

/*
--------------------------------------------------------------------------------
Page builder default modules
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'mod/page-builder/default', array(
	'text.php',
	'embed.php',
));

/*
--------------------------------------------------------------------------------
Init default page builder modules
--------------------------------------------------------------------------------
*/
$reg_modules = new Smk_PageBuilder_ModuleInit();
$reg_modules->register(
	array(
		'text'  => 'Smk_PageBuilder_Default_Text',
		'embed' => 'Smk_PageBuilder_Default_Embed',
	)
);

/*
--------------------------------------------------------------------------------
Enqueue scripts and styles
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'base', array(
	'enqueue.php',
));

/*
--------------------------------------------------------------------------------
Smk Toolkit Pages
--------------------------------------------------------------------------------
*/
smk_toolkit_require( 'admin', array(
	'smk-toolkit-page.php',
	'sys-info/system-info.php',
	'sys-info/page-system-info.php',
	'sys-info/page-php-info.php',
	'sys-info/page-wp-options.php',
	'sys-info/page-all-fields.php',
	'sys-info/page-all-panels.php',
	'log/log-page.php',
));

/*
--------------------------------------------------------------------------------
Tests & Experiments.
--------------------------------------------------------------------------------
*/
// DO NOT INCLUDE THE FOLLOWING CODE ON A LIVE WEBSITE. THIS IS USED ONLY FOR
// TESTS AND DEBUGING
/*smk_toolkit_require( 'experiments', array(
	'experiments.php',
	'test.php',
));*/