<?php 
smk_print_recipe();
get_header(); 
$recipe_data = new Smk_Recipe_Data;
?>

<div class="rw-section rw-container right-sidebar">
	<div class="rw-inner clearfix">

		<?php smk_theme_sidebar(); ?>

		<!-- Main content -->
		<div class="rw-column rw-content" itemscope itemtype="http://schema.org/Recipe">
			
			<div class="rw-row page-title single-recipe-page-title">
				<h1 itemprop="name"><?php echo smk_theme_page_title(); ?></h1>
				<?php echo smk_manage_recipe( false, '<i class="fa fa-cog"></i>', 'right'); ?>
			</div>
			
			<?php if( is_edit_recipe() ) : ?>

				<div class="rw-row">
					
					<?php smk_submit_recipe_form( get_the_ID() ); ?>

				</div>

			<?php else : ?>

				<div class="rw-row">

					<?php 
					if (have_posts()) {
						while (have_posts()) : the_post();
				 			echo smk_recipe_is_pending();
						?>

							<div id="post-<?php the_ID(); ?>" <?php post_class(array('entry', 'style-columns', 'clearfix')); ?>>
								<div class="entry-photo single-recipe-photo-cover">
									<?php 
										if ( has_post_thumbnail() ) { // check if the post has a Post Thumbnail assigned to it.
											$layout_width = smk_theme_setting( 'layout_width', 1140 );
											$photo_width_plus = 0;
											if( 1240 == $layout_width ){
												$photo_width_plus = 100;
											}
											elseif( 1340 == $layout_width ){
												$photo_width_plus = 200;
											}
											elseif( 1440 == $layout_width ){
												$photo_width_plus = 300;
											}

											echo '<img itemprop="image" src="'. smk_theme_resize(smk_theme_post_image_url(), 780 + $photo_width_plus, false, true, true, false) .'" alt="'. get_the_title() .'" />';
										}
										$prints_number_total = $recipe_data->getPrintsNumber();
										$prints_number = absint($prints_number_total) > 0 ? ' ('. $prints_number_total .')' : '';
									?>
									<div class="recipe-tools">
										<!-- <div class="tool like" title="Like (686)"><i class="the-icon fa fa-thumbs-o-up"></i></div> -->
										<!-- <div class="tool favorite active" title="Add to favorites (320)"><i class="the-icon fa fa-heart-o"></i></div> -->
										<?php 
											smk_like_button( false, array(
												'class'            => 'tool like',
												'content'          => '<i class="the-icon fa fa-thumbs-o-up"></i>',
												'title_format'     => '%text% (%count%)',
												'title'            => __('Like', 'smk_theme'),
												'title_remove'     => __('Dislike', 'smk_theme'),
												'title_not_logged' => __('Please log in to like this post', 'smk_theme'),
											));
											smk_favorite_button( false, array(
												'class'            => 'tool favorite',
												'content'          => '<i class="the-icon fa fa-heart-o"></i>',
												'title_format'     => '%text% (%count%)',
												'title'            => __('Add to favorites', 'smk_theme'),
												'title_remove'     => __('Remove from favorites', 'smk_theme'),
												'title_not_logged' => __('Please log in to add this post to favorites', 'smk_theme'),
											)); 
										?>
										<!-- <div class="tool collection" title="Add to collection (47)"><i class="the-icon fa fa-bookmark-o"></i></div> -->
										<?php if( 'on' == smk_recipe_setting( 'ui_enable_print', 'on' )  ) : ?>
											<a href="<?php echo smk_add_query_arg('print_recipe', 1); ?>" class="tool print" title="<?php echo _x('Print', 'verb', 'smk_theme') . $prints_number; ?>"><i class="the-icon fa fa-print"></i></a>
										<?php endif; ?>
										<!-- <div class="tool share" title="Share (210)"><i class="the-icon fa fa-share-alt"></i></div> -->
									</div>
								</div>
								<?php 
									$single_recipe_meta_position = get_theme_mod( 'single_recipe_meta_position', 'right' );
									$allowed_pos = array( 'right', 'left', 'top', 'bottom' );
									$single_recipe_meta_position = ( in_array( $single_recipe_meta_position, $allowed_pos ) ) ? $single_recipe_meta_position : 'right';
									if( !empty($_GET['meta_position']) && in_array( $_GET['meta_position'], $allowed_pos ) ){
										$single_recipe_meta_position = sanitize_html_class( $_GET['meta_position'] );
									}

								?>
								<div class="entry-content meta-pos-<?php echo $single_recipe_meta_position; ?> clearfix">

									<?php 
										if( in_array( $single_recipe_meta_position, array('left', 'top') ) ){
											$first_tpl = 'meta';
											$second_tpl = 'content';
										}
										else{
											$first_tpl = 'content';
											$second_tpl = 'meta';
										}
										if( in_array( $single_recipe_meta_position, array('bottom', 'top') ) ){
											$tpl_separator = '<div class="clear"></div>';
										}
										else{
											$tpl_separator = '';
										}
										smk_get_template_part( 'tpl/tpl-single-recipe-'. $first_tpl .'.php' );
										echo $tpl_separator;
										smk_get_template_part( 'tpl/tpl-single-recipe-'. $second_tpl .'.php' );
									?>
								
								</div> <!-- .entry-content -->
								<div class="clear"></div>
								
							</div> <!-- .entry -->
							<div class="clear"></div>
							

						<?php
						// echo '<pre>';
						// print_r( get_post_meta( get_the_ID() ) );
						// print_r( get_post_meta( get_the_ID(), 'smk_who_rated_the_recipe' ) );
						// echo '</pre>';
						endwhile; 
					}
					?>


				</div> <!-- .rw-row -->
				
				<?php 
					$categories = get_the_terms(get_the_ID(), 'recipe_categories');
					$tags = get_the_terms(get_the_ID(), 'recipe_tags');
					if( $categories || $tags ){
						echo '<div class="rw-row border-bottom clearfix">';
							if( $categories ){ 
								echo '<div class="recipe-taxes"><span class="tax-title">'. __('Category:', 'smk_theme') .'</span>';
								foreach ( $categories as $cat ) {
									echo '<span class="tax">'. smk_get_recipe_category_link( $cat->slug ) .'</span>';
								}
								echo '</div>';
							}
							if( $tags ){ 
								echo '<div class="recipe-taxes"><span class="tax-title">'. __('Tags:', 'smk_theme') .'</span>';
								foreach ( $tags as $tag ) {
									echo '<span class="tax">'. smk_get_recipe_tag_link( $tag->slug ) .'</span>';
								}
								echo '</div>';
							}
						echo '</div> <!-- .rw-row -->';
					} 
				?>

				<div class="rw-row subtle border-bottom clearfix">
				<?php 
					if( $recipe_data->hasCategory() ) {
						smk_theme_related_posts( array(
							'post_type' => 'smk_recipes',
							'tax'       => 'recipe_categories',
						) ); 
					}
				?>
				</div> <!-- .rw-row -->
				<div id="all-post-comments">
					<?php
						comments_template(); 
					?>
				</div>

			<?php endif; ?>
			
		</div> <!-- .rw-content -->

	</div> <!-- .rw-inner -->
</div> <!-- .rw-container -->

<?php get_footer(); ?>