<?php 
	$recipe_data       = new Smk_Recipe_Data;
	$position          = ( isset( $this->position ) ) ? $this->position : 1;
	$show_meta         = ( !empty( $this->show_meta ) ) ? true : false;
	$number_of_columns = ( !empty( $this->columns ) && absint( $this->columns ) >= 3 ) ? absint( $this->columns ) : 3;
	$clear_grid_row    = '';
	$column            = ( $number_of_columns >= 3 ) ? ' rvg-'. $number_of_columns .'-col' : '';
?>

<!-- Entry -->
<div class="recipe-view-grid<?php echo $column; ?>">
<div class="grid-in">

	<div class="recipe-block">
		<?php
			$img_url  = '';
			$thumb_bg = '';
			if( has_post_thumbnail() ) {
				$img_url = '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 460, 460, true) .'" alt="' . esc_attr( get_the_title() ) . '" />';
			}
			elseif( ! has_post_thumbnail() ){
				$thumb_bg = ' thumb-bg';
			}

			echo '<a href="'. get_permalink() .'"><div class="entry-photo'. $thumb_bg .'">'. $img_url .'</div></a>';

			$hide_it = empty( $show_meta ) ? ' hide-this-meta' : ''; 
		?>
		<div class="recipe-title<?php echo $hide_it; ?>">
			<?php echo smk_recipe_is_pending(); ?>
			<a href="<?php the_permalink(); ?>"><?php the_title();?></a>
		</div>
		<div class="recipe-controls<?php echo $hide_it; ?>">
			<?php smk_Like_button( false, array(
				'tag'              => 'a',
				'class'            => 'like-post',
				'content'          => '<i class="fa fa-thumbs-o-up"></i>',
				'content_remove'   => '<i class="fa fa-thumbs-up"></i>',
				'title_format'     => '%text% (%count%)',
				'title'            => __('Like', 'smk_theme'),
				'title_remove'     => __('Dislike', 'smk_theme'),
				'title_not_logged' => __('Please log in to like this post', 'smk_theme'),
			)); ?>
			<?php smk_favorite_button( false, array(
				'tag'              => 'a',
				'class'            => 'favorite-post',
				'content'          => '<i class="fa fa-heart-o"></i>',
				'content_remove'   => '<i class="fa fa-heart"></i>',
				'title_format'     => '%text% (%count%)',
				'title'            => __('Add to favorites', 'smk_theme'),
				'title_remove'     => __('Remove from favorites', 'smk_theme'),
				'title_not_logged' => __('Please log in to add this post to favorites', 'smk_theme'),
			)); ?>
		</div>

	</div>

</div> <!-- .grid-in -->
</div> <!-- .entry -->
<?php 
	if( $number_of_columns == $position ){
		echo '<div class="clear-grid"></div>'; 
	}
?>