<?php 
	$recipe_data = new Smk_Recipe_Data; 
?>

<!-- Entry -->
<div class="recipe-view-def clearfix">
	
	<div class="grid-container">
		
		<div class="entry-photo grid desk-3 mob-6 alpha">
			<?php
				$img_url  = '';
				$thumb_bg = '';
				$is_featured = get_post_meta( get_the_ID(), 'smk_recipe_is_featured', true );

				$featured_badge = ( !empty($is_featured) && 'yes' == $is_featured ) ? '<div class="badge">'. __('Featured', 'smk_theme') .'</div>' : '';
				echo $featured_badge;

				if( has_post_thumbnail() ) {
					$img_url = '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 460, 460, true) .'" alt="' . esc_attr( get_the_title() ) . '" />';
				}
				elseif( ! has_post_thumbnail() ){
					$thumb_bg = ' thumb-bg';
				}

				echo '<a href="'. get_permalink() .'"><div class="entry-photo'. $thumb_bg .'">'. $img_url .'</div></a>';
			?>
			
		</div> <!-- desk-3 -->

		<div class="grid desk-2-5 mob-6 recipe-info-2">
			<div class="recipe-info-2-inner">

					<?php if( ( $prep_time = absint( $recipe_data->preparationTime() ) ) > 0 ){ ?>
					<div class="info preparation">
						<span class="type"><?php _e('Preparation:', 'smk_theme'); ?></span>
						<span class="value"><?php printf( __('%1$d minutes', 'smk_theme'), $prep_time ) ?></span>
					</div>
					<?php 
					} 
					if( $recipe_data->ingredientsCount() ){
					?>
					<div class="info ingredients">
						<span class="type"><?php echo _x('Contains:', 'verb', 'smk_theme'); ?></span>
						<span class="value"><?php printf( __('%1$d ingredients', 'smk_theme'), absint( $recipe_data->ingredientsCount() ) ) ?></span>
					</div>
					<?php 
					}
						$categories = get_the_terms(get_the_ID(), 'recipe_categories');
						if( $categories ){ 
						?>
						<div class="info category">
							<span class="type"><?php _e('Category:', 'smk_theme'); ?></span>
							<?php
								foreach ( $categories as $cat ) {
									echo '<span class="value-category">'. smk_get_recipe_category_link( $cat->slug ) .'</span>';
								}
							?>
						</div>
						<?php
						}

					if( $recipe_data->difficulty() ){
					?>
					<div class="info difficulty moderate">
						<span class="type"><?php _e('Difficulty:', 'smk_theme') ?></span>
						<span class="value"><?php echo $recipe_data->difficultyName(); ?></span>
					</div>
					<?php } ?>
					<div class="clear"></div>
				</div> <!-- .recipe-info -->

		</div> <!-- desk-3 -->

		<div class="grid desk-6-5 omega">
			<div class="recipe-main-info clearfix">
				
				<div class="recipe-info">
					<div class="entry-title">
						<?php echo smk_recipe_is_pending(); ?>
						<h2><a href="<?php the_permalink(); ?>"><?php the_title();?></a></h2>
					</div>
					<div class="entry-controls minimal">

						<?php 
							if( can_show_recipe_rating() ) {
								$rating = new Smk_Recipes_Rating;
								$the_rating = $rating->getPostStars();
								echo '<span class="control-tip">'. $the_rating .'</span>';
							}
						?>
						
						<div class="control"> <i class="fa fa-calendar"></i> </div><span class="control-tip"><?php smk_post_date('j M Y'); ?></span>

						<?php smk_favorite_button( false, array(
							'tag'              => 'a',
							'class'            => 'control entry-to-favorites',
							'content'          => '<i class="fa fa-heart-o"></i>',
							'content_remove'   => '<i class="fa fa-heart"></i>',
							'total_in_title'   => false,
							'modify_content'   => 'next',
							'title'            => __('Add to favorites', 'smk_theme'),
							'title_remove'     => __('Remove from favorites', 'smk_theme'),
							'title_not_logged' => __('Please log in to add this post to favorites', 'smk_theme'),
						)); ?>
						<span class="control-tip"><?php echo smk_get_favorites_count( get_the_ID() ); ?></span>

						<?php smk_like_button( false, array(
							'tag'              => 'a',
							'class'            => 'control entry-like',
							'content'          => '<i class="fa fa-thumbs-o-up"></i>',
							'content_remove'   => '<i class="fa fa-thumbs-up"></i>',
							'total_in_title'   => false,
							'modify_content'   => 'next',
							'title'            => __('Like', 'smk_theme'),
							'title_remove'     => __('Dislike', 'smk_theme'),
							'title_not_logged' => __('Please log in to like this post', 'smk_theme'),
						)); ?>
						<span class="control-tip"><?php echo smk_get_likes_count( get_the_ID() ); ?></span>

						<span class="control entry-comments" title="<?php _e('Comments', 'smk_theme') ?>"> <i class="fa fa-comments"></i> </span> 
						<span class="control-tip"><?php smk_comments_number_link(false); ?></span>
						<?php if( absint( $recipe_data->getViews() ) > 0 && 'on' == smk_recipe_setting( 'ui_enable_favorites', 'on' ) ) : ?>
							<div class="control"> <i class="fa fa-bar-chart"></i> </div> 
							<span class="control-tip"><?php printf( __('%1$s views', 'smk_theme'), absint( $recipe_data->getViews() ) ); ?></span>
						<?php endif; ?>
					</div>
					<div class="entry-content">
						<?php 
							smk_theme_excerpt( 50 ); 
						?>
					</div>
					<div class="entry-info-author">
						<a href="<?php echo get_author_posts_url( get_the_author_meta( 'ID' ) ); ?>">
							<?php echo get_avatar( get_the_author_meta( 'ID' ), 50 ); ?>
						</a>
						<div class="author-name"><?php smk_post_author_link(); ?></div>
						<div class="total-recipes"><?php printf( __('%d recipes', 'smk_theme'), smk_get_total_user_recipes( get_the_author_meta( 'ID' ) ) ); ?></div>
					</div>
				</div> <!-- .recipe-info-2 -->
			</div> <!-- .recipe-main-inf0 -->
			<div class="clear"></div>
		</div> <!-- .desk-6 -->

	</div> <!-- .grid-container -->
	
</div> <!-- .entry -->
<div class="clear"></div>