<?php $recipe_data = new Smk_Recipe_Data; ?>

<!-- Entry -->
<div class="recipe-view-list clearfix">

	<div class="recipe-photo">
		<?php
			$img_url  = '';
			$thumb_bg = '';
			if( has_post_thumbnail() ) {
				$img_url = '<img src="'. smk_theme_resize(smk_theme_post_image_url(), 60, 60, true) .'" alt="' . esc_attr( get_the_title() ) . '" />';
			}
			elseif( ! has_post_thumbnail() ){
				$thumb_bg = ' thumb-bg';
			}

			echo '<a href="'. get_permalink() .'"><div class="entry-photo'. $thumb_bg .'">'. $img_url .'</div></a>';
		?>
		
	</div>

	<div class="recipe-details">
		<?php echo smk_recipe_is_pending(); ?>
		<div class="title"><a href="<?php the_permalink(); ?>"><?php the_title();?></a></div>
		<div class="excerpt">
			<?php 
				if( can_show_recipe_rating() ) {
					$rating = new Smk_Recipes_Rating;
					$the_rating = $rating->getPostStars();
					echo '<span class="control-tip">'. $the_rating .'</span> ';
				}
			?>
			<?php smk_theme_excerpt( 22 ); ?>
		</div>
		<div class="meta">
			<span><?php smk_post_author_link(); ?></span> 
			&bull; <span><?php smk_post_date('j M Y'); ?></span>
			<?php 
				if( absint( $recipe_data->getViews() ) > 0 && 'on' == smk_recipe_setting( 'ui_enable_favorites', 'on' )  ) {
					echo '&bull; <span>';
					printf( __('%1$s views', 'smk_theme'), absint( $recipe_data->getViews() ) );
					echo '</span>';
				} 
			?>
			<?php 
				$categories = get_the_terms(get_the_ID(), 'recipe_categories');
				if( $categories ){ 
					echo '&bull; <span>';
					$cat_list = array();
					foreach ( $categories as $cat ) {
						$cat_list[] = smk_get_recipe_category_link( $cat->slug );
					}
					echo implode(', ', $cat_list);
					echo '</span>';
				}
			?>
		</div>
	</div>

	<div class="recipe-controls">
		<?php smk_Like_button( false, array(
			'tag'              => 'a',
			'class'            => 'like-post',
			'content'          => '<i class="fa fa-thumbs-o-up"></i>',
			'content_remove'   => '<i class="fa fa-thumbs-up"></i>',
			'title_format'     => '%text% (%count%)',
			'title'            => __('Like', 'smk_theme'),
			'title_remove'     => __('Dislike', 'smk_theme'),
			'title_not_logged' => __('Please log in to like this post', 'smk_theme'),
		)); ?>
		<?php smk_favorite_button( false, array(
			'tag'              => 'a',
			'class'            => 'favorite-post',
			'content'          => '<i class="fa fa-heart-o"></i>',
			'content_remove'   => '<i class="fa fa-heart"></i>',
			'title_format'     => '%text% (%count%)',
			'title'            => __('Add to favorites', 'smk_theme'),
			'title_remove'     => __('Remove from favorites', 'smk_theme'),
			'title_not_logged' => __('Please log in to add this post to favorites', 'smk_theme'),
		)); ?>
	</div>


</div> <!-- .entry -->
<div class="clear"></div>