<?php 
$registered_only_can_view_recipes = smk_recipe_setting( 'registered_only_can_view_recipes', 'off' );
?>
<div class="recipe-content">
	
	<?php 
	if( $registered_only_can_view_recipes == 'on' && ! is_user_logged_in() ){
		echo '<div class="notification orange">'. __('Please sign in to view this recipe.', 'smk_theme') .'</div>';
	}
	else{

		$recipe_data = new Smk_Recipe_Data;
		$first = false;
		$ingredients = $recipe_data->ingredients();
		if( !empty( $ingredients ) ) :
			$first = true;
		?>
		<div class="single-recipe-ingredients">
			<h3 class="recipe-headlines ingredients first"><?php _e('Ingredients:', 'smk_theme'); ?></h3>
			<ul>
				<?php 
				$output = '';
				foreach ($ingredients as $ingredient_id => $val) {
					if( empty($val['ingredient']) ) {
						continue;
					}

					$qt      = !empty($val['quantity']) ? esc_attr($val['quantity']) : '';
					$measure = !empty($val['measurement']) ? esc_attr($val['measurement']) : '';
					$notes   = !empty($val['notes']) ? esc_attr($val['notes']) : '';
					
					$output .= '<li>';
						$output .= '<div class="mark-as-ok"><i class="fa fa-check"></i></div>';
						$output .= '<div class="ingredient" itemprop="ingredients">'. esc_attr($val['ingredient']) .'</div>';

							$output .= '<div class="ingredient-quantity">';
								$output .= '<div class="qt">'. $qt .' '. $measure .'</div>';
								if( !empty($notes) ){
									$output .= '<div class="qt-notes">'. $notes .'</div>';
								}
							$output .= '</div>';
					$output .= '</li>';
				}
				echo $output;
				?>
			</ul>
		</div>
		<?php endif; ?>

		<h3 class="recipe-headlines preparation-mode<?php echo ($first === false) ? ' first' : ''; ?>"><?php _e('Preparation mode:', 'smk_theme'); ?></h3>
		<div itemprop="recipeInstructions">
			<?php the_content(); ?>
		</div>

		<?php 
			if( $recipe_data->footnotes() ) : 
		?>
		<h3 class="recipe-headlines footnotes"><?php _e('Footnotes:', 'smk_theme'); ?></h3>
		<?php 
			echo wpautop( $recipe_data->footnotes() ); 
			endif;

		$links = $recipe_data->links();
		if( $links ) :
		?>
		<h3 class="recipe-headlines links"><?php _e('Links:', 'smk_theme'); ?></h3>
		<ul>
			<?php 
				$output = '';
				foreach ($links as $link_id => $val) {
					if( empty($val['url']) ) continue;
					
					$output .= '<li>';
						$output .= '<a href="'. $val['url'] .'" target="_blank">';
							$output .= ( !empty($val['title']) ) ? $val['title'] : $val['url'];
						$output .= '</a>';
					$output .= '</li>';
				}
				echo $output;
			?>
		</ul>
		<?php endif; ?>
	<?php } ?>
</div>