<?php $recipe_data = new Smk_Recipe_Data; ?>
<div class="recipe-meta">
	<ul>
		<li>
			<div class="entry-info-author">
				<?php echo '<a href="'. get_author_posts_url( get_the_author_meta( 'ID' ) ) .'">' . get_avatar( get_the_author_meta( 'ID' ), 50 ) .'</a>'; ?>
				<div class="author-name">
					<?php smk_post_author_link(); ?>
				</div>
				<div>
				<?php 
				$follow = new Smk_Theme_User_Follow;
				echo $follow->button( get_the_author_meta( 'ID' ), array(
					'btn_class' => array(
						'default' => 'button mini blue',
						'active' => 'button mini green active current',
					)
				)); ?>
				</div>
			</div>
		</li>
		<li>
			<i class="the-icon fa fa-calendar" title="<?php printf(__('Submited on %1$s', 'smk_theme'), smk_post_date(false, false)); ?>"></i> 
			<span itemprop="datePublished" content="<?php smk_post_date('Y-m-j'); ?>"><?php smk_post_date('j M Y'); ?></span>
		</li>
		<?php 
			if( $recipe_data->difficulty() ){
				echo '<li><div><i class="the-icon fa fa-tasks" title='. __('Difficulty', 'smk_theme') .'></i> <span>'. $recipe_data->difficultyName() .'</span></div></li>';
			}

			if( ( $prep_time = absint( $recipe_data->preparationTime() ) ) > 0 ){
				echo '<li itemprop="totalTime" content="PT'. $prep_time .'M">
				<div><i class="the-icon fa fa-clock-o" title="'. __('Preparation time', 'smk_theme') .'"></i> <span>' . 
				$prep_time .' '. __('minutes', 'smk_theme') . 
				'</span></div>
				</li>';
			}
		?>
		<?php 
			$views_on = smk_recipe_setting( 'ui_enable_favorites', 'on' );

			if( absint( $recipe_data->getViews() ) > 0 && $views_on == 'on' ) : ?>
			<li>
				<i class="the-icon fa fa-eye" title="<?php printf( __('This recipe has been visited for %1$s times', 'smk_theme'), absint( $recipe_data->getViews() ) ); ?>"></i> 
				<span><?php printf( __('%1$s views', 'smk_theme'), absint( $recipe_data->getViews() ) ); ?></span>
			</li>
		<?php endif; ?>
		<?php if( smk_favorites_enabled() ) : ?>
		<li><div><i class="the-icon fa fa-heart" title="<?php printf( __('Favorited by %1$d users', 'smk_theme'), smk_get_favorites_count() ) ?>"></i> <span><?php printf( __('%1$d favorites', 'smk_theme'), smk_get_favorites_count()); ?></span></div></li>
		<?php 
			endif;

			if( smk_likes_enabled() ) :
		?>
		<li><div><i class="the-icon fa fa-thumbs-up" title="<?php printf( __('%1$d like this', 'smk_theme'), smk_get_likes_count() ) ?>"></i> <span><?php printf( __('%1$d likes', 'smk_theme'), smk_get_likes_count() ) ?></span></div></li>
		
		<?php endif; 
			if( can_show_recipe_rating() ) : 
		?>
		<li><div><i class="the-icon fa fa-bar-chart" title="<?php _e('Rating', 'smk_theme'); ?>"></i> <span><?php 
			$rating = new Smk_Recipes_Rating;
			echo $rating->getPostStars()
		?></span></div></li>
		<?php endif; ?>

	</ul>
</div>
